#pragma once
/* this file was auto-generated from ./src/modules/flow/mqtt/mqtt.json */
#include <stdbool.h>
#include <stdint.h>
#include <sol-flow.h>


#ifdef __cplusplus
extern "C" {
#endif

#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT_DEFINED 1
extern const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_MQTT_CLIENT;

struct sol_flow_node_type_mqtt_client_options {
    struct sol_flow_node_options base;
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT_OPTIONS_API_VERSION (1)
    const char * host; /**< Configure the address of the MQTT Broker (default: '') */
    int32_t port; /**< Configure the port of the MQTT Broker (default: 1883) */
    const char * username; /**< Username for authenticating the connection (required) */
    const char * password; /**< Password for authenticating the connection (required) */
    const char * client_id; /**< MQTT client ID. Must be valid if {clean_session} is not set (required) */
    int32_t keepalive; /**< Time in milliseconds between PING messages from the Broker to the client (default: 60000) */
    bool clean_session; /**< If set, start a new session in the broker. Restore previous session otherwise. Must be set if {client_id} isn't provided (default: True) */
    int32_t qos; /**< QoS for the MQTT messages sent. 0: AT_MOST_ONCE, 1: AT_LEST_ONCE, 2: EXACTLY_ONCE (default: 0) */
    const char * ca_cert; /**< CA Certificate for TLS connection (required) */
    const char * client_cert; /**< Client Certificate for TLS connection (required) */
    const char * private_key; /**< Private key for TLS connection (required) */
    const char * topic; /**< Configure the Topic to send messages to / subscribe to (required) */
};

#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT_OPTIONS_DEFAULTS(...) { \
    .base = { \
        SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_OPTIONS_API_VERSION, ) \
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_MQTT_CLIENT_OPTIONS_API_VERSION) \
    }, \
    .host = "", \
    .port = 1883, \
    .username = NULL, \
    .password = NULL, \
    .client_id = NULL, \
    .keepalive = 60000, \
    .clean_session = true, \
    .qos = 0, \
    .ca_cert = NULL, \
    .client_cert = NULL, \
    .private_key = NULL, \
    __VA_ARGS__ \
}
/* Input Ports */
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__PUBLISH (0)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__SUBSCRIBE (1)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__HOST (2)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__PORT (3)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__USER (4)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__PASS (5)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__ID (6)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__KEEPALIVE (7)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__CLEAN (8)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__QOS (9)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__TOPIC (10)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN__DATA (11)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__IN_LAST (11)

/* Output Ports */
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__OUT__OUTDATA (0)
#define SOL_FLOW_NODE_TYPE_MQTT_CLIENT__OUT_LAST (0)

#ifndef SOL_LOG_DOMAIN
#define SOL_LOG_DOMAIN &_log_domain
#include "sol-log.h"

#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_DECLARE(_var, _name)     SOL_ATTR_UNUSED struct sol_log_domain _var = {         .name = "sol-" _name,         .color = SOL_LOG_COLOR_MAGENTA,         .level = SOL_LOG_LEVEL_WARNING     }

#define SOL_LOG_INTERNAL_DECLARE_STATIC(_var, _name)     static SOL_LOG_INTERNAL_DECLARE(_var, _name)

SOL_LOG_INTERNAL_DECLARE_STATIC(_log_domain, "flow-mqtt");

#else // #ifdef SOL_LOG_ENABLED

#define SOL_LOG_INTERNAL_DECLARE(_var, _name)
#define SOL_LOG_INTERNAL_DECLARE_STATIC(_var, _name)

#ifdef SOL_LOG_DOMAIN
#undef SOL_LOG_DOMAIN
#define SOL_LOG_DOMAIN NULL
#endif // #ifdef SOL_LOG_DOMAIN

#endif // #ifdef SOL_LOG_ENABLED
#endif // ifndef SOL_LOG_DOMAIN

#ifdef __cplusplus
}
#endif
