/* this file was auto-generated from ./src/modules/flow/am2315/am2315.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_AM2315_DEFINED
#include "sol-flow/am2315.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_am2315_thermometer__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = temperature_am2315_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_am2315_thermometer__out__KELVIN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_am2315_thermometer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_am2315_thermometer__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_am2315_thermometer_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_am2315_thermometer__out__KELVIN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_am2315_thermometer_init_type_internal(void)
{
    if (sol_flow_node_type_am2315_thermometer__in__TICK.packet_type == NULL) {
        sol_flow_node_type_am2315_thermometer__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_am2315_thermometer__out__KELVIN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_am2315_thermometer_options sol_flow_node_type_am2315_thermometer_options_defaults = SOL_FLOW_NODE_TYPE_AM2315_THERMOMETER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_am2315_thermometer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "am2315/thermometer",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_AM2315_THERMOMETER",
    .options_symbol = "sol_flow_node_type_am2315_thermometer_options",
    .description = "Gets AM2315 sensor temperature in Kelvin. This device also reads humidity, check for its node",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/am2315/thermometer.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a temperature reading and produce packets on each of the the output ports. Note that AM2315 needs a 2 seconds interval between readings - any ticks sent before such interval will output data only at the end of the interval.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "KELVIN",
            .description="Measured temperature in Kelvin.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_am2315_thermometer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_AM2315_THERMOMETER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="i2c_bus",
            .description="I2C bus number",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_am2315_thermometer_options, i2c_bus),
            .size=sizeof(int32_t),
        },
        {
            .name="i2c_slave",
            .description="I2C bus slave on which the sensor answers.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_am2315_thermometer_options, i2c_slave),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=92,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_am2315_thermometer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct am2315_data),
    .options_size = sizeof(struct sol_flow_node_type_am2315_thermometer_options),
    .default_options = &sol_flow_node_type_am2315_thermometer_options_defaults,
    .init_type = sol_flow_node_type_am2315_thermometer_init_type_internal,
    .open = temperature_am2315_open,
    .close = temperature_am2315_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_am2315_thermometer_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_am2315_thermometer_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_am2315_thermometer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_AM2315_THERMOMETER = &sol_flow_node_type_am2315_thermometer;

static struct sol_flow_port_type_in sol_flow_node_type_am2315_humidity__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = humidity_am2315_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_am2315_humidity__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_am2315_humidity_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_am2315_humidity__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_am2315_humidity_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_am2315_humidity__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_am2315_humidity_init_type_internal(void)
{
    if (sol_flow_node_type_am2315_humidity__in__TICK.packet_type == NULL) {
        sol_flow_node_type_am2315_humidity__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_am2315_humidity__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_am2315_humidity_options sol_flow_node_type_am2315_humidity_options_defaults = SOL_FLOW_NODE_TYPE_AM2315_HUMIDITY_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_am2315_humidity_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "am2315/humidity",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_AM2315_HUMIDITY",
    .options_symbol = "sol_flow_node_type_am2315_humidity_options",
    .description = "Gets AM2315 sensor relative humidity in percentage. This device also reads temperature, check for its node",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/am2315/humidity.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a humidity reading and produce packets on the output ports. Note that AM2315 needs a 2 seconds interval between readings - any ticks sent before such interval will output data only at the end of the interval.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Measured relative humidity in percentage.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_am2315_humidity_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_AM2315_HUMIDITY_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="i2c_bus",
            .description="I2C bus number",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_am2315_humidity_options, i2c_bus),
            .size=sizeof(int32_t),
        },
        {
            .name="i2c_slave",
            .description="I2C bus slave on which the sensor answers.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_am2315_humidity_options, i2c_slave),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=92,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_am2315_humidity = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct am2315_data),
    .options_size = sizeof(struct sol_flow_node_type_am2315_humidity_options),
    .default_options = &sol_flow_node_type_am2315_humidity_options_defaults,
    .init_type = sol_flow_node_type_am2315_humidity_init_type_internal,
    .open = humidity_am2315_open,
    .close = humidity_am2315_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_am2315_humidity_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_am2315_humidity_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_am2315_humidity_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_AM2315_HUMIDITY = &sol_flow_node_type_am2315_humidity;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_am2315(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_am2315(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_AM2315_THERMOMETER,
            &SOL_FLOW_NODE_TYPE_AM2315_HUMIDITY,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
