/* this file was auto-generated from ./src/modules/flow/calamari/calamari.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_CALAMARI_DEFINED
#include "sol-flow/calamari.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_calamari_led__in__INTENSITY = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = calamari_led_process_intensity,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_calamari_led_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_calamari_led__in__INTENSITY;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_calamari_led_init_type_internal(void)
{
    if (sol_flow_node_type_calamari_led__in__INTENSITY.packet_type == NULL) {
        sol_flow_node_type_calamari_led__in__INTENSITY.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_calamari_led_options sol_flow_node_type_calamari_led_options_defaults = SOL_FLOW_NODE_TYPE_CALAMARI_LED_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_calamari_led_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "calamari/led",
    .category = "output/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_CALAMARI_LED",
    .options_symbol = "sol_flow_node_type_calamari_led_options",
    .description = "Calamari PWM Led Output",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/calamari_led.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "INTENSITY",
            .description="Set PWM led intensity",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_calamari_led_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_CALAMARI_LED_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="period",
            .description="PWM period",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_calamari_led_options, period),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=10000,
            },
        },
        {
            .name="range",
            .description="Range for PWM output.",
            .data_type="irange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_calamari_led_options, range),
            .size=sizeof(struct sol_irange_spec),
            .defvalue = {
                .irange_spec={.max=10000, .min=0, .step=1},
            },
        },
        {
            .name="address",
            .description="Hardware address of the PWN output",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_calamari_led_options, address),
            .size=sizeof(int32_t),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_calamari_led = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct calamari_led_data),
    .options_size = sizeof(struct sol_flow_node_type_calamari_led_options),
    .default_options = &sol_flow_node_type_calamari_led_options_defaults,
    .init_type = sol_flow_node_type_calamari_led_init_type_internal,
    .open = calamari_led_open,
    .close = calamari_led_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_calamari_led_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_calamari_led_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_CALAMARI_LED = &sol_flow_node_type_calamari_led;

static struct sol_flow_port_type_in sol_flow_node_type_calamari_lever__in__POLL_SIGNAL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = calamari_lever_process_poll,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_calamari_lever__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_calamari_lever_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_calamari_lever__in__POLL_SIGNAL;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_calamari_lever_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_calamari_lever__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_calamari_lever_init_type_internal(void)
{
    if (sol_flow_node_type_calamari_lever__in__POLL_SIGNAL.packet_type == NULL) {
        sol_flow_node_type_calamari_lever__in__POLL_SIGNAL.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_calamari_lever__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_calamari_lever_options sol_flow_node_type_calamari_lever_options_defaults = SOL_FLOW_NODE_TYPE_CALAMARI_LEVER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_calamari_lever_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "calamari/lever",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_CALAMARI_LEVER",
    .options_symbol = "sol_flow_node_type_calamari_lever_options",
    .description = "SPI Lever in Calamari lure",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/calamari_lever.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "POLL_SIGNAL",
            .description="Signal the SPI chip that a read must be performed",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Current value queried from SPI chip",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_calamari_lever_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_CALAMARI_LEVER_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="poll_interval",
            .description="Intervel between polling the SPI chip in the lure.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_calamari_lever_options, poll_interval),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="range",
            .description="The range value. Used to convert the output.",
            .data_type="irange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_calamari_lever_options, range),
            .size=sizeof(struct sol_irange_spec),
            .defvalue = {
                .irange_spec={.max=1023, .min=0, .step=1},
            },
        },
        {
            .name="bus",
            .description="SPI bus.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_calamari_lever_options, bus),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="chip_select",
            .description="SPI chip select.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_calamari_lever_options, chip_select),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_calamari_lever = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct calamari_lever_data),
    .options_size = sizeof(struct sol_flow_node_type_calamari_lever_options),
    .default_options = &sol_flow_node_type_calamari_lever_options_defaults,
    .init_type = sol_flow_node_type_calamari_lever_init_type_internal,
    .open = calamari_lever_open,
    .close = calamari_lever_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_calamari_lever_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_calamari_lever_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_calamari_lever_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_CALAMARI_LEVER = &sol_flow_node_type_calamari_lever;

static struct sol_flow_port_type_in sol_flow_node_type_calamari_rgb_ctl__in__RED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = calamari_rgb_led_process_red,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_calamari_rgb_ctl__in__GREEN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = calamari_rgb_led_process_green,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_calamari_rgb_ctl__in__BLUE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = calamari_rgb_led_process_blue,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_calamari_rgb_ctl__out__RED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_calamari_rgb_ctl__out__GREEN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_calamari_rgb_ctl__out__BLUE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_calamari_rgb_ctl_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_calamari_rgb_ctl__in__RED;
    if (port < 2)
        return &sol_flow_node_type_calamari_rgb_ctl__in__GREEN;
    if (port < 3)
        return &sol_flow_node_type_calamari_rgb_ctl__in__BLUE;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_calamari_rgb_ctl_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_calamari_rgb_ctl__out__RED;
    if (port < 2)
        return &sol_flow_node_type_calamari_rgb_ctl__out__GREEN;
    if (port < 3)
        return &sol_flow_node_type_calamari_rgb_ctl__out__BLUE;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_calamari_rgb_ctl_init_type_internal(void)
{
    if (sol_flow_node_type_calamari_rgb_ctl__in__RED.packet_type == NULL) {
        sol_flow_node_type_calamari_rgb_ctl__in__RED.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_calamari_rgb_ctl__in__GREEN.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_calamari_rgb_ctl__in__BLUE.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_calamari_rgb_ctl__out__RED.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_calamari_rgb_ctl__out__GREEN.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_calamari_rgb_ctl__out__BLUE.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_calamari_rgb_ctl_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "calamari/rgb-ctl",
    .category = "internal",
    .symbol = "SOL_FLOW_NODE_TYPE_CALAMARI_RGB_CTL",
    .options_symbol = "sol_flow_node_type_calamari_rgb_ctl_options",
    .description = "RGB led control for calamari lure",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "RED",
            .description="Turn red led ON/OFF",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=true,
        }),
            &((const struct sol_flow_port_description){
            .name = "GREEN",
            .description="Turn green led ON/OFF",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=1,
            .required=true,
        }),
            &((const struct sol_flow_port_description){
            .name = "BLUE",
            .description="Turn blue led ON/OFF",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=2,
            .required=true,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "RED",
            .description="Control GPIO pin responsible for turning red led ON/OFF",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "GREEN",
            .description="Control GPIO pin responsible for turning green led ON/OFF",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "BLUE",
            .description="Control GPIO pin responsible for turning blue led ON/OFF",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_calamari_rgb_ctl = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_calamari_rgb_ctl_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_calamari_rgb_ctl_get_port_in_internal,
    .ports_out_count = 3,
    .get_port_out = sol_flow_node_type_calamari_rgb_ctl_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_calamari_rgb_ctl_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_CALAMARI_RGB_CTL = &sol_flow_node_type_calamari_rgb_ctl;

static struct sol_flow_port_type_in sol_flow_node_type_calamari_segments_ctl__in__SEGMENTS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = segments_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_calamari_segments_ctl__in__VALUE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = value_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_calamari_segments_ctl__out__CLEAR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_calamari_segments_ctl__out__LATCH = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_calamari_segments_ctl__out__CLOCK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_calamari_segments_ctl__out__DATA = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_calamari_segments_ctl_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_calamari_segments_ctl__in__SEGMENTS;
    if (port < 2)
        return &sol_flow_node_type_calamari_segments_ctl__in__VALUE;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_calamari_segments_ctl_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_calamari_segments_ctl__out__CLEAR;
    if (port < 2)
        return &sol_flow_node_type_calamari_segments_ctl__out__LATCH;
    if (port < 3)
        return &sol_flow_node_type_calamari_segments_ctl__out__CLOCK;
    if (port < 4)
        return &sol_flow_node_type_calamari_segments_ctl__out__DATA;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_calamari_segments_ctl_init_type_internal(void)
{
    if (sol_flow_node_type_calamari_segments_ctl__in__SEGMENTS.packet_type == NULL) {
        sol_flow_node_type_calamari_segments_ctl__in__SEGMENTS.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
        sol_flow_node_type_calamari_segments_ctl__in__VALUE.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_calamari_segments_ctl__out__CLEAR.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_calamari_segments_ctl__out__LATCH.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_calamari_segments_ctl__out__CLOCK.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_calamari_segments_ctl__out__DATA.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_calamari_segments_ctl_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "calamari/segments-ctl",
    .category = "internal",
    .symbol = "SOL_FLOW_NODE_TYPE_CALAMARI_SEGMENTS_CTL",
    .options_symbol = "sol_flow_node_type_calamari_segments_ctl_options",
    .description = "",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "SEGMENTS",
            .description="Define segments to be on and off. The order expected by the display for each bit is 'abcdefgX', where X is the DP, as described in http://en.wikipedia.org/wiki/Seven-segment_display_character_representations.",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "VALUE",
            .description="Set value to be displayed.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "CLEAR",
            .description="",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "LATCH",
            .description="",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "CLOCK",
            .description="",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "DATA",
            .description="",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_calamari_segments_ctl = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct segments_ctl_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_calamari_segments_ctl_init_type_internal,
    .open = segments_ctl_open,
    .close = segments_ctl_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_calamari_segments_ctl_get_port_in_internal,
    .ports_out_count = 4,
    .get_port_out = sol_flow_node_type_calamari_segments_ctl_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_calamari_segments_ctl_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_CALAMARI_SEGMENTS_CTL = &sol_flow_node_type_calamari_segments_ctl;

static struct sol_flow_port_type_in sol_flow_node_type_calamari_7seg__in__SEGMENTS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = segments_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_calamari_7seg__in__VALUE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = value_set,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_calamari_7seg_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_calamari_7seg__in__SEGMENTS;
    if (port < 2)
        return &sol_flow_node_type_calamari_7seg__in__VALUE;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_calamari_7seg_init_type_internal(void)
{
    if (sol_flow_node_type_calamari_7seg__in__SEGMENTS.packet_type == NULL) {
        sol_flow_node_type_calamari_7seg__in__SEGMENTS.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
        sol_flow_node_type_calamari_7seg__in__VALUE.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }
    segments_init_type();

    log_init();
}

static const struct sol_flow_node_type_calamari_7seg_options sol_flow_node_type_calamari_7seg_options_defaults = SOL_FLOW_NODE_TYPE_CALAMARI_7SEG_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_calamari_7seg_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "calamari/7seg",
    .category = "output/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_CALAMARI_7SEG",
    .options_symbol = "sol_flow_node_type_calamari_7seg_options",
    .description = "Receives packages with values to be displayed on Calamari's 7 segments display",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/calamari-7seg.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "SEGMENTS",
            .description="Define segments to be on and off. The order expected by the display for each bit is 'abcdefgX', where X is the DP, as described in http://en.wikipedia.org/wiki/Seven-segment_display_character_representations.",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "VALUE",
            .description="Set value to be displayed.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_calamari_7seg_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_CALAMARI_7SEG_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="clock_pin",
            .description="CLOCK GPIO pin",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_calamari_7seg_options, clock_pin),
            .size=sizeof(const char *),
        },
        {
            .name="clear_pin",
            .description="CLEAR GPIO pin",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_calamari_7seg_options, clear_pin),
            .size=sizeof(const char *),
        },
        {
            .name="data_pin",
            .description="DATA GPIO pin",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_calamari_7seg_options, data_pin),
            .size=sizeof(const char *),
        },
        {
            .name="latch_pin",
            .description="LATCH GPIO pin",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_calamari_7seg_options, latch_pin),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_calamari_7seg = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_type_calamari_7seg_options),
    .default_options = &sol_flow_node_type_calamari_7seg_options_defaults,
    .init_type = sol_flow_node_type_calamari_7seg_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_calamari_7seg_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_calamari_7seg_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_CALAMARI_7SEG = &sol_flow_node_type_calamari_7seg;

static struct sol_flow_port_type_in sol_flow_node_type_calamari_rgb_led__in__RED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = calamari_rgb_led_process_red,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_calamari_rgb_led__in__GREEN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = calamari_rgb_led_process_green,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_calamari_rgb_led__in__BLUE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = calamari_rgb_led_process_blue,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_calamari_rgb_led_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_calamari_rgb_led__in__RED;
    if (port < 2)
        return &sol_flow_node_type_calamari_rgb_led__in__GREEN;
    if (port < 3)
        return &sol_flow_node_type_calamari_rgb_led__in__BLUE;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_calamari_rgb_led_init_type_internal(void)
{
    if (sol_flow_node_type_calamari_rgb_led__in__RED.packet_type == NULL) {
        sol_flow_node_type_calamari_rgb_led__in__RED.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_calamari_rgb_led__in__GREEN.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_calamari_rgb_led__in__BLUE.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }
    rgb_led_init_type();

    log_init();
}

static const struct sol_flow_node_type_calamari_rgb_led_options sol_flow_node_type_calamari_rgb_led_options_defaults = SOL_FLOW_NODE_TYPE_CALAMARI_RGB_LED_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_calamari_rgb_led_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "calamari/rgb-led",
    .category = "output/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_CALAMARI_RGB_LED",
    .options_symbol = "sol_flow_node_type_calamari_rgb_led_options",
    .description = "Receives packets indicating the color of Calamari's RGB LED",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/calamari_rgb_led.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "RED",
            .description="Turn red led ON/OFF",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=true,
        }),
            &((const struct sol_flow_port_description){
            .name = "GREEN",
            .description="Turn green led ON/OFF",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=1,
            .required=true,
        }),
            &((const struct sol_flow_port_description){
            .name = "BLUE",
            .description="Turn blue led ON/OFF",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=2,
            .required=true,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_calamari_rgb_led_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_CALAMARI_RGB_LED_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="red_pin",
            .description="Red LED GPIO pin",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_calamari_rgb_led_options, red_pin),
            .size=sizeof(const char *),
        },
        {
            .name="green_pin",
            .description="Green LED GPIO pin",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_calamari_rgb_led_options, green_pin),
            .size=sizeof(const char *),
        },
        {
            .name="blue_pin",
            .description="Blue LED GPIO pin",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_calamari_rgb_led_options, blue_pin),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_calamari_rgb_led = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_type_calamari_rgb_led_options),
    .default_options = &sol_flow_node_type_calamari_rgb_led_options_defaults,
    .init_type = sol_flow_node_type_calamari_rgb_led_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_calamari_rgb_led_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_calamari_rgb_led_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_CALAMARI_RGB_LED = &sol_flow_node_type_calamari_rgb_led;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_calamari(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_calamari(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_CALAMARI_LED,
            &SOL_FLOW_NODE_TYPE_CALAMARI_LEVER,
            &SOL_FLOW_NODE_TYPE_CALAMARI_RGB_CTL,
            &SOL_FLOW_NODE_TYPE_CALAMARI_SEGMENTS_CTL,
            &SOL_FLOW_NODE_TYPE_CALAMARI_7SEG,
            &SOL_FLOW_NODE_TYPE_CALAMARI_RGB_LED,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
