/* this file was auto-generated from ./src/modules/flow/compass/compass.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_COMPASS_DEFINED
#include "sol-flow/compass.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_compass_accelerometer_magnetometer__in__ACCELEROMETER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = compass_accel_open,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_compass_accelerometer_magnetometer__in__MAGNETOMETER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = compass_mag_open,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_compass_accelerometer_magnetometer__out__VECTOR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_compass_accelerometer_magnetometer__out__HEADING = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_compass_accelerometer_magnetometer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_compass_accelerometer_magnetometer__in__ACCELEROMETER;
    if (port < 2)
        return &sol_flow_node_type_compass_accelerometer_magnetometer__in__MAGNETOMETER;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_compass_accelerometer_magnetometer_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_compass_accelerometer_magnetometer__out__VECTOR;
    if (port < 2)
        return &sol_flow_node_type_compass_accelerometer_magnetometer__out__HEADING;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_compass_accelerometer_magnetometer_init_type_internal(void)
{
    if (sol_flow_node_type_compass_accelerometer_magnetometer__in__ACCELEROMETER.packet_type == NULL) {
        sol_flow_node_type_compass_accelerometer_magnetometer__in__ACCELEROMETER.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
        sol_flow_node_type_compass_accelerometer_magnetometer__in__MAGNETOMETER.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
        sol_flow_node_type_compass_accelerometer_magnetometer__out__VECTOR.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
        sol_flow_node_type_compass_accelerometer_magnetometer__out__HEADING.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_compass_accelerometer_magnetometer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "compass/accelerometer-magnetometer",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_COMPASS_ACCELEROMETER_MAGNETOMETER",
    .options_symbol = "sol_flow_node_type_compass_accelerometer_magnetometer_options",
    .description = "Generic compass that takes direction-vectors of an accelerometer and a magnetometer and outputs heading towards Magnetic North Pole, in degrees.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "ACCELEROMETER",
            .description="Accelerometer readings.",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=true,
        }),
            &((const struct sol_flow_port_description){
            .name = "MAGNETOMETER",
            .description="Magnetometer readings.",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=1,
            .required=true,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "VECTOR",
            .description="Heading relative to Magnetic North Pole.",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "HEADING",
            .description="Heading relative to Magnetic North Pole, in degrees.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_compass_accelerometer_magnetometer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct compass_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_compass_accelerometer_magnetometer_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_compass_accelerometer_magnetometer_get_port_in_internal,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_compass_accelerometer_magnetometer_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_compass_accelerometer_magnetometer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_COMPASS_ACCELEROMETER_MAGNETOMETER = &sol_flow_node_type_compass_accelerometer_magnetometer;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_compass(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_compass(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_COMPASS_ACCELEROMETER_MAGNETOMETER,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
