/* this file was auto-generated from ./src/modules/flow/evdev/evdev.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_EVDEV_DEFINED
#include "sol-flow/evdev.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_out sol_flow_node_type_evdev_boolean__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_evdev_boolean_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_evdev_boolean__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_evdev_boolean_init_type_internal(void)
{
    if (sol_flow_node_type_evdev_boolean__out__OUT.packet_type == NULL) {
        sol_flow_node_type_evdev_boolean__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_evdev_boolean_options sol_flow_node_type_evdev_boolean_options_defaults = SOL_FLOW_NODE_TYPE_EVDEV_BOOLEAN_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_evdev_boolean_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "evdev/boolean",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_EVDEV_BOOLEAN",
    .options_symbol = "sol_flow_node_type_evdev_boolean_options",
    .description = "Provides a boolean packet after an evdev event",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/evdev.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="An evdev event happened",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_evdev_boolean_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_EVDEV_BOOLEAN_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="ev_code",
            .description="The event code to be monitored",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_evdev_boolean_options, ev_code),
            .size=sizeof(int32_t),
        },
        {
            .name="path",
            .description="The event path to be monitored",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_evdev_boolean_options, path),
            .size=sizeof(const char *),
        },
        {
            .name="on_press",
            .description="The event is triggered on press",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_evdev_boolean_options, on_press),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="on_release",
            .description="The event is triggered on release",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_evdev_boolean_options, on_release),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_evdev_boolean = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct evdev_data),
    .options_size = sizeof(struct sol_flow_node_type_evdev_boolean_options),
    .default_options = &sol_flow_node_type_evdev_boolean_options_defaults,
    .init_type = sol_flow_node_type_evdev_boolean_init_type_internal,
    .open = evdev_open,
    .close = evdev_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_evdev_boolean_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_evdev_boolean_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_EVDEV_BOOLEAN = &sol_flow_node_type_evdev_boolean;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_evdev(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_evdev(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_EVDEV_BOOLEAN,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
