/* this file was auto-generated from ./src/modules/flow/file/file.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_FILE_DEFINED
#include "sol-flow/file.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_file_reader__in__PATH = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = file_reader_path_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_file_reader__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_file_reader_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_file_reader__in__PATH;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_file_reader_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_file_reader__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_file_reader_init_type_internal(void)
{
    if (sol_flow_node_type_file_reader__in__PATH.packet_type == NULL) {
        sol_flow_node_type_file_reader__in__PATH.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_file_reader__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
    }

    log_init();
}

static const struct sol_flow_node_type_file_reader_options sol_flow_node_type_file_reader_options_defaults = SOL_FLOW_NODE_TYPE_FILE_READER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_file_reader_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "file/reader",
    .category = "input/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_FILE_READER",
    .options_symbol = "sol_flow_node_type_file_reader_options",
    .description = "Reads a file from disk and dispatches on output port as a blob",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/file_reader.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "PATH",
            .description="A string containing the file path.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="A blob containing the file contents and its size.",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_file_reader_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_FILE_READER_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="path",
            .description="file name to read.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_file_reader_options, path),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_file_reader = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct file_reader_data),
    .options_size = sizeof(struct sol_flow_node_type_file_reader_options),
    .default_options = &sol_flow_node_type_file_reader_options_defaults,
    .init_type = sol_flow_node_type_file_reader_init_type_internal,
    .open = file_reader_open,
    .close = file_reader_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_file_reader_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_file_reader_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_file_reader_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_FILE_READER = &sol_flow_node_type_file_reader;

static struct sol_flow_port_type_in sol_flow_node_type_file_writer__in__PATH = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = file_writer_path_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_file_writer__in__PERMISSIONS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = file_writer_permissions_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_file_writer__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = file_writer_contents_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_file_writer__out__BUSY = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_file_writer__out__SIZE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_file_writer__out__DONE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_file_writer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_file_writer__in__PATH;
    if (port < 2)
        return &sol_flow_node_type_file_writer__in__PERMISSIONS;
    if (port < 3)
        return &sol_flow_node_type_file_writer__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_file_writer_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_file_writer__out__BUSY;
    if (port < 2)
        return &sol_flow_node_type_file_writer__out__SIZE;
    if (port < 3)
        return &sol_flow_node_type_file_writer__out__DONE;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_file_writer_init_type_internal(void)
{
    if (sol_flow_node_type_file_writer__in__PATH.packet_type == NULL) {
        sol_flow_node_type_file_writer__in__PATH.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_file_writer__in__PERMISSIONS.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_file_writer__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
        sol_flow_node_type_file_writer__out__BUSY.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_file_writer__out__SIZE.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_file_writer__out__DONE.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_file_writer_options sol_flow_node_type_file_writer_options_defaults = SOL_FLOW_NODE_TYPE_FILE_WRITER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_file_writer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "file/writer",
    .category = "input/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_FILE_WRITER",
    .options_symbol = "sol_flow_node_type_file_writer_options",
    .description = "Writes a file to disk",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/file_writer.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "PATH",
            .description="A string containing the file path.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PERMISSIONS",
            .description="file permissions in POSIX mode such as 0644.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="A blob containing the file contents.",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "BUSY",
            .description="True if it's busy writing the file to disk.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "SIZE",
            .description="Bytes already written to disk.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "DONE",
            .description="Total bytes to write to disk.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_file_writer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_FILE_WRITER_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="path",
            .description="file name to write.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_file_writer_options, path),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="permissions",
            .description="file permissions in POSIX mode such as 0644.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_file_writer_options, permissions),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=420,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_file_writer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct file_writer_data),
    .options_size = sizeof(struct sol_flow_node_type_file_writer_options),
    .default_options = &sol_flow_node_type_file_writer_options_defaults,
    .init_type = sol_flow_node_type_file_writer_init_type_internal,
    .open = file_writer_open,
    .close = file_writer_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_file_writer_get_port_in_internal,
    .ports_out_count = 3,
    .get_port_out = sol_flow_node_type_file_writer_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_file_writer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_FILE_WRITER = &sol_flow_node_type_file_writer;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_file(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_file(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_FILE_READER,
            &SOL_FLOW_NODE_TYPE_FILE_WRITER,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
