/* this file was auto-generated from ./src/modules/flow/flower-power/flower-power.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_FLOWER_POWER_DEFINED
#include "sol-flow/flower-power.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_flower_power_http_get__in__GET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = http_get_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_flower_power_http_get__in__USERNAME = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = http_set_username,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_flower_power_http_get__in__PASSWORD = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = http_set_password,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_http_get__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_http_get__out__DEVICE_INFO = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_flower_power_http_get_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_flower_power_http_get__in__GET;
    if (port < 2)
        return &sol_flow_node_type_flower_power_http_get__in__USERNAME;
    if (port < 3)
        return &sol_flow_node_type_flower_power_http_get__in__PASSWORD;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_flower_power_http_get_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_flower_power_http_get__out__OUT;
    if (port < 2)
        return &sol_flow_node_type_flower_power_http_get__out__DEVICE_INFO;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_flower_power_http_get_init_type_internal(void)
{
    if (sol_flow_node_type_flower_power_http_get__in__GET.packet_type == NULL) {
        sol_flow_node_type_flower_power_http_get__in__GET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_flower_power_http_get__in__USERNAME.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_flower_power_http_get__in__PASSWORD.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_flower_power_http_get__out__OUT.packet_type = PACKET_TYPE_FLOWER_POWER;
        sol_flow_node_type_flower_power_http_get__out__DEVICE_INFO.packet_type = PACKET_TYPE_FLOWER_POWER_SENSOR;
    }

    log_init();
}

static const struct sol_flow_node_type_flower_power_http_get_options sol_flow_node_type_flower_power_http_get_options_defaults = SOL_FLOW_NODE_TYPE_FLOWER_POWER_HTTP_GET_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_flower_power_http_get_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "flower-power/http-get",
    .category = "iot/cloud",
    .symbol = "SOL_FLOW_NODE_TYPE_FLOWER_POWER_HTTP_GET",
    .options_symbol = "sol_flow_node_type_flower_power_http_get_options",
    .description = "Fetch plants Flower-Power data via HTTP",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/flower-power/http-get.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "GET",
            .description="Fetch plants data via HTTP. Username and password must be provided before otherwise an error packet will be sent.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=true,
        }),
            &((const struct sol_flow_port_description){
            .name = "USERNAME",
            .description="Username to be used to get plants information. It must be previously registered at Parrot site or app.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=true,
        }),
            &((const struct sol_flow_port_description){
            .name = "PASSWORD",
            .description="Password for username to be used to get plants information.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=2,
            .required=true,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Packet with measures (sunlight, temperature, soil moisture and fertilizer) and thresholds related to a plant.",
            .data_type="custom:PACKET_TYPE_FLOWER_POWER",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "DEVICE_INFO",
            .description="Packet with sensor information, as battery level and battery's end of life date.",
            .data_type="custom:PACKET_TYPE_FLOWER_POWER_SENSOR",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_flower_power_http_get_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_FLOWER_POWER_HTTP_GET_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="client_id",
            .description="Parrot client id",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_flower_power_http_get_options, client_id),
            .size=sizeof(const char *),
        },
        {
            .name="client_secret",
            .description="Parrot client secret",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_flower_power_http_get_options, client_secret),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_flower_power_http_get = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_get_data),
    .options_size = sizeof(struct sol_flow_node_type_flower_power_http_get_options),
    .default_options = &sol_flow_node_type_flower_power_http_get_options_defaults,
    .init_type = sol_flow_node_type_flower_power_http_get_init_type_internal,
    .open = http_get_open,
    .close = http_get_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_flower_power_http_get_get_port_in_internal,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_flower_power_http_get_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_flower_power_http_get_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_FLOWER_POWER_HTTP_GET = &sol_flow_node_type_flower_power_http_get;

static struct sol_flow_port_type_in sol_flow_node_type_flower_power_get_value__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = parse_packet,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__ID = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__FERTILIZER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__FERTILIZER_MIN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__FERTILIZER_MAX = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__LIGHT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__LIGHT_MIN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__LIGHT_MAX = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__KELVIN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__KELVIN_MIN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__KELVIN_MAX = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__TIMESTAMP = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__WATER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__WATER_MIN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_value__out__WATER_MAX = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_flower_power_get_value_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_flower_power_get_value__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_flower_power_get_value_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_flower_power_get_value__out__ID;
    if (port < 2)
        return &sol_flow_node_type_flower_power_get_value__out__FERTILIZER;
    if (port < 3)
        return &sol_flow_node_type_flower_power_get_value__out__FERTILIZER_MIN;
    if (port < 4)
        return &sol_flow_node_type_flower_power_get_value__out__FERTILIZER_MAX;
    if (port < 5)
        return &sol_flow_node_type_flower_power_get_value__out__LIGHT;
    if (port < 6)
        return &sol_flow_node_type_flower_power_get_value__out__LIGHT_MIN;
    if (port < 7)
        return &sol_flow_node_type_flower_power_get_value__out__LIGHT_MAX;
    if (port < 8)
        return &sol_flow_node_type_flower_power_get_value__out__KELVIN;
    if (port < 9)
        return &sol_flow_node_type_flower_power_get_value__out__KELVIN_MIN;
    if (port < 10)
        return &sol_flow_node_type_flower_power_get_value__out__KELVIN_MAX;
    if (port < 11)
        return &sol_flow_node_type_flower_power_get_value__out__TIMESTAMP;
    if (port < 12)
        return &sol_flow_node_type_flower_power_get_value__out__WATER;
    if (port < 13)
        return &sol_flow_node_type_flower_power_get_value__out__WATER_MIN;
    if (port < 14)
        return &sol_flow_node_type_flower_power_get_value__out__WATER_MAX;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_flower_power_get_value_init_type_internal(void)
{
    if (sol_flow_node_type_flower_power_get_value__in__IN.packet_type == NULL) {
        sol_flow_node_type_flower_power_get_value__in__IN.packet_type = PACKET_TYPE_FLOWER_POWER;
        sol_flow_node_type_flower_power_get_value__out__ID.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_flower_power_get_value__out__FERTILIZER.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__FERTILIZER_MIN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__FERTILIZER_MAX.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__LIGHT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__LIGHT_MIN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__LIGHT_MAX.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__KELVIN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__KELVIN_MIN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__KELVIN_MAX.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__TIMESTAMP.packet_type = SOL_FLOW_PACKET_TYPE_TIMESTAMP;
        sol_flow_node_type_flower_power_get_value__out__WATER.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__WATER_MIN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_value__out__WATER_MAX.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_flower_power_get_value_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "flower-power/get-value",
    .category = "iot/cloud",
    .symbol = "SOL_FLOW_NODE_TYPE_FLOWER_POWER_GET_VALUE",
    .options_symbol = "sol_flow_node_type_flower_power_get_value_options",
    .description = "Parse Flower-Power packets splitting into each measure.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/flower-power/get-value.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Packet with measures (sunlight, temperature, soil moisture and fertilizer) and thresholds related to a plant.",
            .data_type="custom:PACKET_TYPE_FLOWER_POWER",
            .array_size=0,
            .base_port_idx=0,
            .required=true,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "ID",
            .description="Plant identification, also known as location identifier.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "FERTILIZER",
            .description="Plant's fertilizer level in mS/cm. The typical range for fertilizer in horticultural applications is 0 to 4 mS/cm. Generally, fertilizer < 1 is low, fertilizer in the range of 1 - 3 is a good range, above 3 is high, and above 4 may to too high. Fertilizer usage and sensitivity is plant specific.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "FERTILIZER_MIN",
            .description="Plant's fertilizer minimum threshold.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "FERTILIZER_MAX",
            .description="Plant's fertilizer maximum threshold.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "LIGHT",
            .description="Plant's sunlight level in Daily Light Integral (DLI) - mole x m-2 x d-1.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=4,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "LIGHT_MIN",
            .description="Plant's sunlight minimum threshold.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=5,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "LIGHT_MAX",
            .description="Plant's sunlight maximum threshold.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=6,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "KELVIN",
            .description="Air temperature around the plant in Kelvin. The range of temperature that is generally comfortable for most plants is between 283-305K.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=7,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "KELVIN_MIN",
            .description="Minimum threshold for air temperature around the plant(in Kelvin).",
            .data_type="float",
            .array_size=0,
            .base_port_idx=8,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "KELVIN_MAX",
            .description="Maximum threshold for air temperature around the plant(in Kelvin).",
            .data_type="float",
            .array_size=0,
            .base_port_idx=9,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "TIMESTAMP",
            .description="Timestamp of sensors reading.",
            .data_type="timestamp",
            .array_size=0,
            .base_port_idx=10,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "WATER",
            .description="Plant's water lever (soil moisture) in a range from 0 to 50%. The typical soil moisture range is between 8 (very dry) to 45 (saturated). The soil moisture will read 0 when in air. Generally, most plants require watering when the soil moisture is in the range of 12 to 18. If the soil moisture stays > 40 for too long, this may be harmful to some plants",
            .data_type="float",
            .array_size=0,
            .base_port_idx=11,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "WATER_MIN",
            .description="Plant's water minimum threshold.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=12,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "WATER_MAX",
            .description="Plant's water maximum threshold.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=13,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_flower_power_get_value = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_flower_power_get_value_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_flower_power_get_value_get_port_in_internal,
    .ports_out_count = 14,
    .get_port_out = sol_flow_node_type_flower_power_get_value_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_flower_power_get_value_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_FLOWER_POWER_GET_VALUE = &sol_flow_node_type_flower_power_get_value;

static struct sol_flow_port_type_in sol_flow_node_type_flower_power_filter_id__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = filter_packet,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_flower_power_filter_id__in__ID = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = filter_set_id,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_filter_id__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_flower_power_filter_id_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_flower_power_filter_id__in__IN;
    if (port < 2)
        return &sol_flow_node_type_flower_power_filter_id__in__ID;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_flower_power_filter_id_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_flower_power_filter_id__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_flower_power_filter_id_init_type_internal(void)
{
    if (sol_flow_node_type_flower_power_filter_id__in__IN.packet_type == NULL) {
        sol_flow_node_type_flower_power_filter_id__in__IN.packet_type = PACKET_TYPE_FLOWER_POWER;
        sol_flow_node_type_flower_power_filter_id__in__ID.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_flower_power_filter_id__out__OUT.packet_type = PACKET_TYPE_FLOWER_POWER;
    }

    log_init();
}

static const struct sol_flow_node_type_flower_power_filter_id_options sol_flow_node_type_flower_power_filter_id_options_defaults = SOL_FLOW_NODE_TYPE_FLOWER_POWER_FILTER_ID_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_flower_power_filter_id_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "flower-power/filter-id",
    .category = "iot/cloud",
    .symbol = "SOL_FLOW_NODE_TYPE_FLOWER_POWER_FILTER_ID",
    .options_symbol = "sol_flow_node_type_flower_power_filter_id_options",
    .description = "Filter Flower-Power packets, forwarding only packets that matches a specific plant ID.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/flower-power/filter-id.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Packet with measures (sunlight, temperature, soil moisture and fertilizer) and thresholds related to a plant.",
            .data_type="custom:PACKET_TYPE_FLOWER_POWER",
            .array_size=0,
            .base_port_idx=0,
            .required=true,
        }),
            &((const struct sol_flow_port_description){
            .name = "ID",
            .description="Plant identification, also known as location identifier. Overwrite previous ID or ID set via options.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Packet with measures (sunlight, temperature, soil moisture and fertilizer) and thresholds related to the plant specified by options ID.",
            .data_type="custom:PACKET_TYPE_FLOWER_POWER",
            .array_size=0,
            .base_port_idx=0,
            .required=true,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_flower_power_filter_id_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_FLOWER_POWER_FILTER_ID_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="id",
            .description="Plant identifier.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_flower_power_filter_id_options, id),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_flower_power_filter_id = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct filter_data),
    .options_size = sizeof(struct sol_flow_node_type_flower_power_filter_id_options),
    .default_options = &sol_flow_node_type_flower_power_filter_id_options_defaults,
    .init_type = sol_flow_node_type_flower_power_filter_id_init_type_internal,
    .open = filter_open,
    .close = filter_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_flower_power_filter_id_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_flower_power_filter_id_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_flower_power_filter_id_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_FLOWER_POWER_FILTER_ID = &sol_flow_node_type_flower_power_filter_id;

static struct sol_flow_port_type_in sol_flow_node_type_flower_power_get_sensor_value__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = parse_sensor_packet,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_sensor_value__out__ID = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_sensor_value__out__BATTERY_LEVEL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_sensor_value__out__BATTERY_END_OF_LIFE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_get_sensor_value__out__TIMESTAMP = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_flower_power_get_sensor_value_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_flower_power_get_sensor_value__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_flower_power_get_sensor_value_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_flower_power_get_sensor_value__out__ID;
    if (port < 2)
        return &sol_flow_node_type_flower_power_get_sensor_value__out__BATTERY_LEVEL;
    if (port < 3)
        return &sol_flow_node_type_flower_power_get_sensor_value__out__BATTERY_END_OF_LIFE;
    if (port < 4)
        return &sol_flow_node_type_flower_power_get_sensor_value__out__TIMESTAMP;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_flower_power_get_sensor_value_init_type_internal(void)
{
    if (sol_flow_node_type_flower_power_get_sensor_value__in__IN.packet_type == NULL) {
        sol_flow_node_type_flower_power_get_sensor_value__in__IN.packet_type = PACKET_TYPE_FLOWER_POWER_SENSOR;
        sol_flow_node_type_flower_power_get_sensor_value__out__ID.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_flower_power_get_sensor_value__out__BATTERY_LEVEL.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_flower_power_get_sensor_value__out__BATTERY_END_OF_LIFE.packet_type = SOL_FLOW_PACKET_TYPE_TIMESTAMP;
        sol_flow_node_type_flower_power_get_sensor_value__out__TIMESTAMP.packet_type = SOL_FLOW_PACKET_TYPE_TIMESTAMP;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_flower_power_get_sensor_value_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "flower-power/get-sensor-value",
    .category = "iot/cloud",
    .symbol = "SOL_FLOW_NODE_TYPE_FLOWER_POWER_GET_SENSOR_VALUE",
    .options_symbol = "sol_flow_node_type_flower_power_get_sensor_value_options",
    .description = "Parse Flower-Power sensor packets splitting into each measure.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/flower-power/get-sensor-value.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Packet with sensor information, as battery level and battery's end of life date related to a sensor.",
            .data_type="custom:PACKET_TYPE_FLOWER_POWER_SENSOR",
            .array_size=0,
            .base_port_idx=0,
            .required=true,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "ID",
            .description="Sensor identification, also known as sensor serial.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "BATTERY_LEVEL",
            .description="Battery level (percent).",
            .data_type="float",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "BATTERY_END_OF_LIFE",
            .description="Timestamp of estimated battery end of life.",
            .data_type="timestamp",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "TIMESTAMP",
            .description="Timestamp of sensors reading.",
            .data_type="timestamp",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_flower_power_get_sensor_value = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_flower_power_get_sensor_value_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_flower_power_get_sensor_value_get_port_in_internal,
    .ports_out_count = 4,
    .get_port_out = sol_flow_node_type_flower_power_get_sensor_value_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_flower_power_get_sensor_value_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_FLOWER_POWER_GET_SENSOR_VALUE = &sol_flow_node_type_flower_power_get_sensor_value;

static struct sol_flow_port_type_in sol_flow_node_type_flower_power_filter_sensor_id__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = filter_sensor_packet,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_flower_power_filter_sensor_id__in__ID = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = filter_set_id,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_flower_power_filter_sensor_id__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_flower_power_filter_sensor_id_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_flower_power_filter_sensor_id__in__IN;
    if (port < 2)
        return &sol_flow_node_type_flower_power_filter_sensor_id__in__ID;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_flower_power_filter_sensor_id_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_flower_power_filter_sensor_id__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_flower_power_filter_sensor_id_init_type_internal(void)
{
    if (sol_flow_node_type_flower_power_filter_sensor_id__in__IN.packet_type == NULL) {
        sol_flow_node_type_flower_power_filter_sensor_id__in__IN.packet_type = PACKET_TYPE_FLOWER_POWER_SENSOR;
        sol_flow_node_type_flower_power_filter_sensor_id__in__ID.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_flower_power_filter_sensor_id__out__OUT.packet_type = PACKET_TYPE_FLOWER_POWER_SENSOR;
    }

    log_init();
}

static const struct sol_flow_node_type_flower_power_filter_sensor_id_options sol_flow_node_type_flower_power_filter_sensor_id_options_defaults = SOL_FLOW_NODE_TYPE_FLOWER_POWER_FILTER_SENSOR_ID_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_flower_power_filter_sensor_id_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "flower-power/filter-sensor-id",
    .category = "iot/cloud",
    .symbol = "SOL_FLOW_NODE_TYPE_FLOWER_POWER_FILTER_SENSOR_ID",
    .options_symbol = "sol_flow_node_type_flower_power_filter_sensor_id_options",
    .description = "Filter Flower-Power device information packets, forwarding only packets that matches a specific sensor ID.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/flower-power/filter-sensor-id.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Packet with sensor information, as battery level and battery's end of life date.",
            .data_type="custom:PACKET_TYPE_FLOWER_POWER_SENSOR",
            .array_size=0,
            .base_port_idx=0,
            .required=true,
        }),
            &((const struct sol_flow_port_description){
            .name = "ID",
            .description="Sensor identification, also known as sensor serial. Overwrite previous ID or ID set via options.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Packet with sensor information, as battery level and battery's end of life date related to the sensor specified by options ID.",
            .data_type="custom:PACKET_TYPE_FLOWER_POWER_SENSOR",
            .array_size=0,
            .base_port_idx=0,
            .required=true,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_flower_power_filter_sensor_id_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_FLOWER_POWER_FILTER_SENSOR_ID_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="id",
            .description="Sensor identifier.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_flower_power_filter_sensor_id_options, id),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_flower_power_filter_sensor_id = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct filter_data),
    .options_size = sizeof(struct sol_flow_node_type_flower_power_filter_sensor_id_options),
    .default_options = &sol_flow_node_type_flower_power_filter_sensor_id_options_defaults,
    .init_type = sol_flow_node_type_flower_power_filter_sensor_id_init_type_internal,
    .open = filter_open,
    .close = filter_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_flower_power_filter_sensor_id_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_flower_power_filter_sensor_id_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_flower_power_filter_sensor_id_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_FLOWER_POWER_FILTER_SENSOR_ID = &sol_flow_node_type_flower_power_filter_sensor_id;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_flower_power(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_flower_power(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_FLOWER_POWER_HTTP_GET,
            &SOL_FLOW_NODE_TYPE_FLOWER_POWER_GET_VALUE,
            &SOL_FLOW_NODE_TYPE_FLOWER_POWER_FILTER_ID,
            &SOL_FLOW_NODE_TYPE_FLOWER_POWER_GET_SENSOR_VALUE,
            &SOL_FLOW_NODE_TYPE_FLOWER_POWER_FILTER_SENSOR_ID,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
