/* this file was auto-generated from ./src/modules/flow/format/format.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_FORMAT_DEFINED
#include "sol-flow/format.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_format_float_to_string__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = drange_to_string_convert,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_format_float_to_string__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_format_float_to_string_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_format_float_to_string__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_format_float_to_string_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_format_float_to_string__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_format_float_to_string_init_type_internal(void)
{
    if (sol_flow_node_type_format_float_to_string__in__IN.packet_type == NULL) {
        sol_flow_node_type_format_float_to_string__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_format_float_to_string__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_format_float_to_string_options sol_flow_node_type_format_float_to_string_options_defaults = SOL_FLOW_NODE_TYPE_FORMAT_FLOAT_TO_STRING_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_format_float_to_string_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "format/float-to-string",
    .category = "converter",
    .symbol = "SOL_FLOW_NODE_TYPE_FORMAT_FLOAT_TO_STRING",
    .options_symbol = "sol_flow_node_type_format_float_to_string_options",
    .description = "Receives a float packet and converts it to a string one.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/converter/float-to-string.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Where to receive the float value to be converted.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Float converted to string with 6 digits after decimal-point character.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_format_float_to_string_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_FORMAT_FLOAT_TO_STRING_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="format_spec",
            .description="Format string to be used in the conversion. The syntax is the same as Python's string.format() -- https://docs.python.org/3/library/stdtypes.html#str.format --, except that we got no format recursion, no '!' conversions, and the attribute names must be one of the integer fields (val, min, max, step). Numbered fields will get to them in this order. Naturally, there is no field attribute nor field index dereferencing either.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_format_float_to_string_options, format_spec),
            .size=sizeof(const char *),
            .defvalue = {
                .s="{val:f}",
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_format_float_to_string = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct string_converter),
    .options_size = sizeof(struct sol_flow_node_type_format_float_to_string_options),
    .default_options = &sol_flow_node_type_format_float_to_string_options_defaults,
    .init_type = sol_flow_node_type_format_float_to_string_init_type_internal,
    .open = drange_to_string_open,
    .close = drange_to_string_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_format_float_to_string_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_format_float_to_string_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_format_float_to_string_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_FORMAT_FLOAT_TO_STRING = &sol_flow_node_type_format_float_to_string;

static struct sol_flow_port_type_in sol_flow_node_type_format_int_to_string__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = irange_to_string_convert,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_format_int_to_string__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_format_int_to_string_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_format_int_to_string__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_format_int_to_string_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_format_int_to_string__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_format_int_to_string_init_type_internal(void)
{
    if (sol_flow_node_type_format_int_to_string__in__IN.packet_type == NULL) {
        sol_flow_node_type_format_int_to_string__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_format_int_to_string__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_format_int_to_string_options sol_flow_node_type_format_int_to_string_options_defaults = SOL_FLOW_NODE_TYPE_FORMAT_INT_TO_STRING_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_format_int_to_string_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "format/int-to-string",
    .category = "converter",
    .symbol = "SOL_FLOW_NODE_TYPE_FORMAT_INT_TO_STRING",
    .options_symbol = "sol_flow_node_type_format_int_to_string_options",
    .description = "Receives an int packet and converts it to a string one.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/converter/int-to-string.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Where to receive the int value to be converted.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Int converted to string.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_format_int_to_string_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_FORMAT_INT_TO_STRING_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="format_spec",
            .description="Format string to be used in the conversion. The syntax is the same as Python's string.format() -- https://docs.python.org/3/library/stdtypes.html#str.format --, except that we got no format recursion, no '!' conversions, and the attribute names must be one of the integer fields (val, min, max, step). Numbered fields will get to them in this order. Naturally, there is no field attribute nor field index dereferencing either.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_format_int_to_string_options, format_spec),
            .size=sizeof(const char *),
            .defvalue = {
                .s="{val:d}",
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_format_int_to_string = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct string_converter),
    .options_size = sizeof(struct sol_flow_node_type_format_int_to_string_options),
    .default_options = &sol_flow_node_type_format_int_to_string_options_defaults,
    .init_type = sol_flow_node_type_format_int_to_string_init_type_internal,
    .open = irange_to_string_open,
    .close = irange_to_string_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_format_int_to_string_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_format_int_to_string_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_format_int_to_string_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_FORMAT_INT_TO_STRING = &sol_flow_node_type_format_int_to_string;

static struct sol_flow_port_type_in sol_flow_node_type_format_string_formatted_form__in__SELECTED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = string_formatted_selected_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_format_string_formatted_form__in__UP = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = string_formatted_up_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_format_string_formatted_form__in__DOWN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = string_formatted_down_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_format_string_formatted_form__in__NEXT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = string_formatted_next_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_format_string_formatted_form__in__PREVIOUS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = string_formatted_previous_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_format_string_formatted_form__in__SELECT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = string_formatted_select_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_format_string_formatted_form__in__ENABLED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = string_formatted_enabled_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_format_string_formatted_form__out__STRING = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_format_string_formatted_form__out__SELECTED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_format_string_formatted_form_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_format_string_formatted_form__in__SELECTED;
    if (port < 2)
        return &sol_flow_node_type_format_string_formatted_form__in__UP;
    if (port < 3)
        return &sol_flow_node_type_format_string_formatted_form__in__DOWN;
    if (port < 4)
        return &sol_flow_node_type_format_string_formatted_form__in__NEXT;
    if (port < 5)
        return &sol_flow_node_type_format_string_formatted_form__in__PREVIOUS;
    if (port < 6)
        return &sol_flow_node_type_format_string_formatted_form__in__SELECT;
    if (port < 7)
        return &sol_flow_node_type_format_string_formatted_form__in__ENABLED;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_format_string_formatted_form_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_format_string_formatted_form__out__STRING;
    if (port < 2)
        return &sol_flow_node_type_format_string_formatted_form__out__SELECTED;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_format_string_formatted_form_init_type_internal(void)
{
    if (sol_flow_node_type_format_string_formatted_form__in__SELECTED.packet_type == NULL) {
        sol_flow_node_type_format_string_formatted_form__in__SELECTED.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_format_string_formatted_form__in__UP.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_format_string_formatted_form__in__DOWN.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_format_string_formatted_form__in__NEXT.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_format_string_formatted_form__in__PREVIOUS.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_format_string_formatted_form__in__SELECT.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_format_string_formatted_form__in__ENABLED.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_format_string_formatted_form__out__STRING.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_format_string_formatted_form__out__SELECTED.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_format_string_formatted_form_options sol_flow_node_type_format_string_formatted_form_options_defaults = SOL_FLOW_NODE_TYPE_FORMAT_STRING_FORMATTED_FORM_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_format_string_formatted_form_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "format/string-formatted-form",
    .category = "io/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_FORMAT_STRING_FORMATTED_FORM",
    .options_symbol = "sol_flow_node_type_format_string_formatted_form_options",
    .description = "Receives packages to control the formation/edition of a formatted string. That string may be formatted to have any number of numerical fields, that will then be open to edition by the node's input port interactions. Four input ports control the position on the format numerical fields (and the values of the fields themselves) of a forming string. One of the input ports will commit to a state when trigerred, and the formed string will be outputted. A (broader) string output with the current state, defined by the format string, is also outputted (one time per second, to emulate a blinking cursor). All strings in this node should be ASCII only, as it is meant to output to LCD displays.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/form/string-formatted.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "SELECTED",
            .description="Change the current state (useful for initial setups on a flow). Be careful to use this only when your 'value' option is reasonably backwards parseable, i.e., does not contain neighbor numerical fields (no literal fields in between them), does not mix number punctuation and that same punctuation symbols in the literals, etc.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "UP",
            .description="Increase the value of the field under the cursor position.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "DOWN",
            .description="Decrease the value of the field under the cursor position.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "NEXT",
            .description="Advance the cursor position (to the right), to the next numeric field.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PREVIOUS",
            .description="Retract the cursor position (to the left), to the previous numeric field.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=4,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "SELECT",
            .description="Confirm the selection to be current one, generating output packets on both STRING and SELECTED output ports.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=5,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "ENABLED",
            .description="Make the interaction possible, otherwise don't produce strings or process UP/DOWN/SELECT inputs. In other words, enable/disable the node at run-time. The node starts in the enabled state. Note that this does not affect the use of the SELECTED port.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=6,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "STRING",
            .description="The formatted string output. This is meant to feed real display nodes (like grove/lcd-string).",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "SELECTED",
            .description="The current string state.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_format_string_formatted_form_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_FORMAT_STRING_FORMATTED_FORM_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="columns",
            .description="The number of available columns to lay out the output string with. It must be a positive integer.",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_format_string_formatted_form_options, columns),
            .size=sizeof(int32_t),
        },
        {
            .name="rows",
            .description="The number of available rows to lay out the output string with. It must be a positive integer.",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_format_string_formatted_form_options, rows),
            .size=sizeof(int32_t),
        },
        {
            .name="blink_time",
            .description="Cursor blinking time, in miliseconds.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_format_string_formatted_form_options, blink_time),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=1000,
            },
        },
        {
            .name="circular",
            .description="Whether the numeric field edition by the UP/DOWN ports is circular or not (wraps from mininim value to maximum and vice-versa).",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_format_string_formatted_form_options, circular),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="value",
            .description="The value (format) string, to be available for referencing when evaluating the format one by means of the '{value}' tag. Any line breaking characters in this string will be translated to a space instead. This is a format inside the broader one, meant to define the numbered fields to be actually editable by the node. The syntax is a free-form string where fields enclosed by '{}' are treated specially. They must have an entry with Python's number format specification mini-language (https://docs.python.org/3/library/string.html#formatspec), followed by a colon and three comma-separated values defining the field's minimum, maximum and step values. As an exception for the Python's language, empty types are not allowed, and 'n' will always translate to integer. As an example, '{3d:0,255,1}.{3d:0,255,1}.{3d:0,255,1}.{3d:0,255,1}' would make the node have four three-digit integer numbers separated by periods as output--an IPv4 number for user edition.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_format_string_formatted_form_options, value),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="value_default",
            .description="The default value for the numeric fields' node state, in string form. The string should match the expected form given by the 'value' option, naturally. As an example, if '{3d:0,255,1}.{3d:0,255,1}.{3d:0,255,1}.{3d:0,255,1}' is in the 'value' option, something like '255.255.255.255' would be expected for this option. If this option is not set, the minimum values for each field will be the initial state.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_format_string_formatted_form_options, value_default),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="title",
            .description="The title string, to be available for referencing when evaluating the format one by means of the '{title}' tag. Any line breaking characters in this string will be translated to a space instead. If no title is provided, a '{title}' tag in the format will be ignored.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_format_string_formatted_form_options, title),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="format",
            .description="The format string to produce the final STRING output with. The syntax is a free-form string with one '{value}' sub-string in it (and one optional '{title}' one). The value tag will be replaced by the actual true/false strings defined for the node (true_str/false_str options), while the title one will be replaced by the title string option, if set. The title tag must occur before the value one.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_format_string_formatted_form_options, format),
            .size=sizeof(const char *),
            .defvalue = {
                .s="{value}",
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_format_string_formatted_form = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct string_formatted_data),
    .options_size = sizeof(struct sol_flow_node_type_format_string_formatted_form_options),
    .default_options = &sol_flow_node_type_format_string_formatted_form_options_defaults,
    .init_type = sol_flow_node_type_format_string_formatted_form_init_type_internal,
    .open = string_formatted_open,
    .close = string_formatted_close,
    .ports_in_count = 7,
    .get_port_in = sol_flow_node_type_format_string_formatted_form_get_port_in_internal,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_format_string_formatted_form_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_format_string_formatted_form_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_FORMAT_STRING_FORMATTED_FORM = &sol_flow_node_type_format_string_formatted_form;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_format(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_format(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_FORMAT_FLOAT_TO_STRING,
            &SOL_FLOW_NODE_TYPE_FORMAT_INT_TO_STRING,
            &SOL_FLOW_NODE_TYPE_FORMAT_STRING_FORMATTED_FORM,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
