/* this file was auto-generated from ./src/modules/flow/grove/grove.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_GROVE_DEFINED
#include "sol-flow/grove.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>
#include <float.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_grove_temperature_converter__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = temperature_convert,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_temperature_converter__out__KELVIN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_temperature_converter__out__RAW = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_grove_temperature_converter_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_grove_temperature_converter__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_grove_temperature_converter_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_grove_temperature_converter__out__KELVIN;
    if (port < 2)
        return &sol_flow_node_type_grove_temperature_converter__out__RAW;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_grove_temperature_converter_init_type_internal(void)
{
    if (sol_flow_node_type_grove_temperature_converter__in__IN.packet_type == NULL) {
        sol_flow_node_type_grove_temperature_converter__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_grove_temperature_converter__out__KELVIN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_grove_temperature_converter__out__RAW.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_grove_temperature_converter_options sol_flow_node_type_grove_temperature_converter_options_defaults = SOL_FLOW_NODE_TYPE_GROVE_TEMPERATURE_CONVERTER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_grove_temperature_converter_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "grove/temperature-converter",
    .category = "internal",
    .symbol = "SOL_FLOW_NODE_TYPE_GROVE_TEMPERATURE_CONVERTER",
    .options_symbol = "sol_flow_node_type_grove_temperature_converter_options",
    .description = "Converts raw sensor temperature readings to Kelvin packets. Conversion to Kelvin is done using: 1/(log(((i-r)*Rc/r)/Rt)/B + 1/T - where i is input range, r is raw sensor value, Rc is potential divider resistor resitance, Rt is thermistor resistance, B is thermistor constant and T is thermistor reference temperature.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Input value",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "KELVIN",
            .description="Measured temperature in Kelvin.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "RAW",
            .description="Raw measured temperature.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_grove_temperature_converter_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GROVE_TEMPERATURE_CONVERTER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="thermistor_constant",
            .description="Thermistor constant",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_temperature_converter_options, thermistor_constant),
            .size=sizeof(int32_t),
        },
        {
            .name="input_range_mask",
            .description="Input range mask",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_temperature_converter_options, input_range_mask),
            .size=sizeof(int32_t),
        },
        {
            .name="resistance",
            .description="Potential divider resistance",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_temperature_converter_options, resistance),
            .size=sizeof(int32_t),
        },
        {
            .name="reference_temperature",
            .description="Thermistor reference temperature",
            .data_type="float",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_temperature_converter_options, reference_temperature),
            .size=sizeof(double),
        },
        {
            .name="thermistor_resistance",
            .description="Thermistor reference resistance",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_temperature_converter_options, thermistor_resistance),
            .size=sizeof(int32_t),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_grove_temperature_converter = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct temperature_converter_data),
    .options_size = sizeof(struct sol_flow_node_type_grove_temperature_converter_options),
    .default_options = &sol_flow_node_type_grove_temperature_converter_options_defaults,
    .init_type = sol_flow_node_type_grove_temperature_converter_init_type_internal,
    .open = temperature_converter_open,
    .close = NULL,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_grove_temperature_converter_get_port_in_internal,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_grove_temperature_converter_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_grove_temperature_converter_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GROVE_TEMPERATURE_CONVERTER = &sol_flow_node_type_grove_temperature_converter;

static struct sol_flow_port_type_out sol_flow_node_type_grove_thermometer__out__KELVIN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_thermometer__out__RAW = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_grove_thermometer_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_grove_thermometer__out__KELVIN;
    if (port < 2)
        return &sol_flow_node_type_grove_thermometer__out__RAW;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_grove_thermometer_init_type_internal(void)
{
    if (sol_flow_node_type_grove_thermometer__out__KELVIN.packet_type == NULL) {
        sol_flow_node_type_grove_thermometer__out__KELVIN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_grove_thermometer__out__RAW.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }
    temperature_init_type();

    log_init();
}

static const struct sol_flow_node_type_grove_thermometer_options sol_flow_node_type_grove_thermometer_options_defaults = SOL_FLOW_NODE_TYPE_GROVE_THERMOMETER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_grove_thermometer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "grove/thermometer",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_GROVE_THERMOMETER",
    .options_symbol = "sol_flow_node_type_grove_thermometer_options",
    .description = "Gets sensor temperature in Kelvin. Conversion to Kelvin is done using: 1/(log(((i-r)*Rc/r)/Rt)/B + 1/T - where i is input range, r is raw sensor value, Rc is potential divider resistor resitance, Rt is thermistor resistance, B is thermistor constant and T is thermistor reference temperature.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "KELVIN",
            .description="Measured temperature in Kelvin.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "RAW",
            .description="Raw measured temperature.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_grove_thermometer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GROVE_THERMOMETER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="pin",
            .description="Label of the desired pin on the board. If raw is set to true, this should be \"<device> <pin>\" pair, e.g. \"0 3\".",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_thermometer_options, pin),
            .size=sizeof(const char *),
        },
        {
            .name="raw",
            .description="Change 'pin' meaning to be the system parameters needed to address the desired pin. Use it if you know what you are doing.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_thermometer_options, raw),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="mask",
            .description="Valid bits mask. This mask is used to filter the valid bits from the data received from hardware (which is manufacturer dependent), therefore should not be used as a way to change the output range because the mask is applied to the least significant bits.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_thermometer_options, mask),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=12,
            },
        },
        {
            .name="poll_timeout",
            .description="Polling time in milliseconds. This option will take no effect if hardware interruptions for GPIO is supported by the underlying system. Use it if you know that you don't have those interruptions available.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_thermometer_options, poll_timeout),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=1000,
            },
        },
        {
            .name="thermistor_constant",
            .description="Thermistor constant",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_thermometer_options, thermistor_constant),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=3975,
            },
        },
        {
            .name="resistance",
            .description="Potential divider resistance",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_thermometer_options, resistance),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=10000,
            },
        },
        {
            .name="reference_temperature",
            .description="Thermistor reference temperature",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_thermometer_options, reference_temperature),
            .size=sizeof(double),
            .defvalue = {
                .f=298.15,
            },
        },
        {
            .name="thermistor_resistance",
            .description="Thermistor reference resistance",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_thermometer_options, thermistor_resistance),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=10000,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_grove_thermometer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_type_grove_thermometer_options),
    .default_options = &sol_flow_node_type_grove_thermometer_options_defaults,
    .init_type = sol_flow_node_type_grove_thermometer_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_grove_thermometer_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_grove_thermometer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GROVE_THERMOMETER = &sol_flow_node_type_grove_thermometer;

static struct sol_flow_port_type_in sol_flow_node_type_grove_light_converter__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = light_converter,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_light_converter__out__LUX = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_light_converter__out__RAW = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_grove_light_converter_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_grove_light_converter__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_grove_light_converter_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_grove_light_converter__out__LUX;
    if (port < 2)
        return &sol_flow_node_type_grove_light_converter__out__RAW;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_grove_light_converter_init_type_internal(void)
{
    if (sol_flow_node_type_grove_light_converter__in__IN.packet_type == NULL) {
        sol_flow_node_type_grove_light_converter__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_grove_light_converter__out__LUX.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_grove_light_converter__out__RAW.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_grove_light_converter_options sol_flow_node_type_grove_light_converter_options_defaults = SOL_FLOW_NODE_TYPE_GROVE_LIGHT_CONVERTER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_grove_light_converter_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "grove/light-converter",
    .category = "internal",
    .symbol = "SOL_FLOW_NODE_TYPE_GROVE_LIGHT_CONVERTER",
    .options_symbol = "sol_flow_node_type_grove_light_converter_options",
    .description = "Converts light sensor raw readings to Lux.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Input value",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "LUX",
            .description="Measured illuminance in Lux (approximately).",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "RAW",
            .description="Raw measured illuminance.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_grove_light_converter_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GROVE_LIGHT_CONVERTER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="input_range_mask",
            .description="Input range mask",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_light_converter_options, input_range_mask),
            .size=sizeof(int32_t),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_grove_light_converter = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct light_converter_data),
    .options_size = sizeof(struct sol_flow_node_type_grove_light_converter_options),
    .default_options = &sol_flow_node_type_grove_light_converter_options_defaults,
    .init_type = sol_flow_node_type_grove_light_converter_init_type_internal,
    .open = light_converter_open,
    .close = NULL,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_grove_light_converter_get_port_in_internal,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_grove_light_converter_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_grove_light_converter_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GROVE_LIGHT_CONVERTER = &sol_flow_node_type_grove_light_converter;

static struct sol_flow_port_type_out sol_flow_node_type_grove_light_sensor__out__LUX = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_light_sensor__out__RAW = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_grove_light_sensor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_grove_light_sensor__out__LUX;
    if (port < 2)
        return &sol_flow_node_type_grove_light_sensor__out__RAW;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_grove_light_sensor_init_type_internal(void)
{
    if (sol_flow_node_type_grove_light_sensor__out__LUX.packet_type == NULL) {
        sol_flow_node_type_grove_light_sensor__out__LUX.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_grove_light_sensor__out__RAW.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }
    light_sensor_init_type();

    log_init();
}

static const struct sol_flow_node_type_grove_light_sensor_options sol_flow_node_type_grove_light_sensor_options_defaults = SOL_FLOW_NODE_TYPE_GROVE_LIGHT_SENSOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_grove_light_sensor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "grove/light-sensor",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_GROVE_LIGHT_SENSOR",
    .options_symbol = "sol_flow_node_type_grove_light_sensor_options",
    .description = "Get light sensor readings in Lux. However, it should be noted that this sensor is not precise, so the Lux readings are a rough estimation based on Grove Starter Kit booklet table, which relates raw sensor readings to Lux.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "LUX",
            .description="Measured illuminance in Lux (approximately).",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "RAW",
            .description="Raw measured illuminance.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_grove_light_sensor_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GROVE_LIGHT_SENSOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="pin",
            .description="Label of the desired pin on the board. If raw is set to true, this should be \"<device> <pin>\" pair, e.g. \"0 3\".",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_light_sensor_options, pin),
            .size=sizeof(const char *),
        },
        {
            .name="raw",
            .description="Change 'pin' meaning to be the system parameters needed to address the desired pin. Use it if you know what you are doing.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_light_sensor_options, raw),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="mask",
            .description="Valid bits mask. This mask is used to filter the valid bits from the data received from hardware (which is manufacturer dependent), therefore should not be used as a way to change the output range because the mask is applied to the least significant bits.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_light_sensor_options, mask),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=12,
            },
        },
        {
            .name="poll_timeout",
            .description="Polling time in milliseconds. This option will take no effect if hardware interruptions for GPIO is supported by the underlying system. Use it if you know that you don't have those interruptions available.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_light_sensor_options, poll_timeout),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=1000,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_grove_light_sensor = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_type_grove_light_sensor_options),
    .default_options = &sol_flow_node_type_grove_light_sensor_options_defaults,
    .init_type = sol_flow_node_type_grove_light_sensor_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_grove_light_sensor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_grove_light_sensor_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GROVE_LIGHT_SENSOR = &sol_flow_node_type_grove_light_sensor;

static struct sol_flow_port_type_in sol_flow_node_type_grove_rotary_converter__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = rotary_converter,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_rotary_converter__out__DEG = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_rotary_converter__out__RAD = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_rotary_converter__out__RAW = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_grove_rotary_converter_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_grove_rotary_converter__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_grove_rotary_converter_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_grove_rotary_converter__out__DEG;
    if (port < 2)
        return &sol_flow_node_type_grove_rotary_converter__out__RAD;
    if (port < 3)
        return &sol_flow_node_type_grove_rotary_converter__out__RAW;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_grove_rotary_converter_init_type_internal(void)
{
    if (sol_flow_node_type_grove_rotary_converter__in__IN.packet_type == NULL) {
        sol_flow_node_type_grove_rotary_converter__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_grove_rotary_converter__out__DEG.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_grove_rotary_converter__out__RAD.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_grove_rotary_converter__out__RAW.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_grove_rotary_converter_options sol_flow_node_type_grove_rotary_converter_options_defaults = SOL_FLOW_NODE_TYPE_GROVE_ROTARY_CONVERTER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_grove_rotary_converter_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "grove/rotary-converter",
    .category = "internal",
    .symbol = "SOL_FLOW_NODE_TYPE_GROVE_ROTARY_CONVERTER",
    .options_symbol = "sol_flow_node_type_grove_rotary_converter_options",
    .description = "Converts raw rotary sensor reading to degrees or radians.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Input value",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "DEG",
            .description="Measured rotation in degrees.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "RAD",
            .description="Measured rotation in radians.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "RAW",
            .description="Raw measured rotation.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_grove_rotary_converter_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GROVE_ROTARY_CONVERTER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="angular_range",
            .description="Angular range",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_rotary_converter_options, angular_range),
            .size=sizeof(int32_t),
        },
        {
            .name="input_range_mask",
            .description="Input range mask",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_rotary_converter_options, input_range_mask),
            .size=sizeof(int32_t),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_grove_rotary_converter = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct rotary_converter_data),
    .options_size = sizeof(struct sol_flow_node_type_grove_rotary_converter_options),
    .default_options = &sol_flow_node_type_grove_rotary_converter_options_defaults,
    .init_type = sol_flow_node_type_grove_rotary_converter_init_type_internal,
    .open = rotary_converter_open,
    .close = NULL,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_grove_rotary_converter_get_port_in_internal,
    .ports_out_count = 3,
    .get_port_out = sol_flow_node_type_grove_rotary_converter_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_grove_rotary_converter_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GROVE_ROTARY_CONVERTER = &sol_flow_node_type_grove_rotary_converter;

static struct sol_flow_port_type_out sol_flow_node_type_grove_rotary_sensor__out__DEG = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_rotary_sensor__out__RAD = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_grove_rotary_sensor__out__RAW = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_grove_rotary_sensor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_grove_rotary_sensor__out__DEG;
    if (port < 2)
        return &sol_flow_node_type_grove_rotary_sensor__out__RAD;
    if (port < 3)
        return &sol_flow_node_type_grove_rotary_sensor__out__RAW;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_grove_rotary_sensor_init_type_internal(void)
{
    if (sol_flow_node_type_grove_rotary_sensor__out__DEG.packet_type == NULL) {
        sol_flow_node_type_grove_rotary_sensor__out__DEG.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_grove_rotary_sensor__out__RAD.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_grove_rotary_sensor__out__RAW.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }
    rotary_sensor_init_type();

    log_init();
}

static const struct sol_flow_node_type_grove_rotary_sensor_options sol_flow_node_type_grove_rotary_sensor_options_defaults = SOL_FLOW_NODE_TYPE_GROVE_ROTARY_SENSOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_grove_rotary_sensor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "grove/rotary-sensor",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_GROVE_ROTARY_SENSOR",
    .options_symbol = "sol_flow_node_type_grove_rotary_sensor_options",
    .description = "Get rotary sensor reading in degrees and radians.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "DEG",
            .description="Measured rotation in degrees.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "RAD",
            .description="Measured rotation in radians.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "RAW",
            .description="Raw measured rotation.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_grove_rotary_sensor_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GROVE_ROTARY_SENSOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="pin",
            .description="Label of the desired pin on the board. If raw is set to true, this should be \"<device> <pin>\" pair, e.g. \"0 3\".",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_grove_rotary_sensor_options, pin),
            .size=sizeof(const char *),
        },
        {
            .name="raw",
            .description="Change 'pin' meaning to be the system parameters needed to address the desired pin. Use it if you know what you are doing.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_rotary_sensor_options, raw),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="mask",
            .description="Valid bits mask. This mask is used to filter the valid bits from the data received from hardware (which is manufacturer dependent), therefore should not be used as a way to change the output range because the mask is applied to the least significant bits.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_rotary_sensor_options, mask),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=12,
            },
        },
        {
            .name="poll_timeout",
            .description="Polling time in milliseconds. This option will take no effect if hardware interruptions for GPIO is supported by the underlying system. Use it if you know that you don't have those interruptions available.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_rotary_sensor_options, poll_timeout),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=1000,
            },
        },
        {
            .name="angular_range",
            .description="Angular range",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_grove_rotary_sensor_options, angular_range),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=300,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_grove_rotary_sensor = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_type_grove_rotary_sensor_options),
    .default_options = &sol_flow_node_type_grove_rotary_sensor_options_defaults,
    .init_type = sol_flow_node_type_grove_rotary_sensor_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_out_count = 3,
    .get_port_out = sol_flow_node_type_grove_rotary_sensor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_grove_rotary_sensor_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GROVE_ROTARY_SENSOR = &sol_flow_node_type_grove_rotary_sensor;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_grove(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_grove(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_GROVE_TEMPERATURE_CONVERTER,
            &SOL_FLOW_NODE_TYPE_GROVE_THERMOMETER,
            &SOL_FLOW_NODE_TYPE_GROVE_LIGHT_CONVERTER,
            &SOL_FLOW_NODE_TYPE_GROVE_LIGHT_SENSOR,
            &SOL_FLOW_NODE_TYPE_GROVE_ROTARY_CONVERTER,
            &SOL_FLOW_NODE_TYPE_GROVE_ROTARY_SENSOR,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
