/* this file was auto-generated from ./src/modules/flow/gtk/gtk.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_GTK_DEFINED
#include "sol-flow/gtk.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_out sol_flow_node_type_gtk_byte_editor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_byte_editor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_byte_editor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_byte_editor_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_byte_editor__out__OUT.packet_type == NULL) {
        sol_flow_node_type_gtk_byte_editor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_byte_editor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/byte-editor",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_BYTE_EDITOR",
    .options_symbol = "sol_flow_node_type_gtk_byte_editor_options",
    .description = "A byte's individual bits editor that outputs int packets with the resulting value.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/byte-editor.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The current reading for the editor, after a change",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_byte_editor = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_gtk_byte_editor_init_type_internal,
    .open = gtk_byte_editor_open,
    .close = gtk_byte_editor_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_gtk_byte_editor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_byte_editor_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_BYTE_EDITOR = &sol_flow_node_type_gtk_byte_editor;

static struct sol_flow_port_type_in sol_flow_node_type_gtk_label__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = gtk_label_in_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_gtk_label_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_label__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_label_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_label__in__IN.packet_type == NULL) {
        sol_flow_node_type_gtk_label__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_label_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/label",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_LABEL",
    .options_symbol = "sol_flow_node_type_gtk_label_options",
    .description = "Text output for boolean/int packets.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/label.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Prints the packet's value to a label widget",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_label = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_label_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_gtk_label_init_type_internal,
    .open = gtk_label_open,
    .close = gtk_label_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_gtk_label_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_label_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_LABEL = &sol_flow_node_type_gtk_label;

static struct sol_flow_port_type_in sol_flow_node_type_gtk_led_7seg__in__VALUE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = gtk_led_7seg_value_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_gtk_led_7seg__in__SEGMENTS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = gtk_led_7seg_segments_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_gtk_led_7seg_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_led_7seg__in__VALUE;
    if (port < 2)
        return &sol_flow_node_type_gtk_led_7seg__in__SEGMENTS;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_led_7seg_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_led_7seg__in__VALUE.packet_type == NULL) {
        sol_flow_node_type_gtk_led_7seg__in__VALUE.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_gtk_led_7seg__in__SEGMENTS.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
    }

    log_init();
}

static const struct sol_flow_node_type_gtk_led_7seg_options sol_flow_node_type_gtk_led_7seg_options_defaults = SOL_FLOW_NODE_TYPE_GTK_LED_7SEG_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_led_7seg_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/led-7seg",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_LED_7SEG",
    .options_symbol = "sol_flow_node_type_gtk_led_7seg_options",
    .description = "Widget used to represent led 7 segments.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/led-7seg.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "VALUE",
            .description="Set value to be displayed.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "SEGMENTS",
            .description="Define segments to be on and off. The order expected by the display for each bit is 'abcdefgX', where X is the DP, as described in http://en.wikipedia.org/wiki/Seven-segment_display_character_representations.",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_gtk_led_7seg_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_LED_7SEG_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="common_cathode",
            .description="Set this option to true if type of led is common cathode or set it to false if it's common anode (it'll invert gpio low and high states). It's a dummy option used for compatibility with 'led-7seg/led'.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_7seg_options, common_cathode),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="pin_a",
            .description="Pin used to set segment 'A' state. It's a dummy option used for compatibility with 'led-7seg/led'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_7seg_options, pin_a),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pin_b",
            .description="Pin used to set segment 'B' state. It's a dummy option used for compatibility with 'led-7seg/led'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_7seg_options, pin_b),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pin_c",
            .description="Pin used to set segment 'C' state. It's a dummy option used for compatibility with 'led-7seg/led'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_7seg_options, pin_c),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pin_d",
            .description="Pin used to set segment 'D' state. It's a dummy option used for compatibility with 'led-7seg/led'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_7seg_options, pin_d),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pin_e",
            .description="Pin used to set segment 'E' state. It's a dummy option used for compatibility with 'led-7seg/led'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_7seg_options, pin_e),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pin_f",
            .description="Pin used to set segment 'F' state. It's a dummy option used for compatibility with 'led-7seg/led'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_7seg_options, pin_f),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pin_g",
            .description="Pin used to set segment 'G' state. It's a dummy option used for compatibility with 'led-7seg/led'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_7seg_options, pin_g),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pin_dp",
            .description="Pin used to set segment 'DP' state. It's a dummy option used for compatibility with 'led-7seg/led'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_7seg_options, pin_dp),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_led_7seg = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_type_gtk_led_7seg_options),
    .default_options = &sol_flow_node_type_gtk_led_7seg_options_defaults,
    .init_type = sol_flow_node_type_gtk_led_7seg_init_type_internal,
    .open = gtk_led_7seg_open,
    .close = gtk_led_7seg_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_gtk_led_7seg_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_led_7seg_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_LED_7SEG = &sol_flow_node_type_gtk_led_7seg;

static struct sol_flow_port_type_in sol_flow_node_type_gtk_led__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = gtk_led_in_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_gtk_led_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_led__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_led_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_led__in__IN.packet_type == NULL) {
        sol_flow_node_type_gtk_led__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
    }

    log_init();
}

static const struct sol_flow_node_type_gtk_led_options sol_flow_node_type_gtk_led_options_defaults = SOL_FLOW_NODE_TYPE_GTK_LED_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_led_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/led",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_LED",
    .options_symbol = "sol_flow_node_type_gtk_led_options",
    .description = "Gtk widget that immitates a led. It can receive a rgb or int (1 byte per channel) packet to set its color and turn it on. Or it can receive a boolean packet to turn it on or off. Led's turned off are drawn as black.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/led.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Controls whether the led is on or off",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_gtk_led_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_LED_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="rgb",
            .description="The led's RGB color components",
            .data_type="rgb",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_options, rgb),
            .size=sizeof(struct sol_rgb),
            .defvalue = {
                .rgb={.blue=0, .blue_max=255, .green=0, .green_max=255, .red=0, .red_max=255},
            },
        },
        {
            .name="pin",
            .description="Pin number. It's a dummy option used for compatibility with 'gpio/writer'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_led_options, pin),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_led = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_led_data),
    .options_size = sizeof(struct sol_flow_node_type_gtk_led_options),
    .default_options = &sol_flow_node_type_gtk_led_options_defaults,
    .init_type = sol_flow_node_type_gtk_led_init_type_internal,
    .open = gtk_led_open,
    .close = gtk_led_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_gtk_led_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_led_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_LED = &sol_flow_node_type_gtk_led;

static struct sol_flow_port_type_out sol_flow_node_type_gtk_pushbutton__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_gtk_pushbutton__out__PRESSED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_gtk_pushbutton__out__RELEASED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_pushbutton_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_pushbutton__out__OUT;
    if (port < 2)
        return &sol_flow_node_type_gtk_pushbutton__out__PRESSED;
    if (port < 3)
        return &sol_flow_node_type_gtk_pushbutton__out__RELEASED;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_pushbutton_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_pushbutton__out__OUT.packet_type == NULL) {
        sol_flow_node_type_gtk_pushbutton__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_gtk_pushbutton__out__PRESSED.packet_type = SOL_FLOW_PACKET_TYPE_EMPTY;
        sol_flow_node_type_gtk_pushbutton__out__RELEASED.packet_type = SOL_FLOW_PACKET_TYPE_EMPTY;
    }

    log_init();
}

static const struct sol_flow_node_type_gtk_pushbutton_options sol_flow_node_type_gtk_pushbutton_options_defaults = SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_pushbutton_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/pushbutton",
    .category = "input/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON",
    .options_symbol = "sol_flow_node_type_gtk_pushbutton_options",
    .description = "Emulates a pushbutton that automatically goes up when released",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/pushbutton.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="TRUE when pushed and FALSE when released.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "PRESSED",
            .description="Send an empty packet when the button is pushed.",
            .data_type="empty",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "RELEASED",
            .description="Send an empty packet when the button is released.",
            .data_type="empty",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_gtk_pushbutton_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="pin",
            .description="Pin number. It's a dummy option used for compatibility with 'gpio/reader'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_pushbutton_options, pin),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_pushbutton = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_type_gtk_pushbutton_options),
    .default_options = &sol_flow_node_type_gtk_pushbutton_options_defaults,
    .init_type = sol_flow_node_type_gtk_pushbutton_init_type_internal,
    .open = gtk_pushbutton_open,
    .close = gtk_pushbutton_close,
    .ports_out_count = 3,
    .get_port_out = sol_flow_node_type_gtk_pushbutton_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_pushbutton_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON = &sol_flow_node_type_gtk_pushbutton;

static struct sol_flow_port_type_out sol_flow_node_type_gtk_pwm_editor__out__ENABLED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_gtk_pwm_editor__out__DUTY_CYCLE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_gtk_pwm_editor__out__PERIOD = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_pwm_editor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_pwm_editor__out__ENABLED;
    if (port < 2)
        return &sol_flow_node_type_gtk_pwm_editor__out__DUTY_CYCLE;
    if (port < 3)
        return &sol_flow_node_type_gtk_pwm_editor__out__PERIOD;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_pwm_editor_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_pwm_editor__out__ENABLED.packet_type == NULL) {
        sol_flow_node_type_gtk_pwm_editor__out__ENABLED.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_gtk_pwm_editor__out__DUTY_CYCLE.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_gtk_pwm_editor__out__PERIOD.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_gtk_pwm_editor_options sol_flow_node_type_gtk_pwm_editor_options_defaults = SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_pwm_editor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/pwm-editor",
    .category = "input/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR",
    .options_symbol = "sol_flow_node_type_gtk_pwm_editor_options",
    .description = "Gtk widget that a provides (int and boolean) pwm packets to other nodes.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/pwm-editor.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "ENABLED",
            .description="The current reading for enabled (after an input change)",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "DUTY_CYCLE",
            .description="The current reading for duty cycle (after an input change)",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "PERIOD",
            .description="The current reading for period (after an input change)",
            .data_type="int",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_gtk_pwm_editor_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="range",
            .description="PWM editor range",
            .data_type="irange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_pwm_editor_options, range),
            .size=sizeof(struct sol_irange_spec),
            .defvalue = {
                .irange_spec={.max=100, .min=0, .step=1},
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_pwm_editor = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_type_gtk_pwm_editor_options),
    .default_options = &sol_flow_node_type_gtk_pwm_editor_options_defaults,
    .init_type = sol_flow_node_type_gtk_pwm_editor_init_type_internal,
    .open = gtk_pwm_editor_open,
    .close = gtk_pwm_editor_close,
    .ports_out_count = 3,
    .get_port_out = sol_flow_node_type_gtk_pwm_editor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_pwm_editor_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR = &sol_flow_node_type_gtk_pwm_editor;

static struct sol_flow_port_type_in sol_flow_node_type_gtk_pwm_viewer__in__ENABLED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = gtk_pwm_viewer_enable_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_gtk_pwm_viewer__in__DUTY_CYCLE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = gtk_pwm_viewer_duty_cycle_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_gtk_pwm_viewer__in__PERIOD = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = gtk_pwm_viewer_period_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_gtk_pwm_viewer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_pwm_viewer__in__ENABLED;
    if (port < 2)
        return &sol_flow_node_type_gtk_pwm_viewer__in__DUTY_CYCLE;
    if (port < 3)
        return &sol_flow_node_type_gtk_pwm_viewer__in__PERIOD;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_pwm_viewer_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_pwm_viewer__in__ENABLED.packet_type == NULL) {
        sol_flow_node_type_gtk_pwm_viewer__in__ENABLED.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_gtk_pwm_viewer__in__DUTY_CYCLE.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_gtk_pwm_viewer__in__PERIOD.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_gtk_pwm_viewer_options sol_flow_node_type_gtk_pwm_viewer_options_defaults = SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_pwm_viewer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/pwm-viewer",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER",
    .options_symbol = "sol_flow_node_type_gtk_pwm_viewer_options",
    .description = "Gtk widget that provides a graphical visualization of PWM.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/pwm-viewer.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "ENABLED",
            .description="Controls whether PWM is enabled or disabled.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "DUTY_CYCLE",
            .description="Set duty cycle value.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PERIOD",
            .description="Set period.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_gtk_pwm_viewer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="chip",
            .description="PWM chip. It's a dummy option used for compatibility with 'pwm'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_pwm_viewer_options, chip),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pin",
            .description="PWM pin channel. It's a dummy option used for compatibility with 'pwm'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_pwm_viewer_options, pin),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="inversed_polarity",
            .description="PWM polarity (normal or inversed). It's a dummy option used for compatibility with 'pwm'.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_pwm_viewer_options, inversed_polarity),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="enabled",
            .description="Initial enabled state",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_pwm_viewer_options, enabled),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="period",
            .description="Initial period",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_pwm_viewer_options, period),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="duty_cycle",
            .description="Initial duty cycle",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_pwm_viewer_options, duty_cycle),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_pwm_viewer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_pwm_viewer_data),
    .options_size = sizeof(struct sol_flow_node_type_gtk_pwm_viewer_options),
    .default_options = &sol_flow_node_type_gtk_pwm_viewer_options_defaults,
    .init_type = sol_flow_node_type_gtk_pwm_viewer_init_type_internal,
    .open = gtk_pwm_viewer_open,
    .close = gtk_pwm_viewer_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_gtk_pwm_viewer_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_pwm_viewer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER = &sol_flow_node_type_gtk_pwm_viewer;

static struct sol_flow_port_type_out sol_flow_node_type_gtk_rgb_editor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_rgb_editor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_rgb_editor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_rgb_editor_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_rgb_editor__out__OUT.packet_type == NULL) {
        sol_flow_node_type_gtk_rgb_editor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_rgb_editor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/rgb-editor",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_RGB_EDITOR",
    .options_symbol = "sol_flow_node_type_gtk_rgb_editor_options",
    .description = "A color chooser widget that outputs int packets with RGB color space encoded in the int value.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/rgb-editor.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The current reading for the editor, after a change",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_rgb_editor = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_gtk_rgb_editor_init_type_internal,
    .open = gtk_rgb_editor_open,
    .close = gtk_rgb_editor_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_gtk_rgb_editor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_rgb_editor_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_RGB_EDITOR = &sol_flow_node_type_gtk_rgb_editor;

static struct sol_flow_port_type_out sol_flow_node_type_gtk_direction_vector_editor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_direction_vector_editor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_direction_vector_editor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_direction_vector_editor_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_direction_vector_editor__out__OUT.packet_type == NULL) {
        sol_flow_node_type_gtk_direction_vector_editor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_direction_vector_editor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/direction-vector-editor",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_DIRECTION_VECTOR_EDITOR",
    .options_symbol = "sol_flow_node_type_gtk_direction_vector_editor_options",
    .description = "A direction vector editor chooser widget that outputs a direction vector packet.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/direction-vector-editor.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The current reading for the editor, after a change",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct float_editor_note_type sol_flow_node_type_gtk_direction_vector_editor = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_gtk_direction_vector_editor_init_type_internal,
    .open = gtk_float_editor_open,
    .close = gtk_float_editor_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_gtk_direction_vector_editor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_direction_vector_editor_description,
#endif
},
    .setup_widget = direction_vector_setup,
    .send_output_packet = send_direction_vector_output,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_DIRECTION_VECTOR_EDITOR = &sol_flow_node_type_gtk_direction_vector_editor.base;

static struct sol_flow_port_type_out sol_flow_node_type_gtk_location_editor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_location_editor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_location_editor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_location_editor_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_location_editor__out__OUT.packet_type == NULL) {
        sol_flow_node_type_gtk_location_editor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_LOCATION;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_location_editor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/location-editor",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_LOCATION_EDITOR",
    .options_symbol = "sol_flow_node_type_gtk_location_editor_options",
    .description = "A location editor widget that outputs a location packet.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/location-editor.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The current reading for the editor, after a change",
            .data_type="location",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct float_editor_note_type sol_flow_node_type_gtk_location_editor = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_gtk_location_editor_init_type_internal,
    .open = gtk_float_editor_open,
    .close = gtk_float_editor_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_gtk_location_editor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_location_editor_description,
#endif
},
    .setup_widget = location_setup,
    .send_output_packet = send_location_output,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_LOCATION_EDITOR = &sol_flow_node_type_gtk_location_editor.base;

static struct sol_flow_port_type_out sol_flow_node_type_gtk_timestamp_editor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_timestamp_editor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_timestamp_editor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_timestamp_editor_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_timestamp_editor__out__OUT.packet_type == NULL) {
        sol_flow_node_type_gtk_timestamp_editor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_TIMESTAMP;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_timestamp_editor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/timestamp-editor",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_TIMESTAMP_EDITOR",
    .options_symbol = "sol_flow_node_type_gtk_timestamp_editor_options",
    .description = "A timestamp editor widget that outputs a timestamp packet.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/timestamp-editor.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The current reading for the editor, after a change",
            .data_type="timestamp",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_timestamp_editor = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_gtk_timestamp_editor_init_type_internal,
    .open = gtk_timestamp_editor_open,
    .close = gtk_timestamp_editor_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_gtk_timestamp_editor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_timestamp_editor_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_TIMESTAMP_EDITOR = &sol_flow_node_type_gtk_timestamp_editor;

static struct sol_flow_port_type_out sol_flow_node_type_gtk_float_editor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_float_editor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_float_editor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_float_editor_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_float_editor__out__OUT.packet_type == NULL) {
        sol_flow_node_type_gtk_float_editor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_float_editor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/float-editor",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_FLOAT_EDITOR",
    .options_symbol = "sol_flow_node_type_gtk_float_editor_options",
    .description = "A float editor widget that outputs a float packet.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/float-editor.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The current reading for the editor, after a change",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct float_editor_note_type sol_flow_node_type_gtk_float_editor = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_gtk_float_editor_init_type_internal,
    .open = gtk_float_editor_open,
    .close = gtk_float_editor_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_gtk_float_editor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_float_editor_description,
#endif
},
    .setup_widget = float_setup,
    .send_output_packet = send_float_output,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_FLOAT_EDITOR = &sol_flow_node_type_gtk_float_editor.base;

static struct sol_flow_port_type_out sol_flow_node_type_gtk_slider__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_slider_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_slider__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_slider_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_slider__out__OUT.packet_type == NULL) {
        sol_flow_node_type_gtk_slider__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_gtk_slider_options sol_flow_node_type_gtk_slider_options_defaults = SOL_FLOW_NODE_TYPE_GTK_SLIDER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_slider_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/slider",
    .category = "input/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_SLIDER",
    .options_symbol = "sol_flow_node_type_gtk_slider_options",
    .description = "Slider that provides (int) input packets to other nodes",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/slider.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The current reading for the slider (after an input change)",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_gtk_slider_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_SLIDER_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="range",
            .description="Slider's range",
            .data_type="irange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_slider_options, range),
            .size=sizeof(struct sol_irange_spec),
            .defvalue = {
                .irange_spec={.max=100, .min=0, .step=1},
            },
        },
        {
            .name="device",
            .description="Device number on platform. It's a dummy option used for compatibility with 'aio/reader'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_slider_options, device),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pin",
            .description="Pin number. It's a dummy option used for compatibility with 'aio/reader'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_slider_options, pin),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_slider = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_type_gtk_slider_options),
    .default_options = &sol_flow_node_type_gtk_slider_options_defaults,
    .init_type = sol_flow_node_type_gtk_slider_init_type_internal,
    .open = gtk_slider_open,
    .close = gtk_slider_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_gtk_slider_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_slider_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_SLIDER = &sol_flow_node_type_gtk_slider;

static struct sol_flow_port_type_out sol_flow_node_type_gtk_spinbutton__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_spinbutton_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_spinbutton__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_spinbutton_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_spinbutton__out__OUT.packet_type == NULL) {
        sol_flow_node_type_gtk_spinbutton__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_gtk_spinbutton_options sol_flow_node_type_gtk_spinbutton_options_defaults = SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_spinbutton_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/spinbutton",
    .category = "input/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON",
    .options_symbol = "sol_flow_node_type_gtk_spinbutton_options",
    .description = "Spinbutton that provides (int) input packets to other nodes",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/spinbutton.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The current reading for the spinbutton (after an input change)",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_gtk_spinbutton_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="range",
            .description="Spinbutton's range (min / max / step).",
            .data_type="irange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_spinbutton_options, range),
            .size=sizeof(struct sol_irange_spec),
            .defvalue = {
                .irange_spec={.max=INT32_MAX, .min=INT32_MIN, .step=1},
            },
        },
        {
            .name="value",
            .description="Spinbutton's initial value.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_spinbutton_options, value),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="device",
            .description="Device number on platform. It's a dummy option used for compatibility with 'aio/reader'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_spinbutton_options, device),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pin",
            .description="Pin number. It's a dummy option used for compatibility with 'aio/reader'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_spinbutton_options, pin),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_spinbutton = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_type_gtk_spinbutton_options),
    .default_options = &sol_flow_node_type_gtk_spinbutton_options_defaults,
    .init_type = sol_flow_node_type_gtk_spinbutton_init_type_internal,
    .open = gtk_spinbutton_open,
    .close = gtk_spinbutton_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_gtk_spinbutton_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_spinbutton_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON = &sol_flow_node_type_gtk_spinbutton;

static struct sol_flow_port_type_out sol_flow_node_type_gtk_toggle__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_gtk_toggle_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_gtk_toggle__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_gtk_toggle_init_type_internal(void)
{
    if (sol_flow_node_type_gtk_toggle__out__OUT.packet_type == NULL) {
        sol_flow_node_type_gtk_toggle__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_gtk_toggle_options sol_flow_node_type_gtk_toggle_options_defaults = SOL_FLOW_NODE_TYPE_GTK_TOGGLE_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_gtk_toggle_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "gtk/toggle",
    .category = "input/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_GTK_TOGGLE",
    .options_symbol = "sol_flow_node_type_gtk_toggle_options",
    .description = "Toggle that provides boolean input packets to other nodes",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/gtk/toggle.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The current reading for the toggle (after an input change)",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_gtk_toggle_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_GTK_TOGGLE_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="pin",
            .description="Pin number. It's a dummy option used for compatibility with 'gpio/reader'.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_gtk_toggle_options, pin),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_gtk_toggle = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct gtk_common_data),
    .options_size = sizeof(struct sol_flow_node_type_gtk_toggle_options),
    .default_options = &sol_flow_node_type_gtk_toggle_options_defaults,
    .init_type = sol_flow_node_type_gtk_toggle_init_type_internal,
    .open = gtk_toggle_open,
    .close = gtk_toggle_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_gtk_toggle_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_gtk_toggle_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_GTK_TOGGLE = &sol_flow_node_type_gtk_toggle;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_gtk(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_gtk(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_GTK_BYTE_EDITOR,
            &SOL_FLOW_NODE_TYPE_GTK_LABEL,
            &SOL_FLOW_NODE_TYPE_GTK_LED_7SEG,
            &SOL_FLOW_NODE_TYPE_GTK_LED,
            &SOL_FLOW_NODE_TYPE_GTK_PUSHBUTTON,
            &SOL_FLOW_NODE_TYPE_GTK_PWM_EDITOR,
            &SOL_FLOW_NODE_TYPE_GTK_PWM_VIEWER,
            &SOL_FLOW_NODE_TYPE_GTK_RGB_EDITOR,
            &SOL_FLOW_NODE_TYPE_GTK_DIRECTION_VECTOR_EDITOR,
            &SOL_FLOW_NODE_TYPE_GTK_LOCATION_EDITOR,
            &SOL_FLOW_NODE_TYPE_GTK_TIMESTAMP_EDITOR,
            &SOL_FLOW_NODE_TYPE_GTK_FLOAT_EDITOR,
            &SOL_FLOW_NODE_TYPE_GTK_SLIDER,
            &SOL_FLOW_NODE_TYPE_GTK_SPINBUTTON,
            &SOL_FLOW_NODE_TYPE_GTK_TOGGLE,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
