/* this file was auto-generated from ./src/modules/flow/http-client/http-client.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_HTTP_CLIENT_DEFINED
#include "sol-flow/http-client.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_http_client_boolean__in__URL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_url_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_boolean__in__GET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_boolean__in__POST = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = boolean_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_boolean__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_boolean_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_boolean__in__URL;
    if (port < 2)
        return &sol_flow_node_type_http_client_boolean__in__GET;
    if (port < 3)
        return &sol_flow_node_type_http_client_boolean__in__POST;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_boolean_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_boolean__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_boolean_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_boolean__in__URL.packet_type == NULL) {
        sol_flow_node_type_http_client_boolean__in__URL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_boolean__in__GET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_boolean__in__POST.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_http_client_boolean__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_boolean_options sol_flow_node_type_http_client_boolean_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_BOOLEAN_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_boolean_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/boolean",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_BOOLEAN",
    .options_symbol = "sol_flow_node_type_http_client_boolean_options",
    .description = "HTTP Client for boolean",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/boolean.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "URL",
            .description="Replace the url set on options",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET",
            .description="Get the contents of the specified url",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST",
            .description="Post into the url",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The value received from the url",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_boolean_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_BOOLEAN_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="url",
            .description="The url that will be used on request and posts",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_boolean_options, url),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="machine_id",
            .description="If the machine_id should be set on every request made",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_boolean_options, machine_id),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="strict",
            .description="Enforce the response content type, if it does not match if the requested one, ignore it.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_boolean_options, strict),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="accept",
            .description="The desired content type of the response",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_boolean_options, accept),
            .size=sizeof(const char *),
            .defvalue = {
                .s="text/stream, application/json, text/plain",
            },
        },
            {},

        },
    }),
};
#endif

static const struct http_client_node_type sol_flow_node_type_http_client_boolean = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_boolean_options),
    .default_options = &sol_flow_node_type_http_client_boolean_options_defaults,
    .init_type = sol_flow_node_type_http_client_boolean_init_type_internal,
    .open = common_open,
    .close = common_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_http_client_boolean_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_boolean_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_boolean_description,
#endif
},
    .process_data = boolean_process_data,
    .process_json = boolean_process_json,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_BOOLEAN = &sol_flow_node_type_http_client_boolean.base;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_string__in__URL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_url_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_string__in__GET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_string__in__POST = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = string_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_string__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_string_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_string__in__URL;
    if (port < 2)
        return &sol_flow_node_type_http_client_string__in__GET;
    if (port < 3)
        return &sol_flow_node_type_http_client_string__in__POST;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_string_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_string__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_string_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_string__in__URL.packet_type == NULL) {
        sol_flow_node_type_http_client_string__in__URL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_string__in__GET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_string__in__POST.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_string__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_string_options sol_flow_node_type_http_client_string_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_STRING_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_string_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/string",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_STRING",
    .options_symbol = "sol_flow_node_type_http_client_string_options",
    .description = "HTTP Client for string",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/string.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "URL",
            .description="Replace the url set on options",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET",
            .description="Get the contents of the specified url",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST",
            .description="Post into the url",
            .data_type="string",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The value received from the url",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_string_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_STRING_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="url",
            .description="The url that will be used on request and posts",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_string_options, url),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="machine_id",
            .description="If the machine_id should be set on every request made",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_string_options, machine_id),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="strict",
            .description="Enforce the response content type, if it does not match if the requested one, ignore it.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_string_options, strict),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="accept",
            .description="The desired content type of the response",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_string_options, accept),
            .size=sizeof(const char *),
            .defvalue = {
                .s="text/stream, text/plain",
            },
        },
            {},

        },
    }),
};
#endif

static const struct http_client_node_type sol_flow_node_type_http_client_string = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_string_options),
    .default_options = &sol_flow_node_type_http_client_string_options_defaults,
    .init_type = sol_flow_node_type_http_client_string_init_type_internal,
    .open = common_open,
    .close = common_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_http_client_string_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_string_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_string_description,
#endif
},
    .process_data = string_process_data,
    .process_json = string_process_json,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_STRING = &sol_flow_node_type_http_client_string.base;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_rgb__in__URL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_url_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_rgb__in__GET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_rgb__in__POST = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = rgb_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_rgb__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_rgb_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_rgb__in__URL;
    if (port < 2)
        return &sol_flow_node_type_http_client_rgb__in__GET;
    if (port < 3)
        return &sol_flow_node_type_http_client_rgb__in__POST;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_rgb_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_rgb__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_rgb_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_rgb__in__URL.packet_type == NULL) {
        sol_flow_node_type_http_client_rgb__in__URL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_rgb__in__GET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_rgb__in__POST.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
        sol_flow_node_type_http_client_rgb__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_rgb_options sol_flow_node_type_http_client_rgb_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_RGB_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_rgb_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/rgb",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_RGB",
    .options_symbol = "sol_flow_node_type_http_client_rgb_options",
    .description = "HTTP Client for RGB",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/rgb.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "URL",
            .description="Replace the url set on options",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET",
            .description="Get the contents of the specified url",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST",
            .description="Post into the url",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The value received from the url",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_rgb_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_RGB_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="url",
            .description="The url that will be used on request and posts",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_http_client_rgb_options, url),
            .size=sizeof(const char *),
        },
        {
            .name="machine_id",
            .description="If the machine_id should be set on every request made",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_rgb_options, machine_id),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="strict",
            .description="Enforce the response content type, if it does not match if the requested one, ignore it.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_rgb_options, strict),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="accept",
            .description="The desired content type of the response",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_rgb_options, accept),
            .size=sizeof(const char *),
            .defvalue = {
                .s="text/stream, application/json, text/plain",
            },
        },
            {},

        },
    }),
};
#endif

static const struct http_client_node_type sol_flow_node_type_http_client_rgb = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_rgb_options),
    .default_options = &sol_flow_node_type_http_client_rgb_options_defaults,
    .init_type = sol_flow_node_type_http_client_rgb_init_type_internal,
    .open = common_open,
    .close = common_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_http_client_rgb_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_rgb_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_rgb_description,
#endif
},
    .process_data = rgb_process_data,
    .process_json = rgb_process_json,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_RGB = &sol_flow_node_type_http_client_rgb.base;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_direction_vector__in__URL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_url_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_direction_vector__in__GET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_direction_vector__in__POST = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = direction_vector_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_direction_vector__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_direction_vector_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_direction_vector__in__URL;
    if (port < 2)
        return &sol_flow_node_type_http_client_direction_vector__in__GET;
    if (port < 3)
        return &sol_flow_node_type_http_client_direction_vector__in__POST;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_direction_vector_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_direction_vector__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_direction_vector_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_direction_vector__in__URL.packet_type == NULL) {
        sol_flow_node_type_http_client_direction_vector__in__URL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_direction_vector__in__GET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_direction_vector__in__POST.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
        sol_flow_node_type_http_client_direction_vector__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_direction_vector_options sol_flow_node_type_http_client_direction_vector_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_DIRECTION_VECTOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_direction_vector_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/direction-vector",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_DIRECTION_VECTOR",
    .options_symbol = "sol_flow_node_type_http_client_direction_vector_options",
    .description = "HTTP Client for direction vector",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/direction-vector.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "URL",
            .description="Replace the url set on options",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET",
            .description="Get the contents of the specified url",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST",
            .description="Post into the url",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The value received from the url",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_direction_vector_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_DIRECTION_VECTOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="url",
            .description="The url that will be used on request and posts",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_http_client_direction_vector_options, url),
            .size=sizeof(const char *),
        },
        {
            .name="machine_id",
            .description="If the machine_id should be set on every request made",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_direction_vector_options, machine_id),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="strict",
            .description="Enforce the response content type, if it does not match if the requested one, ignore it.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_direction_vector_options, strict),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="accept",
            .description="The desired content type of the response",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_direction_vector_options, accept),
            .size=sizeof(const char *),
            .defvalue = {
                .s="text/stream, application/json, text/plain",
            },
        },
            {},

        },
    }),
};
#endif

static const struct http_client_node_type sol_flow_node_type_http_client_direction_vector = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_direction_vector_options),
    .default_options = &sol_flow_node_type_http_client_direction_vector_options_defaults,
    .init_type = sol_flow_node_type_http_client_direction_vector_init_type_internal,
    .open = common_open,
    .close = common_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_http_client_direction_vector_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_direction_vector_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_direction_vector_description,
#endif
},
    .process_data = direction_vector_process_data,
    .process_json = direction_vector_process_json,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_DIRECTION_VECTOR = &sol_flow_node_type_http_client_direction_vector.base;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_int__in__URL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_url_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_int__in__GET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_int__in__POST = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = int_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_int__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_int_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_int__in__URL;
    if (port < 2)
        return &sol_flow_node_type_http_client_int__in__GET;
    if (port < 3)
        return &sol_flow_node_type_http_client_int__in__POST;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_int_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_int__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_int_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_int__in__URL.packet_type == NULL) {
        sol_flow_node_type_http_client_int__in__URL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_int__in__GET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_int__in__POST.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_http_client_int__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_int_options sol_flow_node_type_http_client_int_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_INT_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_int_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/int",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_INT",
    .options_symbol = "sol_flow_node_type_http_client_int_options",
    .description = "HTTP Client for int",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/int.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "URL",
            .description="Replace the url set on options",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET",
            .description="Get the contents of the specified url",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST",
            .description="Post into the url",
            .data_type="int",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The value received from the url",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_int_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_INT_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="url",
            .description="The url that will be used on request and posts",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_int_options, url),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="machine_id",
            .description="If the machine_id should be set on every request made",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_int_options, machine_id),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="strict",
            .description="Enforce the response content type, if it does not match if the requested one, ignore it.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_int_options, strict),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="accept",
            .description="The desired content type of the response",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_int_options, accept),
            .size=sizeof(const char *),
            .defvalue = {
                .s="text/stream, application/json, text/plain",
            },
        },
            {},

        },
    }),
};
#endif

static const struct http_client_node_type sol_flow_node_type_http_client_int = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_int_options),
    .default_options = &sol_flow_node_type_http_client_int_options_defaults,
    .init_type = sol_flow_node_type_http_client_int_init_type_internal,
    .open = common_open,
    .close = common_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_http_client_int_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_int_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_int_description,
#endif
},
    .process_data = int_process_data,
    .process_json = int_process_json,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_INT = &sol_flow_node_type_http_client_int.base;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_float__in__URL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_url_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_float__in__GET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_float__in__POST = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = float_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_float__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_float_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_float__in__URL;
    if (port < 2)
        return &sol_flow_node_type_http_client_float__in__GET;
    if (port < 3)
        return &sol_flow_node_type_http_client_float__in__POST;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_float_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_float__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_float_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_float__in__URL.packet_type == NULL) {
        sol_flow_node_type_http_client_float__in__URL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_float__in__GET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_float__in__POST.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_http_client_float__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_float_options sol_flow_node_type_http_client_float_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_FLOAT_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_float_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/float",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_FLOAT",
    .options_symbol = "sol_flow_node_type_http_client_float_options",
    .description = "HTTP Client for float",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/float.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "URL",
            .description="Replace the url set on options",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET",
            .description="Get the contents of the specified url",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST",
            .description="Post into the url",
            .data_type="float",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The value received from the url",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_float_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_FLOAT_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="url",
            .description="The url that will be used on request and posts",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_float_options, url),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="machine_id",
            .description="If the machine_id should be set on every request made",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_float_options, machine_id),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="strict",
            .description="Enforce the response content type, if it does not match if the requested one, ignore it.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_float_options, strict),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="accept",
            .description="The desired content type of the response",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_float_options, accept),
            .size=sizeof(const char *),
            .defvalue = {
                .s="text/stream, application/json, text/plain",
            },
        },
            {},

        },
    }),
};
#endif

static const struct http_client_node_type sol_flow_node_type_http_client_float = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_float_options),
    .default_options = &sol_flow_node_type_http_client_float_options_defaults,
    .init_type = sol_flow_node_type_http_client_float_init_type_internal,
    .open = common_open,
    .close = common_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_http_client_float_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_float_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_float_description,
#endif
},
    .process_data = float_process_data,
    .process_json = float_process_json,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_FLOAT = &sol_flow_node_type_http_client_float.base;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_blob__in__URL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_url_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_blob__in__GET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_blob__in__POST = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = blob_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_blob__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_blob_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_blob__in__URL;
    if (port < 2)
        return &sol_flow_node_type_http_client_blob__in__GET;
    if (port < 3)
        return &sol_flow_node_type_http_client_blob__in__POST;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_blob_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_blob__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_blob_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_blob__in__URL.packet_type == NULL) {
        sol_flow_node_type_http_client_blob__in__URL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_blob__in__GET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_blob__in__POST.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
        sol_flow_node_type_http_client_blob__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_blob_options sol_flow_node_type_http_client_blob_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_BLOB_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_blob_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/blob",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_BLOB",
    .options_symbol = "sol_flow_node_type_http_client_blob_options",
    .description = "HTTP client for blob",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/blob.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "URL",
            .description="The url to make a GET request",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET",
            .description="Execute the GET request",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST",
            .description="Execute the GET request",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The values received from the request.",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_blob_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_BLOB_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="url",
            .description="The url to make a GET request",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_blob_options, url),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="machine_id",
            .description="If the machine_id should be set on every request made",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_blob_options, machine_id),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="strict",
            .description="Enforce the response content type, if it does not match if the requested one, ignore it.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_blob_options, strict),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="accept",
            .description="The desired content type of the response",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_blob_options, accept),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct http_client_node_type sol_flow_node_type_http_client_blob = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_blob_options),
    .default_options = &sol_flow_node_type_http_client_blob_options_defaults,
    .init_type = sol_flow_node_type_http_client_blob_init_type_internal,
    .open = common_open,
    .close = common_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_http_client_blob_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_blob_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_blob_description,
#endif
},
    .process_data = get_blob_process,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_BLOB = &sol_flow_node_type_http_client_blob.base;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_json__in__URL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_url_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_json__in__GET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_json__in__POST_OBJECT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = json_object_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_json__in__POST_ARRAY = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = json_array_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_json__in__POST_BOOLEAN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = boolean_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_json__in__POST_STRING = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = json_string_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_json__in__POST_INT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = json_int_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_json__in__POST_FLOAT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = json_float_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_json__in__POST_NULL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = json_null_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_json__out__OBJECT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_json__out__ARRAY = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_json__out__BOOLEAN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_json__out__STRING = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_json__out__INT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_json__out__FLOAT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_json__out__NULL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_json_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_json__in__URL;
    if (port < 2)
        return &sol_flow_node_type_http_client_json__in__GET;
    if (port < 3)
        return &sol_flow_node_type_http_client_json__in__POST_OBJECT;
    if (port < 4)
        return &sol_flow_node_type_http_client_json__in__POST_ARRAY;
    if (port < 5)
        return &sol_flow_node_type_http_client_json__in__POST_BOOLEAN;
    if (port < 6)
        return &sol_flow_node_type_http_client_json__in__POST_STRING;
    if (port < 7)
        return &sol_flow_node_type_http_client_json__in__POST_INT;
    if (port < 8)
        return &sol_flow_node_type_http_client_json__in__POST_FLOAT;
    if (port < 9)
        return &sol_flow_node_type_http_client_json__in__POST_NULL;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_json_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_json__out__OBJECT;
    if (port < 2)
        return &sol_flow_node_type_http_client_json__out__ARRAY;
    if (port < 3)
        return &sol_flow_node_type_http_client_json__out__BOOLEAN;
    if (port < 4)
        return &sol_flow_node_type_http_client_json__out__STRING;
    if (port < 5)
        return &sol_flow_node_type_http_client_json__out__INT;
    if (port < 6)
        return &sol_flow_node_type_http_client_json__out__FLOAT;
    if (port < 7)
        return &sol_flow_node_type_http_client_json__out__NULL;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_json_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_json__in__URL.packet_type == NULL) {
        sol_flow_node_type_http_client_json__in__URL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_json__in__GET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_json__in__POST_OBJECT.packet_type = SOL_FLOW_PACKET_TYPE_JSON_OBJECT;
        sol_flow_node_type_http_client_json__in__POST_ARRAY.packet_type = SOL_FLOW_PACKET_TYPE_JSON_ARRAY;
        sol_flow_node_type_http_client_json__in__POST_BOOLEAN.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_http_client_json__in__POST_STRING.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_json__in__POST_INT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_http_client_json__in__POST_FLOAT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_http_client_json__in__POST_NULL.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_json__out__OBJECT.packet_type = SOL_FLOW_PACKET_TYPE_JSON_OBJECT;
        sol_flow_node_type_http_client_json__out__ARRAY.packet_type = SOL_FLOW_PACKET_TYPE_JSON_ARRAY;
        sol_flow_node_type_http_client_json__out__BOOLEAN.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_http_client_json__out__STRING.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_json__out__INT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_http_client_json__out__FLOAT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_http_client_json__out__NULL.packet_type = SOL_FLOW_PACKET_TYPE_EMPTY;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_json_options sol_flow_node_type_http_client_json_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_JSON_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_json_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/json",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_JSON",
    .options_symbol = "sol_flow_node_type_http_client_json_options",
    .description = "HTTP client for JSON",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/json.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "URL",
            .description="The URL to make a GET/POST request",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET",
            .description="Execute the GET request",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST_OBJECT",
            .description="POST a json-object",
            .data_type="json-object",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST_ARRAY",
            .description="POST a json-array",
            .data_type="json-array",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST_BOOLEAN",
            .description="POST a json boolean",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=4,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST_STRING",
            .description="POST a json string",
            .data_type="string",
            .array_size=0,
            .base_port_idx=5,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST_INT",
            .description="POST a json int - Only the irange value will be sent (min, max and step will be ignored).",
            .data_type="int",
            .array_size=0,
            .base_port_idx=6,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST_FLOAT",
            .description="POST a json float - Only the drange value will be sent (min, max and step will be ignored).",
            .data_type="float",
            .array_size=0,
            .base_port_idx=7,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "POST_NULL",
            .description="POST a json NULL",
            .data_type="any",
            .array_size=0,
            .base_port_idx=8,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OBJECT",
            .description="The response as json-object",
            .data_type="json-object",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "ARRAY",
            .description="The response as json-array",
            .data_type="json-array",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "BOOLEAN",
            .description="The response as json boolean",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "STRING",
            .description="The response as json string",
            .data_type="string",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "INT",
            .description="if the json value is an integer, the int packet is created with that as value and default range (min as INT32_MIN, max as INT32_MAX and step as 1)",
            .data_type="int",
            .array_size=0,
            .base_port_idx=4,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "FLOAT",
            .description="if the json value is a float, the float packet is created with that as value and default range (min as -DBL_MAX, max as DBL_MAX and step as DBL_MIN)",
            .data_type="float",
            .array_size=0,
            .base_port_idx=5,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "NULL",
            .description="If the json value is null, then an empty packet is emitted",
            .data_type="empty",
            .array_size=0,
            .base_port_idx=6,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_json_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_JSON_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="url",
            .description="The URL to make a GET request",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_json_options, url),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="machine_id",
            .description="If the machine_id should be set on every request made",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_json_options, machine_id),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="strict",
            .description="Enforce the response content type, if it does not match if the requested one, ignore it.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_json_options, strict),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="accept",
            .description="The desired content type of the response",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_json_options, accept),
            .size=sizeof(const char *),
            .defvalue = {
                .s="text/stream, application/json, text/plain",
            },
        },
            {},

        },
    }),
};
#endif

static const struct http_client_node_type sol_flow_node_type_http_client_json = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_json_options),
    .default_options = &sol_flow_node_type_http_client_json_options_defaults,
    .init_type = sol_flow_node_type_http_client_json_init_type_internal,
    .open = common_open,
    .close = common_close,
    .ports_in_count = 9,
    .get_port_in = sol_flow_node_type_http_client_json_get_port_in_internal,
    .ports_out_count = 7,
    .get_port_out = sol_flow_node_type_http_client_json_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_json_description,
#endif
},
    .process_data = get_json_process,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_JSON = &sol_flow_node_type_http_client_json.base;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__URL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = generic_url_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__METHOD = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_method_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__TIMEOUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_timeout_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__PARAM_QUERY = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_param_query_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__PARAM_COOKIE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_param_cookie_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__PARAM_POST = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_param_post_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__PARAM_HEADER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_param_header_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__USER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_user_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__PASSWORD = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_password_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__ACCEPT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_accept_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__CONTENT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_content_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__TRIGGER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_trigger_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_request__in__CLEAR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = request_node_clear_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_request__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_request_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_request__in__URL;
    if (port < 2)
        return &sol_flow_node_type_http_client_request__in__METHOD;
    if (port < 3)
        return &sol_flow_node_type_http_client_request__in__TIMEOUT;
    if (port < 4)
        return &sol_flow_node_type_http_client_request__in__PARAM_QUERY;
    if (port < 5)
        return &sol_flow_node_type_http_client_request__in__PARAM_COOKIE;
    if (port < 6)
        return &sol_flow_node_type_http_client_request__in__PARAM_POST;
    if (port < 7)
        return &sol_flow_node_type_http_client_request__in__PARAM_HEADER;
    if (port < 8)
        return &sol_flow_node_type_http_client_request__in__USER;
    if (port < 9)
        return &sol_flow_node_type_http_client_request__in__PASSWORD;
    if (port < 10)
        return &sol_flow_node_type_http_client_request__in__ACCEPT;
    if (port < 11)
        return &sol_flow_node_type_http_client_request__in__CONTENT;
    if (port < 12)
        return &sol_flow_node_type_http_client_request__in__TRIGGER;
    if (port < 13)
        return &sol_flow_node_type_http_client_request__in__CLEAR;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_request_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_request__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_request_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_request__in__URL.packet_type == NULL) {
        sol_flow_node_type_http_client_request__in__URL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_request__in__METHOD.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_request__in__TIMEOUT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_http_client_request__in__PARAM_QUERY.packet_type = sol_flow_node_type_http_client_request_get_composed_string_string_packet_type();
        sol_flow_node_type_http_client_request__in__PARAM_COOKIE.packet_type = sol_flow_node_type_http_client_request_get_composed_string_string_packet_type();
        sol_flow_node_type_http_client_request__in__PARAM_POST.packet_type = sol_flow_node_type_http_client_request_get_composed_string_string_packet_type();
        sol_flow_node_type_http_client_request__in__PARAM_HEADER.packet_type = sol_flow_node_type_http_client_request_get_composed_string_string_packet_type();
        sol_flow_node_type_http_client_request__in__USER.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_request__in__PASSWORD.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_request__in__ACCEPT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_request__in__CONTENT.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
        sol_flow_node_type_http_client_request__in__TRIGGER.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_request__in__CLEAR.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_request__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_HTTP_RESPONSE;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_request_options sol_flow_node_type_http_client_request_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_REQUEST_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_request_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/request",
    .category = "http-generic",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_REQUEST",
    .options_symbol = "sol_flow_node_type_http_client_request_options",
    .description = "Make a HTTP request at a given URL and outputs its content as http-response",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/get-request.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "URL",
            .description="The URL to make a GET request",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "METHOD",
            .description="The http method to use while making the request",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "TIMEOUT",
            .description="The HTTP request timeout",
            .data_type="int",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PARAM_QUERY",
            .description="Appends a new query parameter",
            .data_type="composed:string,string",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PARAM_COOKIE",
            .description="Appends a new cookie parameter",
            .data_type="composed:string,string",
            .array_size=0,
            .base_port_idx=4,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PARAM_POST",
            .description="Appends a new post parameter",
            .data_type="composed:string,string",
            .array_size=0,
            .base_port_idx=5,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PARAM_HEADER",
            .description="Appends a new header parameter",
            .data_type="composed:string,string",
            .array_size=0,
            .base_port_idx=6,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "USER",
            .description="The user name to authenticate. If the URL provided using the URL port or the opiton already contains an user, it will be overrided.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=7,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PASSWORD",
            .description="The password to authenticate. If the URL provided using the URL port or the opiton already contains a password, it will be overrided.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=8,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "ACCEPT",
            .description="The acceptable response type",
            .data_type="string",
            .array_size=0,
            .base_port_idx=9,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "CONTENT",
            .description="The payload",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=10,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "TRIGGER",
            .description="Execute the request",
            .data_type="any",
            .array_size=0,
            .base_port_idx=11,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "CLEAR",
            .description="Clear all accumulated params, content-type and content",
            .data_type="any",
            .array_size=0,
            .base_port_idx=12,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The HTTP response",
            .data_type="http-response",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_request_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_REQUEST_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="url",
            .description="The URL to make a request",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_request_options, url),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="method",
            .description="The HTTP Method: GET, POST, HEAD, PUT,..",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_request_options, method),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="timeout",
            .description="The number of milliseconds to wait for the request to be completed",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_request_options, timeout),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="allow_redir",
            .description="Allow redirections to be followed",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_request_options, allow_redir),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="machine_id",
            .description="If the machine_id should be set on every request made",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_request_options, machine_id),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
            {},

        },
    }),
};
#endif

static const struct http_client_node_type sol_flow_node_type_http_client_request = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_request_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_request_options),
    .default_options = &sol_flow_node_type_http_client_request_options_defaults,
    .init_type = sol_flow_node_type_http_client_request_init_type_internal,
    .open = request_node_open,
    .close = common_close,
    .ports_in_count = 13,
    .get_port_in = sol_flow_node_type_http_client_request_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_request_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_request_description,
#endif
},
    .setup_params = request_node_setup_params,
    .http_response = request_node_http_response,
    .close_node = request_node_close,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_REQUEST = &sol_flow_node_type_http_client_request.base;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_get_response_code__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_response_code,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_get_response_code__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_get_response_code_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_response_code__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_get_response_code_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_response_code__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_get_response_code_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_get_response_code__in__IN.packet_type == NULL) {
        sol_flow_node_type_http_client_get_response_code__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_HTTP_RESPONSE;
        sol_flow_node_type_http_client_get_response_code__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_get_response_code_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/get-response-code",
    .category = "http-generic",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_RESPONSE_CODE",
    .options_symbol = "sol_flow_node_type_http_client_get_response_code_options",
    .description = "Get the response code from a HTTP response",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/get-response-code.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="The http response",
            .data_type="http-response",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The http response code",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_http_client_get_response_code = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_http_client_get_response_code_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_http_client_get_response_code_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_get_response_code_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_get_response_code_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_RESPONSE_CODE = &sol_flow_node_type_http_client_get_response_code;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_get_url__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_url,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_get_url__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_get_url_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_url__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_get_url_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_url__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_get_url_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_get_url__in__IN.packet_type == NULL) {
        sol_flow_node_type_http_client_get_url__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_HTTP_RESPONSE;
        sol_flow_node_type_http_client_get_url__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_get_url_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/get-url",
    .category = "http-generic",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_URL",
    .options_symbol = "sol_flow_node_type_http_client_get_url_options",
    .description = "Get the URL from a HTTP response",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/get-url.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="The http response",
            .data_type="http-response",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The http response URL",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_http_client_get_url = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_http_client_get_url_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_http_client_get_url_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_get_url_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_get_url_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_URL = &sol_flow_node_type_http_client_get_url;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_get_content_type__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_content_type,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_get_content_type__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_get_content_type_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_content_type__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_get_content_type_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_content_type__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_get_content_type_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_get_content_type__in__IN.packet_type == NULL) {
        sol_flow_node_type_http_client_get_content_type__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_HTTP_RESPONSE;
        sol_flow_node_type_http_client_get_content_type__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_get_content_type_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/get-content-type",
    .category = "http-generic",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_CONTENT_TYPE",
    .options_symbol = "sol_flow_node_type_http_client_get_content_type_options",
    .description = "Get the content type from a HTTP response",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/get-content-type.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="The http response",
            .data_type="http-response",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The http response content type",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_http_client_get_content_type = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_http_client_get_content_type_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_http_client_get_content_type_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_get_content_type_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_get_content_type_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_CONTENT_TYPE = &sol_flow_node_type_http_client_get_content_type;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_get_content__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_blob,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_get_content__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_get_content_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_content__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_get_content_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_content__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_get_content_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_get_content__in__IN.packet_type == NULL) {
        sol_flow_node_type_http_client_get_content__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_HTTP_RESPONSE;
        sol_flow_node_type_http_client_get_content__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_get_content_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/get-content",
    .category = "http-generic",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_CONTENT",
    .options_symbol = "sol_flow_node_type_http_client_get_content_options",
    .description = "Get the content from a HTTP response",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/get-blob.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="The http response",
            .data_type="http-response",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The http response blob",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_http_client_get_content = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_http_client_get_content_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_http_client_get_content_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_get_content_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_get_content_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_CONTENT = &sol_flow_node_type_http_client_get_content;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__PROTOCOL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_scheme_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__USER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_user_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__PASSWORD = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_password_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__PORT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_port_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__SERVER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_host_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__PATH = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_path_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__FRAGMENT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_fragment_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__BASE_URI = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_base_uri_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__PARAM = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_query_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__CLEAR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_clear_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_create_url__in__CREATE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = create_url_create_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_create_url__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_create_url_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_create_url__in__PROTOCOL;
    if (port < 2)
        return &sol_flow_node_type_http_client_create_url__in__USER;
    if (port < 3)
        return &sol_flow_node_type_http_client_create_url__in__PASSWORD;
    if (port < 4)
        return &sol_flow_node_type_http_client_create_url__in__PORT;
    if (port < 5)
        return &sol_flow_node_type_http_client_create_url__in__SERVER;
    if (port < 6)
        return &sol_flow_node_type_http_client_create_url__in__PATH;
    if (port < 7)
        return &sol_flow_node_type_http_client_create_url__in__FRAGMENT;
    if (port < 8)
        return &sol_flow_node_type_http_client_create_url__in__BASE_URI;
    if (port < 9)
        return &sol_flow_node_type_http_client_create_url__in__PARAM;
    if (port < 10)
        return &sol_flow_node_type_http_client_create_url__in__CLEAR;
    if (port < 11)
        return &sol_flow_node_type_http_client_create_url__in__CREATE;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_create_url_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_create_url__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_create_url_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_create_url__in__PROTOCOL.packet_type == NULL) {
        sol_flow_node_type_http_client_create_url__in__PROTOCOL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_create_url__in__USER.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_create_url__in__PASSWORD.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_create_url__in__PORT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_http_client_create_url__in__SERVER.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_create_url__in__PATH.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_create_url__in__FRAGMENT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_create_url__in__BASE_URI.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_create_url__in__PARAM.packet_type = sol_flow_node_type_http_client_create_url_get_composed_string_string_packet_type();
        sol_flow_node_type_http_client_create_url__in__CLEAR.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_create_url__in__CREATE.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_http_client_create_url__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_create_url_options sol_flow_node_type_http_client_create_url_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_CREATE_URL_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_create_url_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/create-url",
    .category = "http-generic",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_CREATE_URL",
    .options_symbol = "sol_flow_node_type_http_client_create_url_options",
    .description = "Creates an encoded URL",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/create-url.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "PROTOCOL",
            .description="The URL protocol",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "USER",
            .description="The user name to authenticate",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PASSWORD",
            .description="The password to authenticate",
            .data_type="string",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PORT",
            .description="The server port",
            .data_type="int",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "SERVER",
            .description="The server to connect with",
            .data_type="string",
            .array_size=0,
            .base_port_idx=4,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PATH",
            .description="The server path",
            .data_type="string",
            .array_size=0,
            .base_port_idx=5,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "FRAGMENT",
            .description="The URL fragment",
            .data_type="string",
            .array_size=0,
            .base_port_idx=6,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "BASE_URI",
            .description="A base uri",
            .data_type="string",
            .array_size=0,
            .base_port_idx=7,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PARAM",
            .description="The URL parameters to be encoded",
            .data_type="composed:string,string",
            .array_size=0,
            .base_port_idx=8,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "CLEAR",
            .description="Clear all URL parameters",
            .data_type="any",
            .array_size=0,
            .base_port_idx=9,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "CREATE",
            .description="Process the params and generate an encoded URL",
            .data_type="any",
            .array_size=0,
            .base_port_idx=10,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The enconded URL",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_create_url_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_CREATE_URL_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="scheme",
            .description="The URL protocol",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_create_url_options, scheme),
            .size=sizeof(const char *),
            .defvalue = {
                .s="http",
            },
        },
        {
            .name="port",
            .description="The server port",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_create_url_options, port),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="host",
            .description="The server to connect with",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_create_url_options, host),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="path",
            .description="The serve path",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_create_url_options, path),
            .size=sizeof(const char *),
            .defvalue = {
                .s="/",
            },
        },
        {
            .name="fragment",
            .description="The URL fragment",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_create_url_options, fragment),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="query",
            .description="The URL parameters to be encoded",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_create_url_options, query),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="base_uri",
            .description="A base URL",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_create_url_options, base_uri),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_http_client_create_url = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct create_url_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_create_url_options),
    .default_options = &sol_flow_node_type_http_client_create_url_options_defaults,
    .init_type = sol_flow_node_type_http_client_create_url_init_type_internal,
    .open = create_url_open,
    .close = create_url_close,
    .ports_in_count = 11,
    .get_port_in = sol_flow_node_type_http_client_create_url_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_create_url_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_create_url_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_CREATE_URL = &sol_flow_node_type_http_client_create_url;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_get_headers__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_headers_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_get_headers__in__KEY = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_key_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_get_headers__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_get_headers_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_headers__in__IN;
    if (port < 2)
        return &sol_flow_node_type_http_client_get_headers__in__KEY;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_get_headers_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_headers__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_get_headers_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_get_headers__in__IN.packet_type == NULL) {
        sol_flow_node_type_http_client_get_headers__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_HTTP_RESPONSE;
        sol_flow_node_type_http_client_get_headers__in__KEY.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_get_headers__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_get_headers_options sol_flow_node_type_http_client_get_headers_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_HEADERS_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_get_headers_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/get-headers",
    .category = "http-generic",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_HEADERS",
    .options_symbol = "sol_flow_node_type_http_client_get_headers_options",
    .description = "Get the a header value given a key from a HTTP response",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/get-headers.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="The http response",
            .data_type="http-response",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "KEY",
            .description="The header key to be filtered",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The http response header value",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_get_headers_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_HEADERS_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="key",
            .description="They header key to be filtered",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_get_headers_options, key),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_http_client_get_headers = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_response_get_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_get_headers_options),
    .default_options = &sol_flow_node_type_http_client_get_headers_options_defaults,
    .init_type = sol_flow_node_type_http_client_get_headers_init_type_internal,
    .open = common_get_open,
    .close = common_get_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_http_client_get_headers_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_get_headers_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_get_headers_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_HEADERS = &sol_flow_node_type_http_client_get_headers;

static struct sol_flow_port_type_in sol_flow_node_type_http_client_get_cookies__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_cookies_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_http_client_get_cookies__in__KEY = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_key_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_http_client_get_cookies__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_http_client_get_cookies_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_cookies__in__IN;
    if (port < 2)
        return &sol_flow_node_type_http_client_get_cookies__in__KEY;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_http_client_get_cookies_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_http_client_get_cookies__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_http_client_get_cookies_init_type_internal(void)
{
    if (sol_flow_node_type_http_client_get_cookies__in__IN.packet_type == NULL) {
        sol_flow_node_type_http_client_get_cookies__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_HTTP_RESPONSE;
        sol_flow_node_type_http_client_get_cookies__in__KEY.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_http_client_get_cookies__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_http_client_get_cookies_options sol_flow_node_type_http_client_get_cookies_options_defaults = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_COOKIES_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_http_client_get_cookies_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "http-client/get-cookies",
    .category = "http-generic",
    .symbol = "SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_COOKIES",
    .options_symbol = "sol_flow_node_type_http_client_get_cookies_options",
    .description = "Get the a cookie value given a key from a HTTP response",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/http-client/get-cookies.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="The http response",
            .data_type="http-response",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "KEY",
            .description="The cookie key to be filtered",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The http response cookie value",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_http_client_get_cookies_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_COOKIES_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="key",
            .description="They cookie key to be filtered",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_http_client_get_cookies_options, key),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_http_client_get_cookies = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct http_response_get_data),
    .options_size = sizeof(struct sol_flow_node_type_http_client_get_cookies_options),
    .default_options = &sol_flow_node_type_http_client_get_cookies_options_defaults,
    .init_type = sol_flow_node_type_http_client_get_cookies_init_type_internal,
    .open = common_get_open,
    .close = common_get_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_http_client_get_cookies_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_http_client_get_cookies_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_http_client_get_cookies_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_COOKIES = &sol_flow_node_type_http_client_get_cookies;

const struct sol_flow_packet_type *
sol_flow_node_type_http_client_create_url_get_composed_string_string_packet_type(void)
{
    static const struct sol_flow_packet_type *composed_type = NULL;

    if (composed_type == NULL) {
        const struct sol_flow_packet_type *types[] = {SOL_FLOW_PACKET_TYPE_STRING, SOL_FLOW_PACKET_TYPE_STRING, NULL};
        composed_type = sol_flow_packet_type_composed_new(types);
        SOL_NULL_CHECK(composed_type, NULL);
    }

    return composed_type;
}

const struct sol_flow_packet_type *
sol_flow_node_type_http_client_request_get_composed_string_string_packet_type(void)
{
    static const struct sol_flow_packet_type *composed_type = NULL;

    if (composed_type == NULL) {
        const struct sol_flow_packet_type *types[] = {SOL_FLOW_PACKET_TYPE_STRING, SOL_FLOW_PACKET_TYPE_STRING, NULL};
        composed_type = sol_flow_packet_type_composed_new(types);
        SOL_NULL_CHECK(composed_type, NULL);
    }

    return composed_type;
}


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_http_client(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_http_client(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_BOOLEAN,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_STRING,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_RGB,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_DIRECTION_VECTOR,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_INT,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_FLOAT,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_BLOB,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_JSON,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_REQUEST,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_RESPONSE_CODE,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_URL,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_CONTENT_TYPE,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_CONTENT,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_CREATE_URL,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_HEADERS,
            &SOL_FLOW_NODE_TYPE_HTTP_CLIENT_GET_COOKIES,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
