/* this file was auto-generated from ./src/modules/flow/iio/iio.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_IIO_DEFINED
#include "sol-flow/iio.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>
#include <float.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_iio_gyroscope__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = iio_common_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_iio_gyroscope__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_iio_gyroscope_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_gyroscope__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_iio_gyroscope_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_gyroscope__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_iio_gyroscope_init_type_internal(void)
{
    if (sol_flow_node_type_iio_gyroscope__in__TICK.packet_type == NULL) {
        sol_flow_node_type_iio_gyroscope__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_iio_gyroscope__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
    }

    log_init();
}

static const struct sol_flow_node_type_iio_gyroscope_options sol_flow_node_type_iio_gyroscope_options_defaults = SOL_FLOW_NODE_TYPE_IIO_GYROSCOPE_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_iio_gyroscope_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "iio/gyroscope",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_IIO_GYROSCOPE",
    .options_symbol = "sol_flow_node_type_iio_gyroscope_options",
    .description = "IIO based gyroscope input node. As any IIO device, it can use a buffer to get the readings. To use a buffer, define a size > 0 on buffer size. Readings are sent to the buffer via a trigger mechanism. Set iio_trigger_name to a valid iio trigger name in order to use buffer. If buffer is enabled but no iio_trigger_name was set, it will attempt to create a default trigger that will be activated when sending packets to TICK port.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a gyroscope reading and produce packets on each of the the output ports. If buffer is enabled, current trigger must accept manual activation (default one, sysfs trigger, does).",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Angular speed in all X/Y/Z axes, in radians per second.",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_iio_gyroscope_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_IIO_GYROSCOPE_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="iio_device",
            .description="IIO device identifier. It's a space separated list of commands. For commands, if it's an integer value, will be interpreted as IIO device id. If it's a string starting with '/', will be interpreted as absolute path of IIO device on sysfs. If it's on the form 'i2c/X-YYYY', will evaluate to an i2c device on sysfs, where X is the bus number and YYYY is the device number, eg, 7-0069, for device 0x69 on bus 7. If it's on the form 'create,i2c,<rel_path>,<devnumber>,<devname>', where rel_path is the path of bus relative to '/sys/devices', them it will attempt to create an IIO device on that i2c bus and use it.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_iio_gyroscope_options, iio_device),
            .size=sizeof(const char *),
        },
        {
            .name="buffer_size",
            .description="IIO buffer size. If -1, buffering is disabled. If 0, will use default buffer size. If enabled (> 0), a trigger is necessary to perform readings. Set it using 'iio_trigger_name'; if no trigger name is set, it will attempt to create a default one, which is activated via TICK port.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_gyroscope_options, buffer_size),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="iio_trigger_name",
            .description="IIO trigger name. Name of IIO trigger that should be associated to this device for buffered readings. If not set and buffer enabled, will try to use device current trigger, if any. If none, will attempt to create a sysfs trigger",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_gyroscope_options, iio_trigger_name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="use_device_default_scale",
            .description="If should use device own default scale. If false, it will attempt to use scale option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_gyroscope_options, use_device_default_scale),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="scale",
            .description="Scale to applied to device raw readings",
            .data_type="direction-vector",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_gyroscope_options, scale),
            .size=sizeof(struct sol_direction_vector),
            .defvalue = {
                .direction_vector={.max=DBL_MAX, .min=-DBL_MAX, .x=0, .y=0, .z=0},
            },
        },
        {
            .name="use_device_default_offset",
            .description="If should use device own default offset. If false, it will attempt to use offset_x, offset_y and offset_z options.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_gyroscope_options, use_device_default_offset),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="offset",
            .description="Offset to be added to device raw readings",
            .data_type="direction-vector",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_gyroscope_options, offset),
            .size=sizeof(struct sol_direction_vector),
            .defvalue = {
                .direction_vector={.max=DBL_MAX, .min=-DBL_MAX, .x=0, .y=0, .z=0},
            },
        },
        {
            .name="sampling_frequency",
            .description="Sampling frequency of the sensor. If -1, use device default",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_gyroscope_options, sampling_frequency),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
        {
            .name="out_range",
            .description="Range of output packet. Usually, is the output range of used sensor. It'll be the 'min' and 'max' fields of direction-vector packets sent on OUT port.",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_gyroscope_options, out_range),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
            {},

        },
    }),
};
#endif

static const struct iio_node_type sol_flow_node_type_iio_gyroscope = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct iio_direction_vector_data),
    .options_size = sizeof(struct sol_flow_node_type_iio_gyroscope_options),
    .default_options = &sol_flow_node_type_iio_gyroscope_options_defaults,
    .init_type = sol_flow_node_type_iio_gyroscope_init_type_internal,
    .open = gyroscope_open,
    .close = iio_common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_iio_gyroscope_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_iio_gyroscope_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_iio_gyroscope_description,
#endif
},
    .out_port = SOL_FLOW_NODE_TYPE_IIO_GYROSCOPE__OUT__OUT,
    .reader_cb = iio_direction_vector_reader_cb,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_IIO_GYROSCOPE = &sol_flow_node_type_iio_gyroscope.base;

static struct sol_flow_port_type_in sol_flow_node_type_iio_magnetometer__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = iio_common_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_iio_magnetometer__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_iio_magnetometer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_magnetometer__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_iio_magnetometer_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_magnetometer__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_iio_magnetometer_init_type_internal(void)
{
    if (sol_flow_node_type_iio_magnetometer__in__TICK.packet_type == NULL) {
        sol_flow_node_type_iio_magnetometer__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_iio_magnetometer__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
    }

    log_init();
}

static const struct sol_flow_node_type_iio_magnetometer_options sol_flow_node_type_iio_magnetometer_options_defaults = SOL_FLOW_NODE_TYPE_IIO_MAGNETOMETER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_iio_magnetometer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "iio/magnetometer",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_IIO_MAGNETOMETER",
    .options_symbol = "sol_flow_node_type_iio_magnetometer_options",
    .description = "IIO based magnet input node. As any IIO device, it can use a buffer to get the readings. To use a buffer, define a size > 0 on buffer size. Readings are sent to the buffer via a trigger mechanism. Set iio_trigger_name to a valid iio trigger name in order to use buffer. If buffer is enabled but no iio_trigger_name was set, it will attempt to create a default trigger that will be activated when sending packets to TICK port.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a magnet reading and produce packets on each of the the output ports. If buffer is enabled, current trigger must accept manual activation (default one, sysfs trigger, does).",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Magnet location in all X/Y/Z axes, in Gauss.",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_iio_magnetometer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_IIO_MAGNETOMETER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="iio_device",
            .description="IIO device identifier. It's a space separated list of commands. For commands, if it's an integer value, will be interpreted as IIO device id. If it's a string starting with '/', will be interpreted as absolute path of IIO device on sysfs. If it's on the form 'i2c/X-YYYY', will evaluate to an i2c device on sysfs, where X is the bus number and YYYY is the device number, eg, 7-0069, for device 0x69 on bus 7. If it's on the form 'create,i2c,<rel_path>,<devnumber>,<devname>', where rel_path is the path of bus relative to '/sys/devices', them it will attempt to create an IIO device on that i2c bus and use it.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_iio_magnetometer_options, iio_device),
            .size=sizeof(const char *),
        },
        {
            .name="buffer_size",
            .description="IIO buffer size. If -1, buffering is disabled. If 0, will use default buffer size. If enabled (> 0), a trigger is necessary to perform readings. Set it using 'iio_trigger_name'; if no trigger name is set, it will attempt to create a default one, which is activated via TICK port.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_magnetometer_options, buffer_size),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="iio_trigger_name",
            .description="IIO trigger name. Name of IIO trigger that should be associated to this device for buffered readings. If not set and buffer enabled, will try to use device current trigger, if any. If none, will attempt to create a sysfs trigger",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_magnetometer_options, iio_trigger_name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="use_device_default_scale",
            .description="If should use device own default scale. If false, it will attempt to use scale option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_magnetometer_options, use_device_default_scale),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="scale",
            .description="Scale to applied to device raw readings",
            .data_type="direction-vector",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_magnetometer_options, scale),
            .size=sizeof(struct sol_direction_vector),
            .defvalue = {
                .direction_vector={.max=DBL_MAX, .min=-DBL_MAX, .x=0, .y=0, .z=0},
            },
        },
        {
            .name="use_device_default_offset",
            .description="If should use device own default offset. If false, it will attempt to use offset_x, offset_y and offset_z options.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_magnetometer_options, use_device_default_offset),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="offset",
            .description="Offset to be added to device raw readings",
            .data_type="direction-vector",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_magnetometer_options, offset),
            .size=sizeof(struct sol_direction_vector),
            .defvalue = {
                .direction_vector={.max=DBL_MAX, .min=-DBL_MAX, .x=0, .y=0, .z=0},
            },
        },
        {
            .name="sampling_frequency",
            .description="Sampling frequency of the sensor. If -1, use device default",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_magnetometer_options, sampling_frequency),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
        {
            .name="out_range",
            .description="Range of output packet. Usually, is the output range of used sensor. It'll be the 'min' and 'max' fields of drange packets sent on OUT port.",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_magnetometer_options, out_range),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
            {},

        },
    }),
};
#endif

static const struct iio_node_type sol_flow_node_type_iio_magnetometer = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct iio_direction_vector_data),
    .options_size = sizeof(struct sol_flow_node_type_iio_magnetometer_options),
    .default_options = &sol_flow_node_type_iio_magnetometer_options_defaults,
    .init_type = sol_flow_node_type_iio_magnetometer_init_type_internal,
    .open = magnet_open,
    .close = iio_common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_iio_magnetometer_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_iio_magnetometer_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_iio_magnetometer_description,
#endif
},
    .out_port = SOL_FLOW_NODE_TYPE_IIO_MAGNETOMETER__OUT__OUT,
    .reader_cb = iio_direction_vector_reader_cb,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_IIO_MAGNETOMETER = &sol_flow_node_type_iio_magnetometer.base;

static struct sol_flow_port_type_in sol_flow_node_type_iio_thermometer__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = iio_common_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_iio_thermometer__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_iio_thermometer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_thermometer__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_iio_thermometer_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_thermometer__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_iio_thermometer_init_type_internal(void)
{
    if (sol_flow_node_type_iio_thermometer__in__TICK.packet_type == NULL) {
        sol_flow_node_type_iio_thermometer__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_iio_thermometer__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_iio_thermometer_options sol_flow_node_type_iio_thermometer_options_defaults = SOL_FLOW_NODE_TYPE_IIO_THERMOMETER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_iio_thermometer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "iio/thermometer",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_IIO_THERMOMETER",
    .options_symbol = "sol_flow_node_type_iio_thermometer_options",
    .description = "IIO based temperature input node. As any IIO device, it can use a buffer to get the readings. To use a buffer, define a size > 0 on buffer size. Readings are sent to the buffer via a trigger mechanism. Set iio_trigger_name to a valid iio trigger name in order to use buffer. If buffer is enabled but no iio_trigger_name was set, it will attempt to create a default trigger that will be activated when sending packets to TICK port.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a temperature reading and produce packets on each of the the output ports. If buffer is enabled, current trigger must accept manual activation (default one, sysfs trigger, does).",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Temperature read, in milli degrees Celsius",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_iio_thermometer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_IIO_THERMOMETER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="iio_device",
            .description="IIO device identifier. It's a space separated list of commands. For commands, if it's an integer value, will be interpreted as IIO device id. If it's a string starting with '/', will be interpreted as absolute path of IIO device on sysfs. If it's on the form 'i2c/X-YYYY', will evaluate to an i2c device on sysfs, where X is the bus number and YYYY is the device number, eg, 7-0069, for device 0x69 on bus 7. If it's on the form 'create,i2c,<rel_path>,<devnumber>,<devname>', where rel_path is the path of bus relative to '/sys/devices', them it will attempt to create an IIO device on that i2c bus and use it.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_iio_thermometer_options, iio_device),
            .size=sizeof(const char *),
        },
        {
            .name="buffer_size",
            .description="IIO buffer size. If -1, buffering is disabled. If 0, will use default buffer size. If enabled (> 0), a trigger is necessary to perform readings. Set it using 'iio_trigger_name'; if no trigger name is set, it will attempt to create a default one, which is activated via TICK port.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_thermometer_options, buffer_size),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="iio_trigger_name",
            .description="IIO trigger name. Name of IIO trigger that should be associated to this device for buffered readings. If not set and buffer enabled, will try to use device current trigger, if any. If none, will attempt to create a sysfs trigger",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_thermometer_options, iio_trigger_name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="use_device_default_scale",
            .description="If should use device own default scale. If false, it will attempt to use scale option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_thermometer_options, use_device_default_scale),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="scale",
            .description="Scale to applied to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_thermometer_options, scale),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="use_device_default_offset",
            .description="If should use device own default offset. If false, it will attempt to use offset option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_thermometer_options, use_device_default_offset),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="offset",
            .description="Offset to be added to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_thermometer_options, offset),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="sampling_frequency",
            .description="Sampling frequency of the sensor. If -1, use device default",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_thermometer_options, sampling_frequency),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
        {
            .name="out_range",
            .description="Range of output packet. Usually, is the output range of used sensor. It'll be the 'min' and 'max' fields of drange packets sent on OUT port.",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_thermometer_options, out_range),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
            {},

        },
    }),
};
#endif

static const struct iio_node_type sol_flow_node_type_iio_thermometer = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct iio_double_data),
    .options_size = sizeof(struct sol_flow_node_type_iio_thermometer_options),
    .default_options = &sol_flow_node_type_iio_thermometer_options_defaults,
    .init_type = sol_flow_node_type_iio_thermometer_init_type_internal,
    .open = temperature_open,
    .close = iio_common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_iio_thermometer_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_iio_thermometer_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_iio_thermometer_description,
#endif
},
    .out_port = SOL_FLOW_NODE_TYPE_IIO_THERMOMETER__OUT__OUT,
    .reader_cb = iio_double_reader_cb,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_IIO_THERMOMETER = &sol_flow_node_type_iio_thermometer.base;

static struct sol_flow_port_type_in sol_flow_node_type_iio_pressure_sensor__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = iio_common_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_iio_pressure_sensor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_iio_pressure_sensor_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_pressure_sensor__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_iio_pressure_sensor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_pressure_sensor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_iio_pressure_sensor_init_type_internal(void)
{
    if (sol_flow_node_type_iio_pressure_sensor__in__TICK.packet_type == NULL) {
        sol_flow_node_type_iio_pressure_sensor__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_iio_pressure_sensor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_iio_pressure_sensor_options sol_flow_node_type_iio_pressure_sensor_options_defaults = SOL_FLOW_NODE_TYPE_IIO_PRESSURE_SENSOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_iio_pressure_sensor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "iio/pressure-sensor",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_IIO_PRESSURE_SENSOR",
    .options_symbol = "sol_flow_node_type_iio_pressure_sensor_options",
    .description = "IIO based pressure input node. As any IIO device, it can use a buffer to get the readings. To use a buffer, define a size > 0 on buffer size. Readings are sent to the buffer via a trigger mechanism. Set iio_trigger_name to a valid iio trigger name in order to use buffer. If buffer is enabled but no iio_trigger_name was set, it will attempt to create a default trigger that will be activated when sending packets to TICK port.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a pressure reading and produce packets on each of the the output ports. If buffer is enabled, current trigger must accept manual activation (default one, sysfs trigger, does).",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Pressure data read in Kpa.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_iio_pressure_sensor_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_IIO_PRESSURE_SENSOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="iio_device",
            .description="IIO device identifier. It's a space separated list of commands. For commands, if it's an integer value, will be interpreted as IIO device id. If it's a string starting with '/', will be interpreted as absolute path of IIO device on sysfs. If it's on the form 'i2c/X-YYYY', will evaluate to an i2c device on sysfs, where X is the bus number and YYYY is the device number, eg, 7-0069, for device 0x69 on bus 7. If it's on the form 'create,i2c,<rel_path>,<devnumber>,<devname>', where rel_path is the path of bus relative to '/sys/devices', them it will attempt to create an IIO device on that i2c bus and use it.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_iio_pressure_sensor_options, iio_device),
            .size=sizeof(const char *),
        },
        {
            .name="buffer_size",
            .description="IIO buffer size. If -1, buffering is disabled. If 0, will use default buffer size. If enabled (> 0), a trigger is necessary to perform readings. Set it using 'iio_trigger_name'; if no trigger name is set, it will attempt to create a default one, which is activated via TICK port.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_pressure_sensor_options, buffer_size),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="iio_trigger_name",
            .description="IIO trigger name. Name of IIO trigger that should be associated to this device for buffered readings. If not set and buffer enabled, will try to use device current trigger, if any. If none, will attempt to create a sysfs trigger",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_pressure_sensor_options, iio_trigger_name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="use_device_default_scale",
            .description="If should use device own default scale. If false, it will attempt to use scale option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_pressure_sensor_options, use_device_default_scale),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="scale",
            .description="Scale to applied to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_pressure_sensor_options, scale),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="use_device_default_offset",
            .description="If should use device own default offset. If false, it will attempt to use offset_x, offset_y and offset_z options.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_pressure_sensor_options, use_device_default_offset),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="offset",
            .description="Offset to be added to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_pressure_sensor_options, offset),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="sampling_frequency",
            .description="Sampling frequency of the sensor. If -1, use device default",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_pressure_sensor_options, sampling_frequency),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
        {
            .name="out_range",
            .description="Range of output packet. Usually, is the output range of used sensor. It'll be the 'min' and 'max' fields of drange packets sent on OUT port.",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_pressure_sensor_options, out_range),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
            {},

        },
    }),
};
#endif

static const struct iio_node_type sol_flow_node_type_iio_pressure_sensor = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct iio_double_data),
    .options_size = sizeof(struct sol_flow_node_type_iio_pressure_sensor_options),
    .default_options = &sol_flow_node_type_iio_pressure_sensor_options_defaults,
    .init_type = sol_flow_node_type_iio_pressure_sensor_init_type_internal,
    .open = pressure_open,
    .close = iio_common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_iio_pressure_sensor_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_iio_pressure_sensor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_iio_pressure_sensor_description,
#endif
},
    .out_port = SOL_FLOW_NODE_TYPE_IIO_PRESSURE_SENSOR__OUT__OUT,
    .reader_cb = iio_double_reader_cb,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_IIO_PRESSURE_SENSOR = &sol_flow_node_type_iio_pressure_sensor.base;

static struct sol_flow_port_type_in sol_flow_node_type_iio_color_sensor__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = iio_common_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_iio_color_sensor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_iio_color_sensor_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_color_sensor__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_iio_color_sensor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_color_sensor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_iio_color_sensor_init_type_internal(void)
{
    if (sol_flow_node_type_iio_color_sensor__in__TICK.packet_type == NULL) {
        sol_flow_node_type_iio_color_sensor__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_iio_color_sensor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
    }

    log_init();
}

static const struct sol_flow_node_type_iio_color_sensor_options sol_flow_node_type_iio_color_sensor_options_defaults = SOL_FLOW_NODE_TYPE_IIO_COLOR_SENSOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_iio_color_sensor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "iio/color-sensor",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_IIO_COLOR_SENSOR",
    .options_symbol = "sol_flow_node_type_iio_color_sensor_options",
    .description = "IIO based color input node. As any IIO device, it can use a buffer to get the readings. To use a buffer, define a size > 0 on buffer size. Readings are sent to the buffer via a trigger mechanism. Set iio_trigger_name to a valid iio trigger name in order to use buffer. If buffer is enabled but no iio_trigger_name was set, it will attempt to create a default trigger that will be activated when sending packets to TICK port.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a color reading and produce packets on each of the the output ports. If buffer is enabled, current trigger must accept manual activation (default one, sysfs trigger, does).",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Color Sensor data read.",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_iio_color_sensor_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_IIO_COLOR_SENSOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="iio_device",
            .description="IIO device identifier. It's a space separated list of commands. For commands, if it's an integer value, will be interpreted as IIO device id. If it's a string starting with '/', will be interpreted as absolute path of IIO device on sysfs. If it's on the form 'i2c/X-YYYY', will evaluate to an i2c device on sysfs, where X is the bus number and YYYY is the device number, eg, 7-0069, for device 0x69 on bus 7. If it's on the form 'create,i2c,<rel_path>,<devnumber>,<devname>', where rel_path is the path of bus relative to '/sys/devices', them it will attempt to create an IIO device on that i2c bus and use it.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, iio_device),
            .size=sizeof(const char *),
        },
        {
            .name="buffer_size",
            .description="IIO buffer size. If -1, buffering is disabled. If 0, will use default buffer size. If enabled (> 0), a trigger is necessary to perform readings. Set it using 'iio_trigger_name'; if no trigger name is set, it will attempt to create a default one, which is activated via TICK port.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, buffer_size),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="iio_trigger_name",
            .description="IIO trigger name. Name of IIO trigger that should be associated to this device for buffered readings. If not set and buffer enabled, will try to use device current trigger, if any. If none, will attempt to create a sysfs trigger",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, iio_trigger_name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="use_device_default_scale",
            .description="If should use device own default scale. If false, it will attempt to use scale option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, use_device_default_scale),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="scale_red",
            .description="Scale to applied to device Red raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, scale_red),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="scale_green",
            .description="Scale to applied to device Green raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, scale_green),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="scale_blue",
            .description="Scale to applied to device Blue raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, scale_blue),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="use_device_default_offset",
            .description="If should use device own default offset. If false, it will attempt to use offset_x, offset_y and offset_z options.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, use_device_default_offset),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="offset_red",
            .description="Offset to be added to device Red raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, offset_red),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="offset_green",
            .description="Offset to be added to device Green raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, offset_green),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="offset_blue",
            .description="Offset to be added to device Blue raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, offset_blue),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="sampling_frequency",
            .description="Sampling frequency of the sensor. If -1, use device default",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, sampling_frequency),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
        {
            .name="out_range",
            .description="Range of output packet. Usually, is the output range of used sensor. It'll be the 'min' and 'max' fields of direction-vector packets sent on OUT port.",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_color_sensor_options, out_range),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
            {},

        },
    }),
};
#endif

static const struct iio_node_type sol_flow_node_type_iio_color_sensor = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct iio_color_data),
    .options_size = sizeof(struct sol_flow_node_type_iio_color_sensor_options),
    .default_options = &sol_flow_node_type_iio_color_sensor_options_defaults,
    .init_type = sol_flow_node_type_iio_color_sensor_init_type_internal,
    .open = color_open,
    .close = iio_common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_iio_color_sensor_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_iio_color_sensor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_iio_color_sensor_description,
#endif
},
    .out_port = SOL_FLOW_NODE_TYPE_IIO_COLOR_SENSOR__OUT__OUT,
    .reader_cb = iio_color_reader_cb,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_IIO_COLOR_SENSOR = &sol_flow_node_type_iio_color_sensor.base;

static struct sol_flow_port_type_in sol_flow_node_type_iio_accelerometer__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = iio_common_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_iio_accelerometer__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_iio_accelerometer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_accelerometer__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_iio_accelerometer_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_accelerometer__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_iio_accelerometer_init_type_internal(void)
{
    if (sol_flow_node_type_iio_accelerometer__in__TICK.packet_type == NULL) {
        sol_flow_node_type_iio_accelerometer__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_iio_accelerometer__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
    }

    log_init();
}

static const struct sol_flow_node_type_iio_accelerometer_options sol_flow_node_type_iio_accelerometer_options_defaults = SOL_FLOW_NODE_TYPE_IIO_ACCELEROMETER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_iio_accelerometer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "iio/accelerometer",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_IIO_ACCELEROMETER",
    .options_symbol = "sol_flow_node_type_iio_accelerometer_options",
    .description = "IIO based accelerate input node. As any IIO device, it can use a buffer to get the readings. To use a buffer, define a size > 0 on buffer size. Readings are sent to the buffer via a trigger mechanism. Set iio_trigger_name to a valid iio trigger name in order to use buffer. If buffer is enabled but no iio_trigger_name was set, it will attempt to create a default trigger that will be activated when sending packets to TICK port.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a accelerate reading and produce packets on each of the the output ports. If buffer is enabled, current trigger must accept manual activation (default one, sysfs trigger, does).",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Accelerate data read, in m/s^2.",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_iio_accelerometer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_IIO_ACCELEROMETER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="iio_device",
            .description="IIO device identifier. It's a space separated list of commands. For commands, if it's an integer value, will be interpreted as IIO device id. If it's a string starting with '/', will be interpreted as absolute path of IIO device on sysfs. If it's on the form 'i2c/X-YYYY', will evaluate to an i2c device on sysfs, where X is the bus number and YYYY is the device number, eg, 7-0069, for device 0x69 on bus 7. If it's on the form 'create,i2c,<rel_path>,<devnumber>,<devname>', where rel_path is the path of bus relative to '/sys/devices', them it will attempt to create an IIO device on that i2c bus and use it.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_iio_accelerometer_options, iio_device),
            .size=sizeof(const char *),
        },
        {
            .name="buffer_size",
            .description="IIO buffer size. If -1, buffering is disabled. If 0, will use default buffer size. If enabled (> 0), a trigger is necessary to perform readings. Set it using 'iio_trigger_name'; if no trigger name is set, it will attempt to create a default one, which is activated via TICK port.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_accelerometer_options, buffer_size),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="iio_trigger_name",
            .description="IIO trigger name. Name of IIO trigger that should be associated to this device for buffered readings. If not set and buffer enabled, will try to use device current trigger, if any. If none, will attempt to create a sysfs trigger",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_accelerometer_options, iio_trigger_name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="use_device_default_scale",
            .description="If should use device own default scale. If false, it will attempt to use scale option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_accelerometer_options, use_device_default_scale),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="scale",
            .description="Scale to applied to device raw readings",
            .data_type="direction-vector",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_accelerometer_options, scale),
            .size=sizeof(struct sol_direction_vector),
            .defvalue = {
                .direction_vector={.max=DBL_MAX, .min=-DBL_MAX, .x=0, .y=0, .z=0},
            },
        },
        {
            .name="use_device_default_offset",
            .description="If should use device own default offset. If false, it will attempt to use offset_x, offset_y and offset_z options.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_accelerometer_options, use_device_default_offset),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="offset",
            .description="Offset to be added to device raw readings",
            .data_type="direction-vector",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_accelerometer_options, offset),
            .size=sizeof(struct sol_direction_vector),
            .defvalue = {
                .direction_vector={.max=DBL_MAX, .min=-DBL_MAX, .x=0, .y=0, .z=0},
            },
        },
        {
            .name="sampling_frequency",
            .description="Sampling frequency of the sensor. If -1, use device default",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_accelerometer_options, sampling_frequency),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
        {
            .name="out_range",
            .description="Range of output packet. Usually, is the output range of used sensor. It'll be the 'min' and 'max' fields of direction-vector packets sent on OUT port.",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_accelerometer_options, out_range),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
            {},

        },
    }),
};
#endif

static const struct iio_node_type sol_flow_node_type_iio_accelerometer = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct iio_direction_vector_data),
    .options_size = sizeof(struct sol_flow_node_type_iio_accelerometer_options),
    .default_options = &sol_flow_node_type_iio_accelerometer_options_defaults,
    .init_type = sol_flow_node_type_iio_accelerometer_init_type_internal,
    .open = accelerate_open,
    .close = iio_common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_iio_accelerometer_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_iio_accelerometer_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_iio_accelerometer_description,
#endif
},
    .out_port = SOL_FLOW_NODE_TYPE_IIO_ACCELEROMETER__OUT__OUT,
    .reader_cb = iio_direction_vector_reader_cb,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_IIO_ACCELEROMETER = &sol_flow_node_type_iio_accelerometer.base;

static struct sol_flow_port_type_in sol_flow_node_type_iio_humidity_sensor__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = iio_common_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_iio_humidity_sensor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_iio_humidity_sensor_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_humidity_sensor__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_iio_humidity_sensor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_humidity_sensor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_iio_humidity_sensor_init_type_internal(void)
{
    if (sol_flow_node_type_iio_humidity_sensor__in__TICK.packet_type == NULL) {
        sol_flow_node_type_iio_humidity_sensor__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_iio_humidity_sensor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_iio_humidity_sensor_options sol_flow_node_type_iio_humidity_sensor_options_defaults = SOL_FLOW_NODE_TYPE_IIO_HUMIDITY_SENSOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_iio_humidity_sensor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "iio/humidity-sensor",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_IIO_HUMIDITY_SENSOR",
    .options_symbol = "sol_flow_node_type_iio_humidity_sensor_options",
    .description = "IIO based humidity input node. As any IIO device, it can use a buffer to get the readings. To use a buffer, define a size > 0 on buffer size. Readings are sent to the buffer via a trigger mechanism. Set iio_trigger_name to a valid iio trigger name in order to use buffer. If buffer is enabled but no iio_trigger_name was set, it will attempt to create a default trigger that will be activated when sending packets to TICK port.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a humidity reading and produce packets on each of the the output ports. If buffer is enabled, current trigger must accept manual activation (default one, sysfs trigger, does).",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Relative humidity data read, in percentage(%rh).",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_iio_humidity_sensor_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_IIO_HUMIDITY_SENSOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="iio_device",
            .description="IIO device identifier. It's a space separated list of commands. For commands, if it's an integer value, will be interpreted as IIO device id. If it's a string starting with '/', will be interpreted as absolute path of IIO device on sysfs. If it's on the form 'i2c/X-YYYY', will evaluate to an i2c device on sysfs, where X is the bus number and YYYY is the device number, eg, 7-0069, for device 0x69 on bus 7. If it's on the form 'create,i2c,<rel_path>,<devnumber>,<devname>', where rel_path is the path of bus relative to '/sys/devices', them it will attempt to create an IIO device on that i2c bus and use it.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_iio_humidity_sensor_options, iio_device),
            .size=sizeof(const char *),
        },
        {
            .name="buffer_size",
            .description="IIO buffer size. If -1, buffering is disabled. If 0, will use default buffer size. If enabled (> 0), a trigger is necessary to perform readings. Set it using 'iio_trigger_name'; if no trigger name is set, it will attempt to create a default one, which is activated via TICK port.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_humidity_sensor_options, buffer_size),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="iio_trigger_name",
            .description="IIO trigger name. Name of IIO trigger that should be associated to this device for buffered readings. If not set and buffer enabled, will try to use device current trigger, if any. If none, will attempt to create a sysfs trigger",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_humidity_sensor_options, iio_trigger_name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="use_device_default_scale",
            .description="If should use device own default scale. If false, it will attempt to use scale option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_humidity_sensor_options, use_device_default_scale),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="scale",
            .description="Scale to applied to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_humidity_sensor_options, scale),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="use_device_default_offset",
            .description="If should use device own default offset. If false, it will attempt to use offset_x, offset_y and offset_z options.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_humidity_sensor_options, use_device_default_offset),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="offset",
            .description="Offset to be added to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_humidity_sensor_options, offset),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="sampling_frequency",
            .description="Sampling frequency of the sensor. If -1, use device default",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_humidity_sensor_options, sampling_frequency),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
        {
            .name="out_range",
            .description="Range of output packet. Usually, is the output range of used sensor. It'll be the 'min' and 'max' fields of drange packets sent on OUT port.",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_humidity_sensor_options, out_range),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
            {},

        },
    }),
};
#endif

static const struct iio_node_type sol_flow_node_type_iio_humidity_sensor = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct iio_double_data),
    .options_size = sizeof(struct sol_flow_node_type_iio_humidity_sensor_options),
    .default_options = &sol_flow_node_type_iio_humidity_sensor_options_defaults,
    .init_type = sol_flow_node_type_iio_humidity_sensor_init_type_internal,
    .open = humidity_open,
    .close = iio_common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_iio_humidity_sensor_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_iio_humidity_sensor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_iio_humidity_sensor_description,
#endif
},
    .out_port = SOL_FLOW_NODE_TYPE_IIO_HUMIDITY_SENSOR__OUT__OUT,
    .reader_cb = iio_double_reader_cb,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_IIO_HUMIDITY_SENSOR = &sol_flow_node_type_iio_humidity_sensor.base;

static struct sol_flow_port_type_in sol_flow_node_type_iio_adc__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = iio_common_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_iio_adc__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_iio_adc_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_adc__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_iio_adc_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_adc__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_iio_adc_init_type_internal(void)
{
    if (sol_flow_node_type_iio_adc__in__TICK.packet_type == NULL) {
        sol_flow_node_type_iio_adc__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_iio_adc__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_iio_adc_options sol_flow_node_type_iio_adc_options_defaults = SOL_FLOW_NODE_TYPE_IIO_ADC_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_iio_adc_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "iio/adc",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_IIO_ADC",
    .options_symbol = "sol_flow_node_type_iio_adc_options",
    .description = "IIO based adc input node. As any IIO device, it can use a buffer to get the readings. To use a buffer, define a size > 0 on buffer size. Readings are sent to the buffer via a trigger mechanism. Set iio_trigger_name to a valid iio trigger name in order to use buffer. If buffer is enabled but no iio_trigger_name was set, it will attempt to create a default trigger that will be activated when sending packets to TICK port.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a adc reading and produce packets on each of the the output ports. If buffer is enabled, current trigger must accept manual activation (default one, sysfs trigger, does).",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="ADC data read from analog signal, in milivolts(mV)",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_iio_adc_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_IIO_ADC_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="iio_device",
            .description="IIO device identifier. It's a space separated list of commands. For commands, if it's an integer value, will be interpreted as IIO device id. If it's a string starting with '/', will be interpreted as absolute path of IIO device on sysfs. If it's on the form 'i2c/X-YYYY', will evaluate to an i2c device on sysfs, where X is the bus number and YYYY is the device number, eg, 7-0069, for device 0x69 on bus 7. If it's on the form 'create,i2c,<rel_path>,<devnumber>,<devname>', where rel_path is the path of bus relative to '/sys/devices', them it will attempt to create an IIO device on that i2c bus and use it.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_iio_adc_options, iio_device),
            .size=sizeof(const char *),
        },
        {
            .name="buffer_size",
            .description="IIO buffer size. If -1, buffering is disabled. If 0, will use default buffer size. If enabled (> 0), a trigger is necessary to perform readings. Set it using 'iio_trigger_name'; if no trigger name is set, it will attempt to create a default one, which is activated via TICK port.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_adc_options, buffer_size),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="iio_trigger_name",
            .description="IIO trigger name. Name of IIO trigger that should be associated to this device for buffered readings. If not set and buffer enabled, will try to use device current trigger, if any. If none, will attempt to create a sysfs trigger",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_adc_options, iio_trigger_name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="use_device_default_scale",
            .description="If should use device own default scale. If false, it will attempt to use scale option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_adc_options, use_device_default_scale),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="scale",
            .description="Scale to applied to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_adc_options, scale),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="use_device_default_offset",
            .description="If should use device own default offset. If false, it will attempt to use offset_x, offset_y and offset_z options.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_adc_options, use_device_default_offset),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="offset",
            .description="Offset to be added to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_adc_options, offset),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="sampling_frequency",
            .description="Sampling frequency of the sensor. If -1, use device default",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_adc_options, sampling_frequency),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
        {
            .name="out_range",
            .description="Range of output packet. Usually, is the output range of used sensor. It'll be the 'min' and 'max' fields of drange packets sent on OUT port.",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_adc_options, out_range),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
            {},

        },
    }),
};
#endif

static const struct iio_node_type sol_flow_node_type_iio_adc = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct iio_double_data),
    .options_size = sizeof(struct sol_flow_node_type_iio_adc_options),
    .default_options = &sol_flow_node_type_iio_adc_options_defaults,
    .init_type = sol_flow_node_type_iio_adc_init_type_internal,
    .open = adc_open,
    .close = iio_common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_iio_adc_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_iio_adc_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_iio_adc_description,
#endif
},
    .out_port = SOL_FLOW_NODE_TYPE_IIO_ADC__OUT__OUT,
    .reader_cb = iio_double_reader_cb,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_IIO_ADC = &sol_flow_node_type_iio_adc.base;

static struct sol_flow_port_type_in sol_flow_node_type_iio_light_sensor__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = iio_common_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_iio_light_sensor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_iio_light_sensor_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_light_sensor__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_iio_light_sensor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_light_sensor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_iio_light_sensor_init_type_internal(void)
{
    if (sol_flow_node_type_iio_light_sensor__in__TICK.packet_type == NULL) {
        sol_flow_node_type_iio_light_sensor__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_iio_light_sensor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_iio_light_sensor_options sol_flow_node_type_iio_light_sensor_options_defaults = SOL_FLOW_NODE_TYPE_IIO_LIGHT_SENSOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_iio_light_sensor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "iio/light-sensor",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_IIO_LIGHT_SENSOR",
    .options_symbol = "sol_flow_node_type_iio_light_sensor_options",
    .description = "IIO based light input node. As any IIO device, it can use a buffer to get the readings. To use a buffer, define a size > 0 on buffer size. Readings are sent to the buffer via a trigger mechanism. Set iio_trigger_name to a valid iio trigger name in order to use buffer. If buffer is enabled but no iio_trigger_name was set, it will attempt to create a default trigger that will be activated when sending packets to TICK port.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a light reading and produce packets on each of the the output ports. If buffer is enabled, current trigger must accept manual activation (default one, sysfs trigger, does).",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Light data read in lux.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_iio_light_sensor_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_IIO_LIGHT_SENSOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="iio_device",
            .description="IIO device identifier. It's a space separated list of commands. For commands, if it's an integer value, will be interpreted as IIO device id. If it's a string starting with '/', will be interpreted as absolute path of IIO device on sysfs. If it's on the form 'i2c/X-YYYY', will evaluate to an i2c device on sysfs, where X is the bus number and YYYY is the device number, eg, 7-0069, for device 0x69 on bus 7. If it's on the form 'create,i2c,<rel_path>,<devnumber>,<devname>', where rel_path is the path of bus relative to '/sys/devices', them it will attempt to create an IIO device on that i2c bus and use it.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_iio_light_sensor_options, iio_device),
            .size=sizeof(const char *),
        },
        {
            .name="buffer_size",
            .description="IIO buffer size. If -1, buffering is disabled. If 0, will use default buffer size. If enabled (> 0), a trigger is necessary to perform readings. Set it using 'iio_trigger_name'; if no trigger name is set, it will attempt to create a default one, which is activated via TICK port.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_light_sensor_options, buffer_size),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="iio_trigger_name",
            .description="IIO trigger name. Name of IIO trigger that should be associated to this device for buffered readings. If not set and buffer enabled, will try to use device current trigger, if any. If none, will attempt to create a sysfs trigger",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_light_sensor_options, iio_trigger_name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="use_device_default_scale",
            .description="If should use device own default scale. If false, it will attempt to use scale option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_light_sensor_options, use_device_default_scale),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="scale",
            .description="Scale to applied to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_light_sensor_options, scale),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="use_device_default_offset",
            .description="If should use device own default offset. If false, it will attempt to use offset_x, offset_y and offset_z options.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_light_sensor_options, use_device_default_offset),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="offset",
            .description="Offset to be added to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_light_sensor_options, offset),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="sampling_frequency",
            .description="Sampling frequency of the sensor. If -1, use device default",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_light_sensor_options, sampling_frequency),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
        {
            .name="out_range",
            .description="Range of output packet. Usually, is the output range of used sensor. It'll be the 'min' and 'max' fields of drange packets sent on OUT port.",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_light_sensor_options, out_range),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
            {},

        },
    }),
};
#endif

static const struct iio_node_type sol_flow_node_type_iio_light_sensor = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct iio_double_data),
    .options_size = sizeof(struct sol_flow_node_type_iio_light_sensor_options),
    .default_options = &sol_flow_node_type_iio_light_sensor_options_defaults,
    .init_type = sol_flow_node_type_iio_light_sensor_init_type_internal,
    .open = light_open,
    .close = iio_common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_iio_light_sensor_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_iio_light_sensor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_iio_light_sensor_description,
#endif
},
    .out_port = SOL_FLOW_NODE_TYPE_IIO_LIGHT_SENSOR__OUT__OUT,
    .reader_cb = iio_double_reader_cb,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_IIO_LIGHT_SENSOR = &sol_flow_node_type_iio_light_sensor.base;

static struct sol_flow_port_type_in sol_flow_node_type_iio_proximity_sensor__in__TICK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = iio_common_tick,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_iio_proximity_sensor__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_iio_proximity_sensor_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_proximity_sensor__in__TICK;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_iio_proximity_sensor_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_iio_proximity_sensor__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_iio_proximity_sensor_init_type_internal(void)
{
    if (sol_flow_node_type_iio_proximity_sensor__in__TICK.packet_type == NULL) {
        sol_flow_node_type_iio_proximity_sensor__in__TICK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_iio_proximity_sensor__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_iio_proximity_sensor_options sol_flow_node_type_iio_proximity_sensor_options_defaults = SOL_FLOW_NODE_TYPE_IIO_PROXIMITY_SENSOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_iio_proximity_sensor_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "iio/proximity-sensor",
    .category = "input/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_IIO_PROXIMITY_SENSOR",
    .options_symbol = "sol_flow_node_type_iio_proximity_sensor_options",
    .description = "IIO based proximity input node. As any IIO device, it can use a buffer to get the readings. To use a buffer, define a size > 0 on buffer size. Readings are sent to the buffer via a trigger mechanism. Set iio_trigger_name to a valid iio trigger name in order to use buffer. If buffer is enabled but no iio_trigger_name was set, it will attempt to create a default trigger that will be activated when sending packets to TICK port.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TICK",
            .description="Packets sent in here will trigger a proximity reading and produce packets on each of the the output ports. If buffer is enabled, current trigger must accept manual activation (default one, sysfs trigger, does).",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="proximity data read.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_iio_proximity_sensor_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_IIO_PROXIMITY_SENSOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="iio_device",
            .description="IIO device identifier. It's a space separated list of commands. For commands, if it's an integer value, will be interpreted as IIO device id. If it's a string starting with '/', will be interpreted as absolute path of IIO device on sysfs. If it's on the form 'i2c/X-YYYY', will evaluate to an i2c device on sysfs, where X is the bus number and YYYY is the device number, eg, 7-0069, for device 0x69 on bus 7. If it's on the form 'create,i2c,<rel_path>,<devnumber>,<devname>', where rel_path is the path of bus relative to '/sys/devices', them it will attempt to create an IIO device on that i2c bus and use it.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_iio_proximity_sensor_options, iio_device),
            .size=sizeof(const char *),
        },
        {
            .name="buffer_size",
            .description="IIO buffer size. If -1, buffering is disabled. If 0, will use default buffer size. If enabled (> 0), a trigger is necessary to perform readings. Set it using 'iio_trigger_name'; if no trigger name is set, it will attempt to create a default one, which is activated via TICK port.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_proximity_sensor_options, buffer_size),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="iio_trigger_name",
            .description="IIO trigger name. Name of IIO trigger that should be associated to this device for buffered readings. If not set and buffer enabled, will try to use device current trigger, if any. If none, will attempt to create a sysfs trigger",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_proximity_sensor_options, iio_trigger_name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
        {
            .name="use_device_default_scale",
            .description="If should use device own default scale. If false, it will attempt to use scale option.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_proximity_sensor_options, use_device_default_scale),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="scale",
            .description="Scale to applied to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_proximity_sensor_options, scale),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="use_device_default_offset",
            .description="If should use device own default offset. If false, it will attempt to use offset_x, offset_y and offset_z options.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_proximity_sensor_options, use_device_default_offset),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="offset",
            .description="Offset to be added to device raw readings",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_proximity_sensor_options, offset),
            .size=sizeof(double),
            .defvalue = {
                .f=0,
            },
        },
        {
            .name="sampling_frequency",
            .description="Sampling frequency of the sensor. If -1, use device default",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_proximity_sensor_options, sampling_frequency),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
        {
            .name="out_range",
            .description="Range of output packet. Usually, is the output range of used sensor. It'll be the 'min' and 'max' fields of drange packets sent on OUT port.",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_iio_proximity_sensor_options, out_range),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
            {},

        },
    }),
};
#endif

static const struct iio_node_type sol_flow_node_type_iio_proximity_sensor = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct iio_double_data),
    .options_size = sizeof(struct sol_flow_node_type_iio_proximity_sensor_options),
    .default_options = &sol_flow_node_type_iio_proximity_sensor_options_defaults,
    .init_type = sol_flow_node_type_iio_proximity_sensor_init_type_internal,
    .open = proximity_open,
    .close = iio_common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_iio_proximity_sensor_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_iio_proximity_sensor_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_iio_proximity_sensor_description,
#endif
},
    .out_port = SOL_FLOW_NODE_TYPE_IIO_PROXIMITY_SENSOR__OUT__OUT,
    .reader_cb = iio_double_reader_cb,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_IIO_PROXIMITY_SENSOR = &sol_flow_node_type_iio_proximity_sensor.base;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_iio(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_iio(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_IIO_GYROSCOPE,
            &SOL_FLOW_NODE_TYPE_IIO_MAGNETOMETER,
            &SOL_FLOW_NODE_TYPE_IIO_THERMOMETER,
            &SOL_FLOW_NODE_TYPE_IIO_PRESSURE_SENSOR,
            &SOL_FLOW_NODE_TYPE_IIO_COLOR_SENSOR,
            &SOL_FLOW_NODE_TYPE_IIO_ACCELEROMETER,
            &SOL_FLOW_NODE_TYPE_IIO_HUMIDITY_SENSOR,
            &SOL_FLOW_NODE_TYPE_IIO_ADC,
            &SOL_FLOW_NODE_TYPE_IIO_LIGHT_SENSOR,
            &SOL_FLOW_NODE_TYPE_IIO_PROXIMITY_SENSOR,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
