/* this file was auto-generated from ./src/modules/flow/jhd1313m1/jhd1313m1.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_JHD1313M1_DEFINED
#include "sol-flow/jhd1313m1.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_string__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_string,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_string__in__COLOR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_color,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_jhd1313m1_string_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_jhd1313m1_string__in__IN;
    if (port < 2)
        return &sol_flow_node_type_jhd1313m1_string__in__COLOR;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_jhd1313m1_string_init_type_internal(void)
{
    if (sol_flow_node_type_jhd1313m1_string__in__IN.packet_type == NULL) {
        sol_flow_node_type_jhd1313m1_string__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_jhd1313m1_string__in__COLOR.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
    }

    log_init();
}

static const struct sol_flow_node_type_jhd1313m1_string_options sol_flow_node_type_jhd1313m1_string_options_defaults = SOL_FLOW_NODE_TYPE_JHD1313M1_STRING_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_jhd1313m1_string_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "jhd1313m1/string",
    .category = "output/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_JHD1313M1_STRING",
    .options_symbol = "sol_flow_node_type_jhd1313m1_string_options",
    .description = "Grove-kit's LCD controller (JHD1313M1 model) for simple string displaying and backlight color setting. It uses two I2C addresses, one to control an HD44780 based display and one for RGB backlight. Display matrix is 16x2.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/jhd1313m1/string.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Set string to be displayed. If it's bigger than 16 characters, it breaks it to the second line. If it's bigger than 32 (what fits on the two display lines), it'll be cropped to this length.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "COLOR",
            .description="Set display's backlight color.",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_jhd1313m1_string_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_JHD1313M1_STRING_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="bus",
            .description="I2C bus to be used.",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_jhd1313m1_string_options, bus),
            .size=sizeof(int32_t),
        },
        {
            .name="color",
            .description="Initial background color.",
            .data_type="rgb",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_jhd1313m1_string_options, color),
            .size=sizeof(struct sol_rgb),
            .defvalue = {
                .rgb={.blue=255, .blue_max=255, .green=255, .green_max=255, .red=255, .red_max=255},
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_jhd1313m1_string = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct lcd_data),
    .options_size = sizeof(struct sol_flow_node_type_jhd1313m1_string_options),
    .default_options = &sol_flow_node_type_jhd1313m1_string_options_defaults,
    .init_type = sol_flow_node_type_jhd1313m1_string_init_type_internal,
    .open = lcd_string_open,
    .close = lcd_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_jhd1313m1_string_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_jhd1313m1_string_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_JHD1313M1_STRING = &sol_flow_node_type_jhd1313m1_string;

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__AUTO_SCROLL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_autoscroll,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__LEFT_TO_RIGHT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_ltr,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__COLOR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_color,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__COL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_col,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__ROW = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_row,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__BLINK_CURSOR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_blinking_cursor,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__UNDERLINE_CURSOR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_underline_cursor,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__DISPLAY_ON = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_display_on,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__PUT_CHAR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = put_char,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__PUT_STRING = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = put_string,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__SCROLL_RIGHT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = scroll_display,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__SCROLL_LEFT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = scroll_display,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_jhd1313m1_char__in__CLEAR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = display_clear,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_jhd1313m1_char_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_jhd1313m1_char__in__AUTO_SCROLL;
    if (port < 2)
        return &sol_flow_node_type_jhd1313m1_char__in__LEFT_TO_RIGHT;
    if (port < 3)
        return &sol_flow_node_type_jhd1313m1_char__in__COLOR;
    if (port < 4)
        return &sol_flow_node_type_jhd1313m1_char__in__COL;
    if (port < 5)
        return &sol_flow_node_type_jhd1313m1_char__in__ROW;
    if (port < 6)
        return &sol_flow_node_type_jhd1313m1_char__in__BLINK_CURSOR;
    if (port < 7)
        return &sol_flow_node_type_jhd1313m1_char__in__UNDERLINE_CURSOR;
    if (port < 8)
        return &sol_flow_node_type_jhd1313m1_char__in__DISPLAY_ON;
    if (port < 9)
        return &sol_flow_node_type_jhd1313m1_char__in__PUT_CHAR;
    if (port < 10)
        return &sol_flow_node_type_jhd1313m1_char__in__PUT_STRING;
    if (port < 11)
        return &sol_flow_node_type_jhd1313m1_char__in__SCROLL_RIGHT;
    if (port < 12)
        return &sol_flow_node_type_jhd1313m1_char__in__SCROLL_LEFT;
    if (port < 13)
        return &sol_flow_node_type_jhd1313m1_char__in__CLEAR;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_jhd1313m1_char_init_type_internal(void)
{
    if (sol_flow_node_type_jhd1313m1_char__in__AUTO_SCROLL.packet_type == NULL) {
        sol_flow_node_type_jhd1313m1_char__in__AUTO_SCROLL.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_jhd1313m1_char__in__LEFT_TO_RIGHT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_jhd1313m1_char__in__COLOR.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
        sol_flow_node_type_jhd1313m1_char__in__COL.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_jhd1313m1_char__in__ROW.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_jhd1313m1_char__in__BLINK_CURSOR.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_jhd1313m1_char__in__UNDERLINE_CURSOR.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_jhd1313m1_char__in__DISPLAY_ON.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_jhd1313m1_char__in__PUT_CHAR.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
        sol_flow_node_type_jhd1313m1_char__in__PUT_STRING.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_jhd1313m1_char__in__SCROLL_RIGHT.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_jhd1313m1_char__in__SCROLL_LEFT.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_jhd1313m1_char__in__CLEAR.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
    }

    log_init();
}

static const struct sol_flow_node_type_jhd1313m1_char_options sol_flow_node_type_jhd1313m1_char_options_defaults = SOL_FLOW_NODE_TYPE_JHD1313M1_CHAR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_jhd1313m1_char_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "jhd1313m1/char",
    .category = "output/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_JHD1313M1_CHAR",
    .options_symbol = "sol_flow_node_type_jhd1313m1_char_options",
    .description = "Grove-kit's LCD controller (JHD1313M1 model) for custom character/cursor manipulation and backlight color setting. It uses two I2C addresses, one to control an HD44780 based display and one for RGB backlight. Display matrix is 16x2.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/jhd1313m1/char.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "AUTO_SCROLL",
            .description="Set whether auto-scrolling is on or off. After it's set to on, the cursor position is held static until one sets it off again (or changes it explicitly).",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "LEFT_TO_RIGHT",
            .description="Set character entry direction to be left-to-right (true) or right-to-left (false).",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "COLOR",
            .description="Set display's backlight color.",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "COL",
            .description="Set display's current column. Valid range is 0-16 (16 is a virtual position useful when writing on the last column in right-to-left mode).",
            .data_type="int",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "ROW",
            .description="Set display's current row. Valid range is 0-1.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=4,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "BLINK_CURSOR",
            .description="Set whether the display's blinking cursor is on (true) or off (false).",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=5,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "UNDERLINE_CURSOR",
            .description="Set whether the display's underline cursor is on (true) or off (false).",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=6,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "DISPLAY_ON",
            .description="Set whether the display is on (true) or not (false). Naturally, it starts on by default.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=7,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PUT_CHAR",
            .description="Write given character at display's current row/column and advance them one position. The column will raise or lower depending on the entry direction, and no wrapping will occur -- if either top-left or bottom-right of the screen is hit, further char writes will update those limit cells until one changes the cursor position explicitly.",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=8,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "PUT_STRING",
            .description="Write a sequence of characters at display's current row/column and advance the cursor's position. The cursor's position will change differently depending on the entry direction, and, if either top-left or bottom-right of the screen is hit, the string will be cropped at that point.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=9,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "SCROLL_RIGHT",
            .description="Shift/scroll right the whole display by one column, keeping the char cell states (lcd's RAM state) as it was. Thus, a subsequent shift left will bring the display to what it looked like before the first shift.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=10,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "SCROLL_LEFT",
            .description="Shift/scroll left the whole display by one column, keeping the char cell states (lcd's RAM state) as it was. Thus, a subsequent shift left will bring the display to what it looked like before the first shift.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=11,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "CLEAR",
            .description="Clear the whole display, also resetting cursor to the top-left position.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=12,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_jhd1313m1_char_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_JHD1313M1_CHAR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="bus",
            .description="I2C bus to be used.",
            .data_type="int",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_jhd1313m1_char_options, bus),
            .size=sizeof(int32_t),
        },
        {
            .name="init_col",
            .description="Initial column of the cursor.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_jhd1313m1_char_options, init_col),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="init_row",
            .description="Initial row of the cursor.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_jhd1313m1_char_options, init_row),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="ltr",
            .description="Whether to start on left-to-right (true) or right-to-left (false) cursor advancing.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_jhd1313m1_char_options, ltr),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
        {
            .name="blink_cursor",
            .description="Set whether the display's blinking cursor is on (true) or off (false).",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_jhd1313m1_char_options, blink_cursor),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="underline_cursor",
            .description="Set whether the display's underline cursor is on (true) or off (false).",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_jhd1313m1_char_options, underline_cursor),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="auto_scroll",
            .description="Whether to start on auto scroll mode (true) or not (false).",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_jhd1313m1_char_options, auto_scroll),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="color",
            .description="Initial background color.",
            .data_type="rgb",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_jhd1313m1_char_options, color),
            .size=sizeof(struct sol_rgb),
            .defvalue = {
                .rgb={.blue=255, .blue_max=255, .green=255, .green_max=255, .red=255, .red_max=255},
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_jhd1313m1_char = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct lcd_data),
    .options_size = sizeof(struct sol_flow_node_type_jhd1313m1_char_options),
    .default_options = &sol_flow_node_type_jhd1313m1_char_options_defaults,
    .init_type = sol_flow_node_type_jhd1313m1_char_init_type_internal,
    .open = lcd_char_open,
    .close = lcd_close,
    .ports_in_count = 13,
    .get_port_in = sol_flow_node_type_jhd1313m1_char_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_jhd1313m1_char_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_JHD1313M1_CHAR = &sol_flow_node_type_jhd1313m1_char;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_jhd1313m1(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_jhd1313m1(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_JHD1313M1_STRING,
            &SOL_FLOW_NODE_TYPE_JHD1313M1_CHAR,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
