/* this file was auto-generated from ./src/modules/flow/led-strip/led-strip.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_LED_STRIP_DEFINED
#include "sol-flow/led-strip.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_led_strip_lpd8806__in__PIXEL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = pixel_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_led_strip_lpd8806__in__COLOR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = color_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_led_strip_lpd8806__in__FLUSH = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = flush_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_led_strip_lpd8806_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_led_strip_lpd8806__in__PIXEL;
    if (port < 2)
        return &sol_flow_node_type_led_strip_lpd8806__in__COLOR;
    if (port < 3)
        return &sol_flow_node_type_led_strip_lpd8806__in__FLUSH;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_led_strip_lpd8806_init_type_internal(void)
{
    if (sol_flow_node_type_led_strip_lpd8806__in__PIXEL.packet_type == NULL) {
        sol_flow_node_type_led_strip_lpd8806__in__PIXEL.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_led_strip_lpd8806__in__COLOR.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
        sol_flow_node_type_led_strip_lpd8806__in__FLUSH.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
    }

    log_init();
}

static const struct sol_flow_node_type_led_strip_lpd8806_options sol_flow_node_type_led_strip_lpd8806_options_defaults = SOL_FLOW_NODE_TYPE_LED_STRIP_LPD8806_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_led_strip_lpd8806_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "led-strip/lpd8806",
    .category = "output/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_LED_STRIP_LPD8806",
    .options_symbol = "sol_flow_node_type_led_strip_lpd8806_options",
    .description = "LPD8806 RGB led strip controller.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "PIXEL",
            .description="Pixel position to have its colour set. See node description to understand details of how pixel colours are set.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "COLOR",
            .description="Colour of current pixel position. See node description to understand details of how pixel colours are set.",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "FLUSH",
            .description="Flushes current colour setting to device, effectively applying them.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_led_strip_lpd8806_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_LED_STRIP_LPD8806_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="bus",
            .description="SPI Bus number.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_led_strip_lpd8806_options, bus),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="chip_select",
            .description="SPI chip to operate.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_led_strip_lpd8806_options, chip_select),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="pixel_count",
            .description="Pixel count. How many LEDs are on the strip.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_led_strip_lpd8806_options, pixel_count),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=32,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_led_strip_lpd8806 = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct lcd_strip_lpd8806_data),
    .options_size = sizeof(struct sol_flow_node_type_led_strip_lpd8806_options),
    .default_options = &sol_flow_node_type_led_strip_lpd8806_options_defaults,
    .init_type = sol_flow_node_type_led_strip_lpd8806_init_type_internal,
    .open = led_strip_controler_open,
    .close = led_strip_controler_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_led_strip_lpd8806_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_led_strip_lpd8806_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_LED_STRIP_LPD8806 = &sol_flow_node_type_led_strip_lpd8806;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_led_strip(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_led_strip(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_LED_STRIP_LPD8806,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
