/* this file was auto-generated from ./src/modules/flow/network/network.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_NETWORK_DEFINED
#include "sol-flow/network.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_network_boolean__in__ADDRESS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = network_address_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_network_boolean__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_network_boolean_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_network_boolean__in__ADDRESS;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_network_boolean_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_network_boolean__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_network_boolean_init_type_internal(void)
{
    if (sol_flow_node_type_network_boolean__in__ADDRESS.packet_type == NULL) {
        sol_flow_node_type_network_boolean__in__ADDRESS.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_network_boolean__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_network_boolean_options sol_flow_node_type_network_boolean_options_defaults = SOL_FLOW_NODE_TYPE_NETWORK_BOOLEAN_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_network_boolean_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "network/boolean",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_NETWORK_BOOLEAN",
    .options_symbol = "sol_flow_node_type_network_boolean_options",
    .description = "Provides boolean packets after connect or disconnect from network",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/network.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "ADDRESS",
            .description="Which interface should be monitored (it MUST be a regexp - so if you want a exact match with a name, use '^name$')",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="A boolean packet when network changes. If it's connect true, otherwise false.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_network_boolean_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_NETWORK_BOOLEAN_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="address",
            .description="Which interface should be monitored (it MUST be a regexp - so if you want a exact match with a name, use '^name$')",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_network_boolean_options, address),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_network_boolean = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct network_data),
    .options_size = sizeof(struct sol_flow_node_type_network_boolean_options),
    .default_options = &sol_flow_node_type_network_boolean_options_defaults,
    .init_type = sol_flow_node_type_network_boolean_init_type_internal,
    .open = network_open,
    .close = network_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_network_boolean_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_network_boolean_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_network_boolean_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_NETWORK_BOOLEAN = &sol_flow_node_type_network_boolean;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_network(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_network(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_NETWORK_BOOLEAN,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
