/* this file was auto-generated from ./src/modules/flow/persistence/persistence.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_PERSISTENCE_DEFINED
#include "sol-flow/persistence.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>
#include <float.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_persistence_boolean__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = persist_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_persistence_boolean__in__RESET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = reset_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_persistence_boolean__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_persistence_boolean_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_boolean__in__IN;
    if (port < 2)
        return &sol_flow_node_type_persistence_boolean__in__RESET;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_persistence_boolean_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_boolean__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_persistence_boolean_init_type_internal(void)
{
    if (sol_flow_node_type_persistence_boolean__in__IN.packet_type == NULL) {
        sol_flow_node_type_persistence_boolean__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_persistence_boolean__in__RESET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_persistence_boolean__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_persistence_boolean_options sol_flow_node_type_persistence_boolean_options_defaults = SOL_FLOW_NODE_TYPE_PERSISTENCE_BOOLEAN_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_persistence_boolean_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "persistence/boolean",
    .category = "io/persistence",
    .symbol = "SOL_FLOW_NODE_TYPE_PERSISTENCE_BOOLEAN",
    .options_symbol = "sol_flow_node_type_persistence_boolean_options",
    .description = "Persists the last input packet's data it receives to storage, also repeating that packet on output port. If the value is unchanged, then the packet is not repeated, this allows the use of persistence in feedback loops with setters of data to be persisted. Note that upon a new connection on the unique output port, if a previous stored packet is found, it will already be sent.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/persistence.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="A boolean packet to persist (and repeat on output)",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "RESET",
            .description="Reset persist value to its default and send to output the new value",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="A boolean packet with the persisted value of the node",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_persistence_boolean_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_PERSISTENCE_BOOLEAN_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="name",
            .description="Name to persist a boolean packet. If 'storage' is 'fs', name can be a fully fledged path to the file where the value will be stored.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_boolean_options, name),
            .size=sizeof(const char *),
        },
        {
            .name="storage",
            .description="Storage where data will be persisted. It can be of the following: fs, efivars",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_boolean_options, storage),
            .size=sizeof(const char *),
        },
        {
            .name="default_value",
            .description="Default value for this node, when there's no previous value persisted",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_boolean_options, default_value),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
            {},

        },
    }),
};
#endif

static const struct persistence_node_type sol_flow_node_type_persistence_boolean = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct persist_boolean_data),
    .options_size = sizeof(struct sol_flow_node_type_persistence_boolean_options),
    .default_options = &sol_flow_node_type_persistence_boolean_options_defaults,
    .init_type = sol_flow_node_type_persistence_boolean_init_type_internal,
    .open = persist_boolean_open,
    .close = persist_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_persistence_boolean_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_persistence_boolean_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_persistence_boolean_description,
#endif
},
    .get_packet_data = persist_boolean_get_packet_data,
    .send_packet = persist_boolean_send_packet,
    .get_default = persist_boolean_get_default,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PERSISTENCE_BOOLEAN = &sol_flow_node_type_persistence_boolean.base;

static struct sol_flow_port_type_in sol_flow_node_type_persistence_byte__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = persist_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_persistence_byte__in__RESET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = reset_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_persistence_byte__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_persistence_byte_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_byte__in__IN;
    if (port < 2)
        return &sol_flow_node_type_persistence_byte__in__RESET;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_persistence_byte_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_byte__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_persistence_byte_init_type_internal(void)
{
    if (sol_flow_node_type_persistence_byte__in__IN.packet_type == NULL) {
        sol_flow_node_type_persistence_byte__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
        sol_flow_node_type_persistence_byte__in__RESET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_persistence_byte__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
    }

    log_init();
}

static const struct sol_flow_node_type_persistence_byte_options sol_flow_node_type_persistence_byte_options_defaults = SOL_FLOW_NODE_TYPE_PERSISTENCE_BYTE_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_persistence_byte_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "persistence/byte",
    .category = "io/persistence",
    .symbol = "SOL_FLOW_NODE_TYPE_PERSISTENCE_BYTE",
    .options_symbol = "sol_flow_node_type_persistence_byte_options",
    .description = "Persists the last input packet's data it receives to storage, also repeating that packet on output port. If the value is unchanged, then the packet is not repeated, this allows the use of persistence in feedback loops with setters of data to be persisted. Note that upon a new connection on the unique output port, if a previous stored packet is found, it will already be sent.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/persistence.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="A byte packet to persist (and repeat on output)",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "RESET",
            .description="Reset persist value to its default and send to output the new value",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="A byte packet with the persisted value of the node",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_persistence_byte_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_PERSISTENCE_BYTE_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="name",
            .description="Name to persist a byte packet. If 'storage' is 'fs', name can be a fully fledged path to the file where the value will be stored.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_byte_options, name),
            .size=sizeof(const char *),
        },
        {
            .name="storage",
            .description="Storage where data will be persisted. It can be of the following: fs, efivars",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_byte_options, storage),
            .size=sizeof(const char *),
        },
        {
            .name="default_value",
            .description="Default value for this node, when there's no previous value persisted",
            .data_type="byte",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_byte_options, default_value),
            .size=sizeof(unsigned char),
            .defvalue = {
                .byte=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct persistence_node_type sol_flow_node_type_persistence_byte = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct persist_byte_data),
    .options_size = sizeof(struct sol_flow_node_type_persistence_byte_options),
    .default_options = &sol_flow_node_type_persistence_byte_options_defaults,
    .init_type = sol_flow_node_type_persistence_byte_init_type_internal,
    .open = persist_byte_open,
    .close = persist_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_persistence_byte_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_persistence_byte_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_persistence_byte_description,
#endif
},
    .get_packet_data = persist_byte_get_packet_data,
    .send_packet = persist_byte_send_packet,
    .get_default = persist_byte_get_default,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PERSISTENCE_BYTE = &sol_flow_node_type_persistence_byte.base;

static struct sol_flow_port_type_in sol_flow_node_type_persistence_float__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = persist_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_persistence_float__in__RESET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = reset_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_persistence_float__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_persistence_float_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_float__in__IN;
    if (port < 2)
        return &sol_flow_node_type_persistence_float__in__RESET;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_persistence_float_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_float__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_persistence_float_init_type_internal(void)
{
    if (sol_flow_node_type_persistence_float__in__IN.packet_type == NULL) {
        sol_flow_node_type_persistence_float__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_persistence_float__in__RESET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_persistence_float__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_persistence_float_options sol_flow_node_type_persistence_float_options_defaults = SOL_FLOW_NODE_TYPE_PERSISTENCE_FLOAT_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_persistence_float_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "persistence/float",
    .category = "io/persistence",
    .symbol = "SOL_FLOW_NODE_TYPE_PERSISTENCE_FLOAT",
    .options_symbol = "sol_flow_node_type_persistence_float_options",
    .description = "Persists the last input packet's data it receives to storage, also repeating that packet on output port. If the value is unchanged, then the packet is not repeated, this allows the use of persistence in feedback loops with setters of data to be persisted. Note that upon a new connection on the unique output port, if a previous stored packet is found, it will already be sent.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/persistence.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="An float packet to persist (and repeat on output)",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "RESET",
            .description="Reset persist value to its default and send to output the new value",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="A float packet with the persisted value of the node",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_persistence_float_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_PERSISTENCE_FLOAT_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="name",
            .description="Name to persist a float packet. If 'storage' is 'fs', name can be a fully fledged path to the file where the value will be stored.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_float_options, name),
            .size=sizeof(const char *),
        },
        {
            .name="storage",
            .description="Storage where data will be persisted. It can be of the following: fs, efivars",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_float_options, storage),
            .size=sizeof(const char *),
        },
        {
            .name="default_value",
            .description="Default value for this node, when there's no previous value persisted",
            .data_type="float",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_float_options, default_value),
            .size=sizeof(double),
            .defvalue = {
                .f=0.0,
            },
        },
        {
            .name="default_value_spec",
            .description="Default range for this node, when there's no previous value persisted",
            .data_type="drange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_float_options, default_value_spec),
            .size=sizeof(struct sol_drange_spec),
            .defvalue = {
                .drange_spec={.max=DBL_MAX, .min=-DBL_MAX, .step=DBL_MIN},
            },
        },
        {
            .name="store_only_val",
            .description="Store only drange val, discarding min, max and step values",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_float_options, store_only_val),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
            {},

        },
    }),
};
#endif

static const struct persistence_node_type sol_flow_node_type_persistence_float = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct persist_drange_data),
    .options_size = sizeof(struct sol_flow_node_type_persistence_float_options),
    .default_options = &sol_flow_node_type_persistence_float_options_defaults,
    .init_type = sol_flow_node_type_persistence_float_init_type_internal,
    .open = persist_drange_open,
    .close = persist_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_persistence_float_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_persistence_float_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_persistence_float_description,
#endif
},
    .get_packet_data = persist_drange_get_packet_data,
    .send_packet = persist_drange_send_packet,
    .get_default = persist_drange_get_default,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PERSISTENCE_FLOAT = &sol_flow_node_type_persistence_float.base;

static struct sol_flow_port_type_in sol_flow_node_type_persistence_int__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = persist_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_persistence_int__in__RESET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = reset_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_persistence_int__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_persistence_int_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_int__in__IN;
    if (port < 2)
        return &sol_flow_node_type_persistence_int__in__RESET;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_persistence_int_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_int__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_persistence_int_init_type_internal(void)
{
    if (sol_flow_node_type_persistence_int__in__IN.packet_type == NULL) {
        sol_flow_node_type_persistence_int__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_persistence_int__in__RESET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_persistence_int__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_persistence_int_options sol_flow_node_type_persistence_int_options_defaults = SOL_FLOW_NODE_TYPE_PERSISTENCE_INT_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_persistence_int_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "persistence/int",
    .category = "io/persistence",
    .symbol = "SOL_FLOW_NODE_TYPE_PERSISTENCE_INT",
    .options_symbol = "sol_flow_node_type_persistence_int_options",
    .description = "Persists the last input packet's data it receives to storage, also repeating that packet on output port. If the value is unchanged, then the packet is not repeated, this allows the use of persistence in feedback loops with setters of data to be persisted. Note that upon a new connection on the unique output port, if a previous stored packet is found, it will already be sent.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/persistence.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="A int packet to persist (and repeat on output)",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "RESET",
            .description="Reset persist value to its default and send to output the new value",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="A int packet with the persisted value of the node",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_persistence_int_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_PERSISTENCE_INT_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="name",
            .description="Name to persist an integer packet with. If 'storage' is 'fs', the name must be a fully fledged path to the file where the value will be stored.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_int_options, name),
            .size=sizeof(const char *),
        },
        {
            .name="storage",
            .description="Storage where data will be persisted. It can be of the following: fs, efivars",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_int_options, storage),
            .size=sizeof(const char *),
        },
        {
            .name="default_value",
            .description="Default value for this node, when there's no previous value persisted",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_int_options, default_value),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
        {
            .name="default_value_spec",
            .description="Default range for this node, when there's no previous value persisted",
            .data_type="irange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_int_options, default_value_spec),
            .size=sizeof(struct sol_irange_spec),
            .defvalue = {
                .irange_spec={.max=INT32_MAX, .min=INT32_MIN, .step=1},
            },
        },
        {
            .name="store_only_val",
            .description="Store only irange val, discarding min, max and step values",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_int_options, store_only_val),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
            {},

        },
    }),
};
#endif

static const struct persistence_node_type sol_flow_node_type_persistence_int = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct persist_irange_data),
    .options_size = sizeof(struct sol_flow_node_type_persistence_int_options),
    .default_options = &sol_flow_node_type_persistence_int_options_defaults,
    .init_type = sol_flow_node_type_persistence_int_init_type_internal,
    .open = persist_irange_open,
    .close = persist_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_persistence_int_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_persistence_int_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_persistence_int_description,
#endif
},
    .get_packet_data = persist_irange_get_packet_data,
    .send_packet = persist_irange_send_packet,
    .get_default = persist_irange_get_default,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PERSISTENCE_INT = &sol_flow_node_type_persistence_int.base;

static struct sol_flow_port_type_in sol_flow_node_type_persistence_string__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = persist_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_persistence_string__in__RESET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = reset_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_persistence_string__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_persistence_string_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_string__in__IN;
    if (port < 2)
        return &sol_flow_node_type_persistence_string__in__RESET;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_persistence_string_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_string__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_persistence_string_init_type_internal(void)
{
    if (sol_flow_node_type_persistence_string__in__IN.packet_type == NULL) {
        sol_flow_node_type_persistence_string__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_persistence_string__in__RESET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_persistence_string__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_persistence_string_options sol_flow_node_type_persistence_string_options_defaults = SOL_FLOW_NODE_TYPE_PERSISTENCE_STRING_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_persistence_string_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "persistence/string",
    .category = "io/persistence",
    .symbol = "SOL_FLOW_NODE_TYPE_PERSISTENCE_STRING",
    .options_symbol = "sol_flow_node_type_persistence_string_options",
    .description = "Persists the last input packet's data it receives to storage, also repeating that packet on output port. If the value is unchanged, then the packet is not repeated, this allows the use of persistence in feedback loops with setters of data to be persisted. Note that upon a new connection on the unique output port, if a previous stored packet is found, it will already be sent.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/persistence.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="A string packet to persist (and repeat on output)",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "RESET",
            .description="Reset persist value to its default and send to output the new value",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="A string packet with the persisted value of the node",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_persistence_string_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_PERSISTENCE_STRING_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="name",
            .description="Name to persist a string packet. If 'storage' is 'fs', name can be a fully fledged path to the file where the value will be stored.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_string_options, name),
            .size=sizeof(const char *),
        },
        {
            .name="storage",
            .description="Storage where data will be persisted. It can be of the following: fs, efivars",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_string_options, storage),
            .size=sizeof(const char *),
        },
        {
            .name="default_value",
            .description="Default value for this node, when there's no previous value persisted",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_string_options, default_value),
            .size=sizeof(const char *),
            .defvalue = {
                .s="",
            },
        },
            {},

        },
    }),
};
#endif

static const struct persistence_node_type sol_flow_node_type_persistence_string = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct persist_string_data),
    .options_size = sizeof(struct sol_flow_node_type_persistence_string_options),
    .default_options = &sol_flow_node_type_persistence_string_options_defaults,
    .init_type = sol_flow_node_type_persistence_string_init_type_internal,
    .open = persist_string_open,
    .close = persist_string_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_persistence_string_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_persistence_string_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_persistence_string_description,
#endif
},
    .get_packet_data = persist_string_get_packet_data,
    .send_packet = persist_string_send_packet,
    .get_default = persist_string_get_default,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PERSISTENCE_STRING = &sol_flow_node_type_persistence_string.base;

static struct sol_flow_port_type_in sol_flow_node_type_persistence_rgb__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = persist_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_persistence_rgb__in__RESET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = reset_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_persistence_rgb__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_persistence_rgb_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_rgb__in__IN;
    if (port < 2)
        return &sol_flow_node_type_persistence_rgb__in__RESET;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_persistence_rgb_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_rgb__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_persistence_rgb_init_type_internal(void)
{
    if (sol_flow_node_type_persistence_rgb__in__IN.packet_type == NULL) {
        sol_flow_node_type_persistence_rgb__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
        sol_flow_node_type_persistence_rgb__in__RESET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_persistence_rgb__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
    }

    log_init();
}

static const struct sol_flow_node_type_persistence_rgb_options sol_flow_node_type_persistence_rgb_options_defaults = SOL_FLOW_NODE_TYPE_PERSISTENCE_RGB_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_persistence_rgb_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "persistence/rgb",
    .category = "io/persistence",
    .symbol = "SOL_FLOW_NODE_TYPE_PERSISTENCE_RGB",
    .options_symbol = "sol_flow_node_type_persistence_rgb_options",
    .description = "Persists the last input packet's data it receives to storage, also repeating that packet on output port. If the value is unchanged, then the packet is not repeated, this allows the use of persistence in feedback loops with setters of data to be persisted. Note that upon a new connection on the unique output port, if a previous stored packet is found, it will already be sent.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/persistence.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="A RGB packet to persist (and repeat on output)",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "RESET",
            .description="Reset persist value to its default and send to output the new value",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="A RGB packet with the persisted value of the node",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_persistence_rgb_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_PERSISTENCE_RGB_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="name",
            .description="Name to persist a rgb packet. If 'storage' is 'fs', name can be a fully fledged path to the file where the value will be stored.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_rgb_options, name),
            .size=sizeof(const char *),
        },
        {
            .name="storage",
            .description="Storage where data will be persisted. It can be of the following: fs, efivars",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_rgb_options, storage),
            .size=sizeof(const char *),
        },
        {
            .name="default_value",
            .description="Default value for this node, when there's no previous value persisted",
            .data_type="rgb",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_rgb_options, default_value),
            .size=sizeof(struct sol_rgb),
            .defvalue = {
                .rgb={.blue=0, .blue_max=255, .green=0, .green_max=255, .red=0, .red_max=255},
            },
        },
            {},

        },
    }),
};
#endif

static const struct persistence_node_type sol_flow_node_type_persistence_rgb = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct persist_rgb_data),
    .options_size = sizeof(struct sol_flow_node_type_persistence_rgb_options),
    .default_options = &sol_flow_node_type_persistence_rgb_options_defaults,
    .init_type = sol_flow_node_type_persistence_rgb_init_type_internal,
    .open = persist_rgb_open,
    .close = persist_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_persistence_rgb_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_persistence_rgb_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_persistence_rgb_description,
#endif
},
    .get_packet_data = persist_rgb_get_packet_data,
    .send_packet = persist_rgb_send_packet,
    .get_default = persist_rgb_get_default,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PERSISTENCE_RGB = &sol_flow_node_type_persistence_rgb.base;

static struct sol_flow_port_type_in sol_flow_node_type_persistence_direction_vector__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = persist_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_persistence_direction_vector__in__RESET = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = reset_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_persistence_direction_vector__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_persistence_direction_vector_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_direction_vector__in__IN;
    if (port < 2)
        return &sol_flow_node_type_persistence_direction_vector__in__RESET;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_persistence_direction_vector_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_persistence_direction_vector__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_persistence_direction_vector_init_type_internal(void)
{
    if (sol_flow_node_type_persistence_direction_vector__in__IN.packet_type == NULL) {
        sol_flow_node_type_persistence_direction_vector__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
        sol_flow_node_type_persistence_direction_vector__in__RESET.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_persistence_direction_vector__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
    }

    log_init();
}

static const struct sol_flow_node_type_persistence_direction_vector_options sol_flow_node_type_persistence_direction_vector_options_defaults = SOL_FLOW_NODE_TYPE_PERSISTENCE_DIRECTION_VECTOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_persistence_direction_vector_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "persistence/direction-vector",
    .category = "io/persistence",
    .symbol = "SOL_FLOW_NODE_TYPE_PERSISTENCE_DIRECTION_VECTOR",
    .options_symbol = "sol_flow_node_type_persistence_direction_vector_options",
    .description = "Persists the last input packet's data it receives to storage, also repeating that packet on output port. If the value is unchanged, then the packet is not repeated, this allows the use of persistence in feedback loops with setters of data to be persisted. Note that upon a new connection on the unique output port, if a previous stored packet is found, it will already be sent.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/persistence.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="A RGB packet to persist (and repeat on output)",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "RESET",
            .description="Reset persist value to its default and send to output the new value",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="A RGB packet with the persisted value of the node",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_persistence_direction_vector_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_PERSISTENCE_DIRECTION_VECTOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="name",
            .description="Name to persist a direction-vector packet. If 'storage' is 'fs', name can be a fully fledged path to the file where the value will be stored.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_direction_vector_options, name),
            .size=sizeof(const char *),
        },
        {
            .name="storage",
            .description="Storage where data will be persisted. It can be of the following: fs, efivars",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_persistence_direction_vector_options, storage),
            .size=sizeof(const char *),
        },
        {
            .name="default_value",
            .description="Default value for this node, when there's no previous value persisted",
            .data_type="direction-vector",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_persistence_direction_vector_options, default_value),
            .size=sizeof(struct sol_direction_vector),
            .defvalue = {
                .direction_vector={.max=DBL_MAX, .min=-DBL_MAX, .x=0, .y=0, .z=0},
            },
        },
            {},

        },
    }),
};
#endif

static const struct persistence_node_type sol_flow_node_type_persistence_direction_vector = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct persist_direction_vector_data),
    .options_size = sizeof(struct sol_flow_node_type_persistence_direction_vector_options),
    .default_options = &sol_flow_node_type_persistence_direction_vector_options_defaults,
    .init_type = sol_flow_node_type_persistence_direction_vector_init_type_internal,
    .open = persist_direction_vector_open,
    .close = persist_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_persistence_direction_vector_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_persistence_direction_vector_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_persistence_direction_vector_description,
#endif
},
    .get_packet_data = persist_direction_vector_get_packet_data,
    .send_packet = persist_direction_vector_send_packet,
    .get_default = persist_direction_vector_get_default,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PERSISTENCE_DIRECTION_VECTOR = &sol_flow_node_type_persistence_direction_vector.base;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_persistence(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_persistence(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_PERSISTENCE_BOOLEAN,
            &SOL_FLOW_NODE_TYPE_PERSISTENCE_BYTE,
            &SOL_FLOW_NODE_TYPE_PERSISTENCE_FLOAT,
            &SOL_FLOW_NODE_TYPE_PERSISTENCE_INT,
            &SOL_FLOW_NODE_TYPE_PERSISTENCE_STRING,
            &SOL_FLOW_NODE_TYPE_PERSISTENCE_RGB,
            &SOL_FLOW_NODE_TYPE_PERSISTENCE_DIRECTION_VECTOR,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
