/* this file was auto-generated from ./src/modules/flow/piezo-speaker/piezo-speaker.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_PIEZO_SPEAKER_DEFINED
#include "sol-flow/piezo-speaker.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_piezo_speaker_sound__in__TUNE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = tune_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_piezo_speaker_sound__in__ENABLED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = enabled_set,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_piezo_speaker_sound_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_piezo_speaker_sound__in__TUNE;
    if (port < 2)
        return &sol_flow_node_type_piezo_speaker_sound__in__ENABLED;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_piezo_speaker_sound_init_type_internal(void)
{
    if (sol_flow_node_type_piezo_speaker_sound__in__TUNE.packet_type == NULL) {
        sol_flow_node_type_piezo_speaker_sound__in__TUNE.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_piezo_speaker_sound__in__ENABLED.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_piezo_speaker_sound_options sol_flow_node_type_piezo_speaker_sound_options_defaults = SOL_FLOW_NODE_TYPE_PIEZO_SPEAKER_SOUND_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_piezo_speaker_sound_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "piezo-speaker/sound",
    .category = "output/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_PIEZO_SPEAKER_SOUND",
    .options_symbol = "sol_flow_node_type_piezo_speaker_sound_options",
    .description = "Receives string packages (or load-time configurations) with tunes to be played by a piezo buzzer/speaker over PWM",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/piezo-speaker.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TUNE",
            .description="The tablature string to play on the node. The syntax for it is <note_array|beats_array|base_tempo_in_us>, as in 'ccggaa|111122|300' -- that plays do do sol sol la la in such a way that the first four notes last 300 ms and the last two hold for 600 ms. Possible individual notes are 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'C', and beats can only be on the 1-9 range.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "ENABLED",
            .description="Start/stop buzzing",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_piezo_speaker_sound_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_PIEZO_SPEAKER_SOUND_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="tune",
            .description="Pre-set tune to buzz with",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_piezo_speaker_sound_options, tune),
            .size=sizeof(const char *),
            .defvalue = {
                .s="",
            },
        },
        {
            .name="pin",
            .description="Label of the desired pin on the board. If raw is set to true, this should be \"<device> <channel>\" pair, e.g. \"0 3\".",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_piezo_speaker_sound_options, pin),
            .size=sizeof(const char *),
        },
        {
            .name="raw",
            .description="Change 'pin' meaning to be the system parameters needed to address the desired pin. Use it if you know what you are doing.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_piezo_speaker_sound_options, raw),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="loop",
            .description="Whether to loop indefinetely on the input tune",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_piezo_speaker_sound_options, loop),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_piezo_speaker_sound = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct piezo_speaker_data),
    .options_size = sizeof(struct sol_flow_node_type_piezo_speaker_sound_options),
    .default_options = &sol_flow_node_type_piezo_speaker_sound_options_defaults,
    .init_type = sol_flow_node_type_piezo_speaker_sound_init_type_internal,
    .open = piezo_speaker_open,
    .close = piezo_speaker_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_piezo_speaker_sound_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_piezo_speaker_sound_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PIEZO_SPEAKER_SOUND = &sol_flow_node_type_piezo_speaker_sound;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_piezo_speaker(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_piezo_speaker(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_PIEZO_SPEAKER_SOUND,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
