/* this file was auto-generated from ./src/modules/flow/power-supply/power-supply.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_POWER_SUPPLY_DEFINED
#include "sol-flow/power-supply.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_power_supply_get_list__in__TRIGGER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_list_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_power_supply_get_list__in__TYPE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_type_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_power_supply_get_list__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_power_supply_get_list_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_power_supply_get_list__in__TRIGGER;
    if (port < 2)
        return &sol_flow_node_type_power_supply_get_list__in__TYPE;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_power_supply_get_list_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_power_supply_get_list__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_power_supply_get_list_init_type_internal(void)
{
    if (sol_flow_node_type_power_supply_get_list__in__TRIGGER.packet_type == NULL) {
        sol_flow_node_type_power_supply_get_list__in__TRIGGER.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_power_supply_get_list__in__TYPE.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_power_supply_get_list__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_power_supply_get_list_options sol_flow_node_type_power_supply_get_list_options_defaults = SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_LIST_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_power_supply_get_list_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "power-supply/get-list",
    .category = "power-supply",
    .symbol = "SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_LIST",
    .options_symbol = "sol_flow_node_type_power_supply_get_list_options",
    .description = "Send list of all power supplies attached to board.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/power-supply/get-list.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TRIGGER",
            .description="Trigger to get list of power supplies.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "TYPE",
            .description="Name of type to be used to filter power supplies. It can be 'Any', 'Unknown', 'Battery', 'UPS', 'Mains', 'USB', 'USB_DCP', 'USB_CDP', 'USB_ACA'.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Name of power supplies that match specified type.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_power_supply_get_list_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_LIST_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="type",
            .description="Name of type to be used to filter power supplies. It can be 'Any', 'Unknown', 'Battery', 'UPS', 'Mains', 'USB', 'USB_DCP', 'USB_CDP', 'USB_ACA'. If 'null', no filter is applied.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_power_supply_get_list_options, type),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_power_supply_get_list = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct get_list_data),
    .options_size = sizeof(struct sol_flow_node_type_power_supply_get_list_options),
    .default_options = &sol_flow_node_type_power_supply_get_list_options_defaults,
    .init_type = sol_flow_node_type_power_supply_get_list_init_type_internal,
    .open = get_list_open,
    .close = NULL,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_power_supply_get_list_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_power_supply_get_list_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_power_supply_get_list_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_LIST = &sol_flow_node_type_power_supply_get_list;

static struct sol_flow_port_type_in sol_flow_node_type_power_supply_get_capacity__in__TRIGGER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_capacity,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_power_supply_get_capacity__in__NAME = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_supply_name,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_power_supply_get_capacity__out__CAPACITY = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_power_supply_get_capacity__out__CAPACITY_LEVEL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_power_supply_get_capacity_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_power_supply_get_capacity__in__TRIGGER;
    if (port < 2)
        return &sol_flow_node_type_power_supply_get_capacity__in__NAME;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_power_supply_get_capacity_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_power_supply_get_capacity__out__CAPACITY;
    if (port < 2)
        return &sol_flow_node_type_power_supply_get_capacity__out__CAPACITY_LEVEL;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_power_supply_get_capacity_init_type_internal(void)
{
    if (sol_flow_node_type_power_supply_get_capacity__in__TRIGGER.packet_type == NULL) {
        sol_flow_node_type_power_supply_get_capacity__in__TRIGGER.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_power_supply_get_capacity__in__NAME.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_power_supply_get_capacity__out__CAPACITY.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_power_supply_get_capacity__out__CAPACITY_LEVEL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_power_supply_get_capacity_options sol_flow_node_type_power_supply_get_capacity_options_defaults = SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_CAPACITY_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_power_supply_get_capacity_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "power-supply/get-capacity",
    .category = "power-supply",
    .symbol = "SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_CAPACITY",
    .options_symbol = "sol_flow_node_type_power_supply_get_capacity_options",
    .description = "Get capacity of a power supply. Usually provided by batteries.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/power-supply/get-capacity.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TRIGGER",
            .description="Trigger to get capacity.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "NAME",
            .description="Name of power supply.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "CAPACITY",
            .description="Supply capacity percentage.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "CAPACITY_LEVEL",
            .description="Textual description of capacity. May vary between 'Unknown', 'Critical', 'Low', 'Normal', 'High' and 'Full'.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_power_supply_get_capacity_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_CAPACITY_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="name",
            .description="Name of power supply from where capacity will be fetched.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_power_supply_get_capacity_options, name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_power_supply_get_capacity = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct get_props_data),
    .options_size = sizeof(struct sol_flow_node_type_power_supply_get_capacity_options),
    .default_options = &sol_flow_node_type_power_supply_get_capacity_options_defaults,
    .init_type = sol_flow_node_type_power_supply_get_capacity_init_type_internal,
    .open = get_props_open,
    .close = get_props_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_power_supply_get_capacity_get_port_in_internal,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_power_supply_get_capacity_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_power_supply_get_capacity_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_CAPACITY = &sol_flow_node_type_power_supply_get_capacity;

static struct sol_flow_port_type_in sol_flow_node_type_power_supply_get_info__in__TRIGGER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = get_info,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_power_supply_get_info__in__NAME = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = set_supply_name,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_power_supply_get_info__out__MANUFACTURER = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_power_supply_get_info__out__MODEL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_power_supply_get_info__out__SERIAL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_power_supply_get_info_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_power_supply_get_info__in__TRIGGER;
    if (port < 2)
        return &sol_flow_node_type_power_supply_get_info__in__NAME;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_power_supply_get_info_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_power_supply_get_info__out__MANUFACTURER;
    if (port < 2)
        return &sol_flow_node_type_power_supply_get_info__out__MODEL;
    if (port < 3)
        return &sol_flow_node_type_power_supply_get_info__out__SERIAL;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_power_supply_get_info_init_type_internal(void)
{
    if (sol_flow_node_type_power_supply_get_info__in__TRIGGER.packet_type == NULL) {
        sol_flow_node_type_power_supply_get_info__in__TRIGGER.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_power_supply_get_info__in__NAME.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_power_supply_get_info__out__MANUFACTURER.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_power_supply_get_info__out__MODEL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_power_supply_get_info__out__SERIAL.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_power_supply_get_info_options sol_flow_node_type_power_supply_get_info_options_defaults = SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_INFO_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_power_supply_get_info_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "power-supply/get-info",
    .category = "power-supply",
    .symbol = "SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_INFO",
    .options_symbol = "sol_flow_node_type_power_supply_get_info_options",
    .description = "Get information about a power supply: model, serial number and manufacturer.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/power-supply/get-info.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "TRIGGER",
            .description="Trigger to get info.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "NAME",
            .description="Name of power supply.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "MANUFACTURER",
            .description="Supply manufacturer.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "MODEL",
            .description="Supply model name.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "SERIAL",
            .description="Supply serial number.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_power_supply_get_info_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_INFO_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="name",
            .description="Name of power supply from where information will be fetched.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_power_supply_get_info_options, name),
            .size=sizeof(const char *),
            .defvalue = {
                .s=NULL,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_power_supply_get_info = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct get_props_data),
    .options_size = sizeof(struct sol_flow_node_type_power_supply_get_info_options),
    .default_options = &sol_flow_node_type_power_supply_get_info_options_defaults,
    .init_type = sol_flow_node_type_power_supply_get_info_init_type_internal,
    .open = get_props_open,
    .close = get_props_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_power_supply_get_info_get_port_in_internal,
    .ports_out_count = 3,
    .get_port_out = sol_flow_node_type_power_supply_get_info_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_power_supply_get_info_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_INFO = &sol_flow_node_type_power_supply_get_info;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_power_supply(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_power_supply(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_LIST,
            &SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_CAPACITY,
            &SOL_FLOW_NODE_TYPE_POWER_SUPPLY_GET_INFO,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
