/* this file was auto-generated from ./src/modules/flow/process/process.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_PROCESS_DEFINED
#include "sol-flow/process.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_out sol_flow_node_type_process_stdin__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = process_stdin_out_connect,
    .disconnect = process_stdin_out_disconnect,
};

static struct sol_flow_port_type_out sol_flow_node_type_process_stdin__out__CLOSED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = process_stdin_closed_connect,
    .disconnect = process_stdin_closed_disconnect,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_process_stdin_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_process_stdin__out__OUT;
    if (port < 2)
        return &sol_flow_node_type_process_stdin__out__CLOSED;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_process_stdin_init_type_internal(void)
{
    if (sol_flow_node_type_process_stdin__out__OUT.packet_type == NULL) {
        sol_flow_node_type_process_stdin__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
        sol_flow_node_type_process_stdin__out__CLOSED.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_process_stdin_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "process/stdin",
    .category = "input/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_PROCESS_STDIN",
    .options_symbol = "sol_flow_node_type_process_stdin_options",
    .description = "Current Process STDIN",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/process_stdin.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Binary data chunks (blobs) read. This is not buffered and no extra processing is done, you get what arrived on stdin, as it arrived.",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "CLOSED",
            .description="True if STDIN is closed",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_process_stdin = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_process_stdin_init_type_internal,
    .open = NULL,
    .close = NULL,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_process_stdin_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_process_stdin_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PROCESS_STDIN = &sol_flow_node_type_process_stdin;

static struct sol_flow_port_type_in sol_flow_node_type_process_stdout__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = process_stdout_in_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_process_stdout__out__CLOSED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = process_stdout_closed_connect,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_process_stdout_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_process_stdout__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_process_stdout_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_process_stdout__out__CLOSED;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_process_stdout_init_type_internal(void)
{
    if (sol_flow_node_type_process_stdout__in__IN.packet_type == NULL) {
        sol_flow_node_type_process_stdout__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
        sol_flow_node_type_process_stdout__out__CLOSED.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_process_stdout_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "process/stdout",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_PROCESS_STDOUT",
    .options_symbol = "sol_flow_node_type_process_stdout_options",
    .description = "Current Process STDOUT",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/process_stdout.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Binary data chunks (blobs) read. No extra processing is done, what arrived is written in stdout.",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "CLOSED",
            .description="True if STDOUT is closed",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_process_stdout = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_process_stdout_init_type_internal,
    .open = process_stdout_open,
    .close = process_stdout_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_process_stdout_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_process_stdout_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_process_stdout_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PROCESS_STDOUT = &sol_flow_node_type_process_stdout;

static struct sol_flow_port_type_in sol_flow_node_type_process_stderr__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = process_stderr_in_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_process_stderr__out__CLOSED = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = process_stderr_closed_connect,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_process_stderr_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_process_stderr__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_process_stderr_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_process_stderr__out__CLOSED;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_process_stderr_init_type_internal(void)
{
    if (sol_flow_node_type_process_stderr__in__IN.packet_type == NULL) {
        sol_flow_node_type_process_stderr__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
        sol_flow_node_type_process_stderr__out__CLOSED.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_process_stderr_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "process/stderr",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_PROCESS_STDERR",
    .options_symbol = "sol_flow_node_type_process_stderr_options",
    .description = "Current Process STDERR",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/process_stderr.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Binary data chunks (blobs) read. No extra processing is done, what arrived is written in stderr.",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "CLOSED",
            .description="True if STDERR is closed",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_process_stderr = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = 0,
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_process_stderr_init_type_internal,
    .open = process_stderr_open,
    .close = process_stderr_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_process_stderr_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_process_stderr_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_process_stderr_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PROCESS_STDERR = &sol_flow_node_type_process_stderr;

static struct sol_flow_port_type_in sol_flow_node_type_process_subprocess__in__START = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = process_subprocess_start_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_process_subprocess__in__STOP = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = process_subprocess_stop_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_process_subprocess__in__SIGNAL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = process_subprocess_signal_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_process_subprocess__in__STDIN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = process_subprocess_in_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_process_subprocess__out__STATUS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_process_subprocess__out__STDOUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_process_subprocess__out__STDERR = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_process_subprocess__out__PID = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_process_subprocess_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_process_subprocess__in__START;
    if (port < 2)
        return &sol_flow_node_type_process_subprocess__in__STOP;
    if (port < 3)
        return &sol_flow_node_type_process_subprocess__in__SIGNAL;
    if (port < 4)
        return &sol_flow_node_type_process_subprocess__in__STDIN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_process_subprocess_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_process_subprocess__out__STATUS;
    if (port < 2)
        return &sol_flow_node_type_process_subprocess__out__STDOUT;
    if (port < 3)
        return &sol_flow_node_type_process_subprocess__out__STDERR;
    if (port < 4)
        return &sol_flow_node_type_process_subprocess__out__PID;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_process_subprocess_init_type_internal(void)
{
    if (sol_flow_node_type_process_subprocess__in__START.packet_type == NULL) {
        sol_flow_node_type_process_subprocess__in__START.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_process_subprocess__in__STOP.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_process_subprocess__in__SIGNAL.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_process_subprocess__in__STDIN.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
        sol_flow_node_type_process_subprocess__out__STATUS.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_process_subprocess__out__STDOUT.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
        sol_flow_node_type_process_subprocess__out__STDERR.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
        sol_flow_node_type_process_subprocess__out__PID.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_process_subprocess_options sol_flow_node_type_process_subprocess_options_defaults = SOL_FLOW_NODE_TYPE_PROCESS_SUBPROCESS_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_process_subprocess_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "process/subprocess",
    .category = "output/sw",
    .symbol = "SOL_FLOW_NODE_TYPE_PROCESS_SUBPROCESS",
    .options_symbol = "sol_flow_node_type_process_subprocess_options",
    .description = "Spawn and monitor a subprocess",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/process_subprocess.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "START",
            .description="Start the child process",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "STOP",
            .description="Stop the child process sending SIGTERM",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "SIGNAL",
            .description="Send the specified signal to the child process",
            .data_type="int",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "STDIN",
            .description="Data chunk that will be passed to the subprocess's stdin.",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "STATUS",
            .description="It will delivery a packet when the child process stops or terminates containing its exit code, similar to waitpid(2).",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "STDOUT",
            .description="Binary data chunks (blobs) read. This is not buffered and no extra processing is done, you get what arrived from subprocess's stdout, as it arrived.",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "STDERR",
            .description="Binary data chunks (blobs) read. This is not buffered and no extra processing is done, you get what arrived from subprocess's stderr, as it arrived.",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "PID",
            .description="Send the pid of the child process.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_process_subprocess_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_PROCESS_SUBPROCESS_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="command",
            .description="The command that will be executed",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_process_subprocess_options, command),
            .size=sizeof(const char *),
        },
        {
            .name="start",
            .description="Select if the process should automatically start (true) or should start only after a packet come into the START port",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_process_subprocess_options, start),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_process_subprocess = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct subprocess_data),
    .options_size = sizeof(struct sol_flow_node_type_process_subprocess_options),
    .default_options = &sol_flow_node_type_process_subprocess_options_defaults,
    .init_type = sol_flow_node_type_process_subprocess_init_type_internal,
    .open = process_subprocess_open,
    .close = process_subprocess_close,
    .ports_in_count = 4,
    .get_port_in = sol_flow_node_type_process_subprocess_get_port_in_internal,
    .ports_out_count = 4,
    .get_port_out = sol_flow_node_type_process_subprocess_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_process_subprocess_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_PROCESS_SUBPROCESS = &sol_flow_node_type_process_subprocess;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_process(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_process(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_PROCESS_STDIN,
            &SOL_FLOW_NODE_TYPE_PROCESS_STDOUT,
            &SOL_FLOW_NODE_TYPE_PROCESS_STDERR,
            &SOL_FLOW_NODE_TYPE_PROCESS_SUBPROCESS,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
