/* this file was auto-generated from ./src/modules/flow/servo-motor/servo-motor.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_SERVO_MOTOR_DEFINED
#include "sol-flow/servo-motor.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_servo_motor_controller__in__ANGLE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = angle_set,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_servo_motor_controller__in__DUTY_CYCLE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = duty_cycle_set,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_servo_motor_controller_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_servo_motor_controller__in__ANGLE;
    if (port < 2)
        return &sol_flow_node_type_servo_motor_controller__in__DUTY_CYCLE;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_servo_motor_controller_init_type_internal(void)
{
    if (sol_flow_node_type_servo_motor_controller__in__ANGLE.packet_type == NULL) {
        sol_flow_node_type_servo_motor_controller__in__ANGLE.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_servo_motor_controller__in__DUTY_CYCLE.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_servo_motor_controller_options sol_flow_node_type_servo_motor_controller_options_defaults = SOL_FLOW_NODE_TYPE_SERVO_MOTOR_CONTROLLER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_servo_motor_controller_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "servo-motor/controller",
    .category = "output/hw",
    .symbol = "SOL_FLOW_NODE_TYPE_SERVO_MOTOR_CONTROLLER",
    .options_symbol = "sol_flow_node_type_servo_motor_controller_options",
    .description = "Control RC servo motors.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/servo-motor.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "ANGLE",
            .description="Set the angle of the shaft in degrees, from 0 to 180.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "DUTY_CYCLE",
            .description="Set duty cycle width in microseconds. Shoudln't be less or greater than min and max values, defined on options.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_servo_motor_controller_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_SERVO_MOTOR_CONTROLLER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="duty_cycle_range",
            .description="Pulse width range, in microseconds, corresponding to the minimum (0-degree) angle on the servo until the maximum (180-degree) angle.",
            .data_type="irange-spec",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_servo_motor_controller_options, duty_cycle_range),
            .size=sizeof(struct sol_irange_spec),
            .defvalue = {
                .irange_spec={.max=2400, .min=544, .step=1},
            },
        },
        {
            .name="period",
            .description="Period, in microseconds. A pulse repetition rate of 50 Hz should work with most servos.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_servo_motor_controller_options, period),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=22000,
            },
        },
        {
            .name="pin",
            .description="Label of the desired pin on the board. If raw is set to true, this should be \"<device> <channel>\" pair, e.g. \"0 3\".",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_servo_motor_controller_options, pin),
            .size=sizeof(const char *),
        },
        {
            .name="raw",
            .description="Change 'pin' meaning to be the system parameters needed to address the desired pin. Use it if you know what you are doing.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_servo_motor_controller_options, raw),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_servo_motor_controller = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct servo_motor_data),
    .options_size = sizeof(struct sol_flow_node_type_servo_motor_controller_options),
    .default_options = &sol_flow_node_type_servo_motor_controller_options_defaults,
    .init_type = sol_flow_node_type_servo_motor_controller_init_type_internal,
    .open = servo_motor_open,
    .close = servo_motor_close,
    .ports_in_count = 2,
    .get_port_in = sol_flow_node_type_servo_motor_controller_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_servo_motor_controller_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_SERVO_MOTOR_CONTROLLER = &sol_flow_node_type_servo_motor_controller;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_servo_motor(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_servo_motor(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_SERVO_MOTOR_CONTROLLER,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
