/* this file was auto-generated from ./src/modules/flow/test/test.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_TEST_DEFINED
#include "sol-flow/test.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_test_result__in__PASS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = test_pass_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_test_result__in__FAIL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = test_fail_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_test_result__in__RESULT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = test_result_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_test_result_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_result__in__PASS;
    if (port < 2)
        return &sol_flow_node_type_test_result__in__FAIL;
    if (port < 3)
        return &sol_flow_node_type_test_result__in__RESULT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_result_init_type_internal(void)
{
    if (sol_flow_node_type_test_result__in__PASS.packet_type == NULL) {
        sol_flow_node_type_test_result__in__PASS.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_test_result__in__FAIL.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_test_result__in__RESULT.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
    }

    log_init();
}

static const struct sol_flow_node_type_test_result_options sol_flow_node_type_test_result_options_defaults = SOL_FLOW_NODE_TYPE_TEST_RESULT_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_result_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/result",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_RESULT",
    .options_symbol = "sol_flow_node_type_test_result_options",
    .description = "Node type used to indicate whether a test flow has passed or not",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/test.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "PASS",
            .description="Indicates that the tested flow has passed",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "FAIL",
            .description="Indicates that the tested flow has failed",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "RESULT",
            .description="Indicates the result of tested flow, TRUE means success and FALSE means failure",
            .data_type="any",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_result_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_RESULT_OPTIONS_API_VERSION, )
        .required = false,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="timeout",
            .description="Time allotted for a fbp test to run in ms. Expiration of the timer is considered a failure.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_test_result_options, timeout),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=4000,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_result = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct test_result_data),
    .options_size = sizeof(struct sol_flow_node_type_test_result_options),
    .default_options = &sol_flow_node_type_test_result_options_defaults,
    .init_type = sol_flow_node_type_test_result_init_type_internal,
    .open = test_result_open,
    .close = test_result_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_test_result_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_result_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_RESULT = &sol_flow_node_type_test_result;

static struct sol_flow_port_type_in sol_flow_node_type_test_boolean_validator__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = sequence_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_test_boolean_validator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_test_boolean_validator_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_boolean_validator__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_boolean_validator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_boolean_validator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_boolean_validator_init_type_internal(void)
{
    if (sol_flow_node_type_test_boolean_validator__in__IN.packet_type == NULL) {
        sol_flow_node_type_test_boolean_validator__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_test_boolean_validator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_test_boolean_validator_options sol_flow_node_type_test_boolean_validator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_BOOLEAN_VALIDATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_boolean_validator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/boolean-validator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_BOOLEAN_VALIDATOR",
    .options_symbol = "sol_flow_node_type_test_boolean_validator_options",
    .description = "Matches an expected sequence.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/boolean-validator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Where to receive the expected sequence.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Outputs true if there is a match, false otherwise.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_boolean_validator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_BOOLEAN_VALIDATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="sequence",
            .description="Expected sequence to be matched, formatted as 'TFTFTTTFF' where 'T' is true and 'F' is false.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_boolean_validator_options, sequence),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_boolean_validator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct boolean_validator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_boolean_validator_options),
    .default_options = &sol_flow_node_type_test_boolean_validator_options_defaults,
    .init_type = sol_flow_node_type_test_boolean_validator_init_type_internal,
    .open = boolean_validator_open,
    .close = boolean_validator_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_test_boolean_validator_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_boolean_validator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_boolean_validator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_BOOLEAN_VALIDATOR = &sol_flow_node_type_test_boolean_validator;

static struct sol_flow_port_type_out sol_flow_node_type_test_boolean_generator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_boolean_generator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_boolean_generator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_boolean_generator_init_type_internal(void)
{
    if (sol_flow_node_type_test_boolean_generator__out__OUT.packet_type == NULL) {
        sol_flow_node_type_test_boolean_generator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_test_boolean_generator_options sol_flow_node_type_test_boolean_generator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_BOOLEAN_GENERATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_boolean_generator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/boolean-generator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_BOOLEAN_GENERATOR",
    .options_symbol = "sol_flow_node_type_test_boolean_generator_options",
    .description = "Provides predefined input for testing",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/boolean_generator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Where the predefined sequence is outputted.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_boolean_generator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_BOOLEAN_GENERATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="sequence",
            .description="String sequence to be generated, formatted as 'TFTFTTTFF' where 'T' is true and 'F' is false.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_boolean_generator_options, sequence),
            .size=sizeof(const char *),
        },
        {
            .name="interval",
            .description="Interval between packets, in miliseconds.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_test_boolean_generator_options, interval),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_boolean_generator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct boolean_generator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_boolean_generator_options),
    .default_options = &sol_flow_node_type_test_boolean_generator_options_defaults,
    .init_type = sol_flow_node_type_test_boolean_generator_init_type_internal,
    .open = boolean_generator_open,
    .close = boolean_generator_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_boolean_generator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_boolean_generator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_BOOLEAN_GENERATOR = &sol_flow_node_type_test_boolean_generator;

static struct sol_flow_port_type_in sol_flow_node_type_test_byte_validator__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = byte_validator_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_test_byte_validator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_test_byte_validator_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_byte_validator__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_byte_validator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_byte_validator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_byte_validator_init_type_internal(void)
{
    if (sol_flow_node_type_test_byte_validator__in__IN.packet_type == NULL) {
        sol_flow_node_type_test_byte_validator__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
        sol_flow_node_type_test_byte_validator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_test_byte_validator_options sol_flow_node_type_test_byte_validator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_BYTE_VALIDATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_byte_validator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/byte-validator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_BYTE_VALIDATOR",
    .options_symbol = "sol_flow_node_type_test_byte_validator_options",
    .description = "Matches an expected sequence of byte values.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/byte-validator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Where to receive the expected sequence.",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Outputs true if there is a match, false otherwise.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_byte_validator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_BYTE_VALIDATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="sequence",
            .description="Expected sequence to be matched, formatted as '1 2 3 20 70 255'. Only numbers on base 10.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_byte_validator_options, sequence),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_byte_validator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct byte_validator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_byte_validator_options),
    .default_options = &sol_flow_node_type_test_byte_validator_options_defaults,
    .init_type = sol_flow_node_type_test_byte_validator_init_type_internal,
    .open = byte_validator_open,
    .close = byte_validator_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_test_byte_validator_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_byte_validator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_byte_validator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_BYTE_VALIDATOR = &sol_flow_node_type_test_byte_validator;

static struct sol_flow_port_type_out sol_flow_node_type_test_byte_generator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_byte_generator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_byte_generator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_byte_generator_init_type_internal(void)
{
    if (sol_flow_node_type_test_byte_generator__out__OUT.packet_type == NULL) {
        sol_flow_node_type_test_byte_generator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
    }

    log_init();
}

static const struct sol_flow_node_type_test_byte_generator_options sol_flow_node_type_test_byte_generator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_BYTE_GENERATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_byte_generator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/byte-generator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_BYTE_GENERATOR",
    .options_symbol = "sol_flow_node_type_test_byte_generator_options",
    .description = "Provides predefined input for testing",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/byte_generator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Packets with bytes defined in the 'sequence' option.",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_byte_generator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_BYTE_GENERATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="sequence",
            .description="String sequence to be generated, formatted as '10 20 255'. Only numbers on base 10.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_byte_generator_options, sequence),
            .size=sizeof(const char *),
        },
        {
            .name="interval",
            .description="Interval between packets, in miliseconds.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_test_byte_generator_options, interval),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_byte_generator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct byte_generator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_byte_generator_options),
    .default_options = &sol_flow_node_type_test_byte_generator_options_defaults,
    .init_type = sol_flow_node_type_test_byte_generator_init_type_internal,
    .open = byte_generator_open,
    .close = byte_generator_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_byte_generator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_byte_generator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_BYTE_GENERATOR = &sol_flow_node_type_test_byte_generator;

static struct sol_flow_port_type_in sol_flow_node_type_test_int_validator__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = int_validator_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_test_int_validator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_test_int_validator_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_int_validator__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_int_validator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_int_validator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_int_validator_init_type_internal(void)
{
    if (sol_flow_node_type_test_int_validator__in__IN.packet_type == NULL) {
        sol_flow_node_type_test_int_validator__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_test_int_validator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_test_int_validator_options sol_flow_node_type_test_int_validator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_INT_VALIDATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_int_validator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/int-validator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_INT_VALIDATOR",
    .options_symbol = "sol_flow_node_type_test_int_validator_options",
    .description = "Matches an expected sequence of integer values.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/int-validator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Where to receive the expected sequence.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Outputs true if there is a match, false otherwise.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_int_validator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_INT_VALIDATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="sequence",
            .description="Expected sequence to be matched, formatted as '1 2 3 -4 10 100 -1000'",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_int_validator_options, sequence),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_int_validator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct int_validator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_int_validator_options),
    .default_options = &sol_flow_node_type_test_int_validator_options_defaults,
    .init_type = sol_flow_node_type_test_int_validator_init_type_internal,
    .open = int_validator_open,
    .close = int_validator_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_test_int_validator_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_int_validator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_int_validator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_INT_VALIDATOR = &sol_flow_node_type_test_int_validator;

static struct sol_flow_port_type_out sol_flow_node_type_test_int_generator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_int_generator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_int_generator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_int_generator_init_type_internal(void)
{
    if (sol_flow_node_type_test_int_generator__out__OUT.packet_type == NULL) {
        sol_flow_node_type_test_int_generator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_test_int_generator_options sol_flow_node_type_test_int_generator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_INT_GENERATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_int_generator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/int-generator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_INT_GENERATOR",
    .options_symbol = "sol_flow_node_type_test_int_generator_options",
    .description = "Provides predefined input for testing",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/int_generator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Where the predefined sequence is outputted.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_int_generator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_INT_GENERATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="sequence",
            .description="String sequence to be generated, formatted as '1 10 -2 1000'.",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_int_generator_options, sequence),
            .size=sizeof(const char *),
        },
        {
            .name="interval",
            .description="Interval between packets, in miliseconds.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_test_int_generator_options, interval),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_int_generator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct int_generator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_int_generator_options),
    .default_options = &sol_flow_node_type_test_int_generator_options_defaults,
    .init_type = sol_flow_node_type_test_int_generator_init_type_internal,
    .open = int_generator_open,
    .close = int_generator_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_int_generator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_int_generator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_INT_GENERATOR = &sol_flow_node_type_test_int_generator;

static struct sol_flow_port_type_out sol_flow_node_type_test_float_generator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_float_generator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_float_generator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_float_generator_init_type_internal(void)
{
    if (sol_flow_node_type_test_float_generator__out__OUT.packet_type == NULL) {
        sol_flow_node_type_test_float_generator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_test_float_generator_options sol_flow_node_type_test_float_generator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_FLOAT_GENERATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_float_generator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/float-generator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_FLOAT_GENERATOR",
    .options_symbol = "sol_flow_node_type_test_float_generator_options",
    .description = "Provides predefined input for testing",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/float_generator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Where the predefined sequence is outputted.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_float_generator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_FLOAT_GENERATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="sequence",
            .description="String sequence to be generated, formatted as '1.0 2 -1.7 35.864'",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_float_generator_options, sequence),
            .size=sizeof(const char *),
        },
        {
            .name="interval",
            .description="Interval between packets, in miliseconds.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_test_float_generator_options, interval),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_float_generator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct float_generator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_float_generator_options),
    .default_options = &sol_flow_node_type_test_float_generator_options_defaults,
    .init_type = sol_flow_node_type_test_float_generator_init_type_internal,
    .open = float_generator_open,
    .close = float_generator_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_float_generator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_float_generator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_FLOAT_GENERATOR = &sol_flow_node_type_test_float_generator;

static struct sol_flow_port_type_in sol_flow_node_type_test_float_validator__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = float_validator_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_test_float_validator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_test_float_validator_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_float_validator__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_float_validator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_float_validator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_float_validator_init_type_internal(void)
{
    if (sol_flow_node_type_test_float_validator__in__IN.packet_type == NULL) {
        sol_flow_node_type_test_float_validator__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
        sol_flow_node_type_test_float_validator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_test_float_validator_options sol_flow_node_type_test_float_validator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_FLOAT_VALIDATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_float_validator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/float-validator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_FLOAT_VALIDATOR",
    .options_symbol = "sol_flow_node_type_test_float_validator_options",
    .description = "Matches an expected sequence.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/float-validator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Where to receive the expected sequence.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Outputs true if there is a match, false otherwise.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_float_validator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_FLOAT_VALIDATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="sequence",
            .description="Expected sequence to be matched, formatted as '1.0 2 -1.7 35.864'",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_float_validator_options, sequence),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_float_validator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct float_validator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_float_validator_options),
    .default_options = &sol_flow_node_type_test_float_validator_options_defaults,
    .init_type = sol_flow_node_type_test_float_validator_init_type_internal,
    .open = float_validator_open,
    .close = float_validator_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_test_float_validator_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_float_validator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_float_validator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_FLOAT_VALIDATOR = &sol_flow_node_type_test_float_validator;

static struct sol_flow_port_type_in sol_flow_node_type_test_blob_validator__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = blob_validator_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_test_blob_validator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_test_blob_validator_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_blob_validator__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_blob_validator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_blob_validator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_blob_validator_init_type_internal(void)
{
    if (sol_flow_node_type_test_blob_validator__in__IN.packet_type == NULL) {
        sol_flow_node_type_test_blob_validator__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_BLOB;
        sol_flow_node_type_test_blob_validator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_test_blob_validator_options sol_flow_node_type_test_blob_validator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_BLOB_VALIDATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_blob_validator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/blob-validator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_BLOB_VALIDATOR",
    .options_symbol = "sol_flow_node_type_test_blob_validator_options",
    .description = "Matches an expected memory blob.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/blob-validator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Where to receive the expected sequence.",
            .data_type="blob",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Outputs true if there is a match, false otherwise.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_blob_validator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_BLOB_VALIDATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="expected",
            .description="Expected string to be matched",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_blob_validator_options, expected),
            .size=sizeof(const char *),
        },
        {
            .name="expect_terminating_null_byte",
            .description="If true, it will compare the received blob with 'expected' string with terminating null byte, otherwise it will compare with a not terminated string.",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_test_blob_validator_options, expect_terminating_null_byte),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_blob_validator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct blob_validator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_blob_validator_options),
    .default_options = &sol_flow_node_type_test_blob_validator_options_defaults,
    .init_type = sol_flow_node_type_test_blob_validator_init_type_internal,
    .open = blob_validator_open,
    .close = blob_validator_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_test_blob_validator_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_blob_validator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_blob_validator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_BLOB_VALIDATOR = &sol_flow_node_type_test_blob_validator;

static struct sol_flow_port_type_out sol_flow_node_type_test_string_generator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_string_generator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_string_generator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_string_generator_init_type_internal(void)
{
    if (sol_flow_node_type_test_string_generator__out__OUT.packet_type == NULL) {
        sol_flow_node_type_test_string_generator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_test_string_generator_options sol_flow_node_type_test_string_generator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_STRING_GENERATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_string_generator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/string-generator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_STRING_GENERATOR",
    .options_symbol = "sol_flow_node_type_test_string_generator_options",
    .description = "Provides a predefined string sequence input for testing",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/string_generator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Where the predefined strings sequence is outputted.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_string_generator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_STRING_GENERATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="sequence",
            .description="String sequence to be generated, formatted as 'str1<separator>str2<separator>...', where separator is set on the separator option..",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_string_generator_options, sequence),
            .size=sizeof(const char *),
        },
        {
            .name="separator",
            .description="String sequence separator.",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_test_string_generator_options, separator),
            .size=sizeof(const char *),
            .defvalue = {
                .s=" ",
            },
        },
        {
            .name="interval",
            .description="Interval between packets, in miliseconds.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_test_string_generator_options, interval),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=0,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_string_generator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct string_generator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_string_generator_options),
    .default_options = &sol_flow_node_type_test_string_generator_options_defaults,
    .init_type = sol_flow_node_type_test_string_generator_init_type_internal,
    .open = string_generator_open,
    .close = string_generator_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_string_generator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_string_generator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_STRING_GENERATOR = &sol_flow_node_type_test_string_generator;

static struct sol_flow_port_type_in sol_flow_node_type_test_string_validator__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = string_validator_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_test_string_validator__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_test_string_validator_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_string_validator__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_test_string_validator_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_test_string_validator__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_test_string_validator_init_type_internal(void)
{
    if (sol_flow_node_type_test_string_validator__in__IN.packet_type == NULL) {
        sol_flow_node_type_test_string_validator__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_test_string_validator__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_test_string_validator_options sol_flow_node_type_test_string_validator_options_defaults = SOL_FLOW_NODE_TYPE_TEST_STRING_VALIDATOR_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_test_string_validator_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "test/string-validator",
    .category = "test",
    .symbol = "SOL_FLOW_NODE_TYPE_TEST_STRING_VALIDATOR",
    .options_symbol = "sol_flow_node_type_test_string_validator_options",
    .description = "Matches an expected sequence of strings.",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/components/string-validator.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Where to receive the expected sequence.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Outputs true if there is a match, false otherwise.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_test_string_validator_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_TEST_STRING_VALIDATOR_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="sequence",
            .description="Expected sequence to be matched, formatted as 'string 1|string 2|string 3'",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_test_string_validator_options, sequence),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_test_string_validator = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct string_validator_data),
    .options_size = sizeof(struct sol_flow_node_type_test_string_validator_options),
    .default_options = &sol_flow_node_type_test_string_validator_options_defaults,
    .init_type = sol_flow_node_type_test_string_validator_init_type_internal,
    .open = string_validator_open,
    .close = string_validator_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_test_string_validator_get_port_in_internal,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_test_string_validator_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_test_string_validator_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_TEST_STRING_VALIDATOR = &sol_flow_node_type_test_string_validator;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_test(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_test(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_TEST_RESULT,
            &SOL_FLOW_NODE_TYPE_TEST_BOOLEAN_VALIDATOR,
            &SOL_FLOW_NODE_TYPE_TEST_BOOLEAN_GENERATOR,
            &SOL_FLOW_NODE_TYPE_TEST_BYTE_VALIDATOR,
            &SOL_FLOW_NODE_TYPE_TEST_BYTE_GENERATOR,
            &SOL_FLOW_NODE_TYPE_TEST_INT_VALIDATOR,
            &SOL_FLOW_NODE_TYPE_TEST_INT_GENERATOR,
            &SOL_FLOW_NODE_TYPE_TEST_FLOAT_GENERATOR,
            &SOL_FLOW_NODE_TYPE_TEST_FLOAT_VALIDATOR,
            &SOL_FLOW_NODE_TYPE_TEST_BLOB_VALIDATOR,
            &SOL_FLOW_NODE_TYPE_TEST_STRING_GENERATOR,
            &SOL_FLOW_NODE_TYPE_TEST_STRING_VALIDATOR,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
