/* this file was auto-generated from ./src/modules/flow/thingspeak/thingspeak.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_THINGSPEAK_DEFINED
#include "sol-flow/thingspeak.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_out sol_flow_node_type_thingspeak_talkback_execute__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_thingspeak_talkback_execute_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_thingspeak_talkback_execute__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_thingspeak_talkback_execute_init_type_internal(void)
{
    if (sol_flow_node_type_thingspeak_talkback_execute__out__OUT.packet_type == NULL) {
        sol_flow_node_type_thingspeak_talkback_execute__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_thingspeak_talkback_execute_options sol_flow_node_type_thingspeak_talkback_execute_options_defaults = SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_thingspeak_talkback_execute_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "thingspeak/talkback-execute",
    .category = "iot/cloud",
    .symbol = "SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE",
    .options_symbol = "sol_flow_node_type_thingspeak_talkback_execute_options",
    .description = "Execute the next Thingspeak Talkback command",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/thingspeak/thingspeak-execute.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="The next command to execute. Freeform string.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_thingspeak_talkback_execute_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="api_key",
            .description="Thingpeak API key",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_thingspeak_talkback_execute_options, api_key),
            .size=sizeof(const char *),
        },
        {
            .name="talkback_id",
            .description="Talkback ID",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_thingspeak_talkback_execute_options, talkback_id),
            .size=sizeof(const char *),
        },
        {
            .name="endpoint",
            .description="Thingspeak endpoint. Defaults to public server",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_thingspeak_talkback_execute_options, endpoint),
            .size=sizeof(const char *),
            .defvalue = {
                .s="https://api.thingspeak.com/",
            },
        },
        {
            .name="interval",
            .description="Poll interval in milliseconds. Default to one request every 1000ms.",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_thingspeak_talkback_execute_options, interval),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=1000,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_thingspeak_talkback_execute = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct thingspeak_execute_data),
    .options_size = sizeof(struct sol_flow_node_type_thingspeak_talkback_execute_options),
    .default_options = &sol_flow_node_type_thingspeak_talkback_execute_options_defaults,
    .init_type = sol_flow_node_type_thingspeak_talkback_execute_init_type_internal,
    .open = thingspeak_execute_open,
    .close = thingspeak_execute_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_thingspeak_talkback_execute_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_thingspeak_talkback_execute_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE = &sol_flow_node_type_thingspeak_talkback_execute;

static struct sol_flow_port_type_in sol_flow_node_type_thingspeak_talkback_add__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = thingspeak_add_in_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_thingspeak_talkback_add_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_thingspeak_talkback_add__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_thingspeak_talkback_add_init_type_internal(void)
{
    if (sol_flow_node_type_thingspeak_talkback_add__in__IN.packet_type == NULL) {
        sol_flow_node_type_thingspeak_talkback_add__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_thingspeak_talkback_add_options sol_flow_node_type_thingspeak_talkback_add_options_defaults = SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_thingspeak_talkback_add_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "thingspeak/talkback-add",
    .category = "iot/cloud",
    .symbol = "SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD",
    .options_symbol = "sol_flow_node_type_thingspeak_talkback_add_options",
    .description = "Add a command to the Thingspeak Talkback queue",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/thingspeak/thingspeak-add.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="The next command to execute. Freeform string.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_thingspeak_talkback_add_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="api_key",
            .description="Thingpeak API key",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_thingspeak_talkback_add_options, api_key),
            .size=sizeof(const char *),
        },
        {
            .name="talkback_id",
            .description="Talkback ID",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_thingspeak_talkback_add_options, talkback_id),
            .size=sizeof(const char *),
        },
        {
            .name="endpoint",
            .description="Thingspeak endpoint. Defaults to public server",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_thingspeak_talkback_add_options, endpoint),
            .size=sizeof(const char *),
            .defvalue = {
                .s="https://api.thingspeak.com/",
            },
        },
        {
            .name="position",
            .description="Position for this command to appear in the queue. Default is end of queue",
            .data_type="int",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_thingspeak_talkback_add_options, position),
            .size=sizeof(int32_t),
            .defvalue = {
                .i=-1,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_thingspeak_talkback_add = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct thingspeak_add_data),
    .options_size = sizeof(struct sol_flow_node_type_thingspeak_talkback_add_options),
    .default_options = &sol_flow_node_type_thingspeak_talkback_add_options_defaults,
    .init_type = sol_flow_node_type_thingspeak_talkback_add_init_type_internal,
    .open = thingspeak_add_open,
    .close = thingspeak_add_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_thingspeak_talkback_add_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_thingspeak_talkback_add_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD = &sol_flow_node_type_thingspeak_talkback_add;

static struct sol_flow_port_type_in sol_flow_node_type_thingspeak_channel_update__in__FIELD = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = thingspeak_channel_update_field_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_thingspeak_channel_update__in__STATUS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = thingspeak_channel_update_status_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_thingspeak_channel_update_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 8)
        return &sol_flow_node_type_thingspeak_channel_update__in__FIELD;
    if (port < 9)
        return &sol_flow_node_type_thingspeak_channel_update__in__STATUS;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_thingspeak_channel_update_init_type_internal(void)
{
    if (sol_flow_node_type_thingspeak_channel_update__in__FIELD.packet_type == NULL) {
        sol_flow_node_type_thingspeak_channel_update__in__FIELD.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_thingspeak_channel_update__in__STATUS.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_thingspeak_channel_update_options sol_flow_node_type_thingspeak_channel_update_options_defaults = SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_thingspeak_channel_update_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "thingspeak/channel-update",
    .category = "iot/cloud",
    .symbol = "SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE",
    .options_symbol = "sol_flow_node_type_thingspeak_channel_update_options",
    .description = "Update a Thingspeak channel",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/thingspeak/thingspeak-channel.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "FIELD",
            .description="Status fields",
            .data_type="string",
            .array_size=8,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "STATUS",
            .description="Status update message",
            .data_type="string",
            .array_size=0,
            .base_port_idx=8,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_thingspeak_channel_update_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="api_key",
            .description="Thingpeak API key",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_thingspeak_channel_update_options, api_key),
            .size=sizeof(const char *),
        },
        {
            .name="endpoint",
            .description="Thingspeak endpoint. Defaults to public server",
            .data_type="string",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_thingspeak_channel_update_options, endpoint),
            .size=sizeof(const char *),
            .defvalue = {
                .s="https://api.thingspeak.com/",
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_thingspeak_channel_update = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct thingspeak_channel_update_data),
    .options_size = sizeof(struct sol_flow_node_type_thingspeak_channel_update_options),
    .default_options = &sol_flow_node_type_thingspeak_channel_update_options_defaults,
    .init_type = sol_flow_node_type_thingspeak_channel_update_init_type_internal,
    .open = thingspeak_channel_update_open,
    .close = thingspeak_channel_update_close,
    .ports_in_count = 9,
    .get_port_in = sol_flow_node_type_thingspeak_channel_update_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_thingspeak_channel_update_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE = &sol_flow_node_type_thingspeak_channel_update;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_thingspeak(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_thingspeak(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_EXECUTE,
            &SOL_FLOW_NODE_TYPE_THINGSPEAK_TALKBACK_ADD,
            &SOL_FLOW_NODE_TYPE_THINGSPEAK_CHANNEL_UPDATE,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
