/* this file was auto-generated from ./src/modules/flow/unix-socket/unix-socket.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DEFINED
#include "sol-flow/unix-socket.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_unix_socket_boolean_writer__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = boolean_writer_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_unix_socket_boolean_writer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_boolean_writer__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_boolean_writer_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_boolean_writer__in__IN.packet_type == NULL) {
        sol_flow_node_type_unix_socket_boolean_writer__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_boolean_writer_options sol_flow_node_type_unix_socket_boolean_writer_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BOOLEAN_WRITER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_boolean_writer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/boolean-writer",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BOOLEAN_WRITER",
    .options_symbol = "sol_flow_node_type_unix_socket_boolean_writer_options",
    .description = "Unix socket boolean writer",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/boolean-writer.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Unix socket boolean writer, port out.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_boolean_writer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BOOLEAN_WRITER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_boolean_writer_options, path),
            .size=sizeof(const char *),
        },
        {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_boolean_writer_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_boolean_writer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_boolean_writer_options),
    .default_options = &sol_flow_node_type_unix_socket_boolean_writer_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_boolean_writer_init_type_internal,
    .open = boolean_writer_open,
    .close = common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_unix_socket_boolean_writer_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_boolean_writer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BOOLEAN_WRITER = &sol_flow_node_type_unix_socket_boolean_writer;

static struct sol_flow_port_type_out sol_flow_node_type_unix_socket_boolean_reader__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_unix_socket_boolean_reader_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_boolean_reader__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_boolean_reader_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_boolean_reader__out__OUT.packet_type == NULL) {
        sol_flow_node_type_unix_socket_boolean_reader__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_boolean_reader_options sol_flow_node_type_unix_socket_boolean_reader_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BOOLEAN_READER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_boolean_reader_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/boolean-reader",
    .category = "input/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BOOLEAN_READER",
    .options_symbol = "sol_flow_node_type_unix_socket_boolean_reader_options",
    .description = "Unix socket boolean reader",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/boolean-reader.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Unix socket boolean reader, port out.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_boolean_reader_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BOOLEAN_READER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_boolean_reader_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_boolean_reader_options, path),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_boolean_reader = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_boolean_reader_options),
    .default_options = &sol_flow_node_type_unix_socket_boolean_reader_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_boolean_reader_init_type_internal,
    .open = boolean_reader_open,
    .close = common_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_unix_socket_boolean_reader_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_boolean_reader_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BOOLEAN_READER = &sol_flow_node_type_unix_socket_boolean_reader;

static struct sol_flow_port_type_in sol_flow_node_type_unix_socket_string_writer__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = string_writer_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_unix_socket_string_writer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_string_writer__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_string_writer_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_string_writer__in__IN.packet_type == NULL) {
        sol_flow_node_type_unix_socket_string_writer__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_string_writer_options sol_flow_node_type_unix_socket_string_writer_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_STRING_WRITER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_string_writer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/string-writer",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_STRING_WRITER",
    .options_symbol = "sol_flow_node_type_unix_socket_string_writer_options",
    .description = "Unix socket string writer",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/string-writer.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Unix socket string writer, port out.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_string_writer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_STRING_WRITER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_string_writer_options, path),
            .size=sizeof(const char *),
        },
        {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_string_writer_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_string_writer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_string_writer_options),
    .default_options = &sol_flow_node_type_unix_socket_string_writer_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_string_writer_init_type_internal,
    .open = string_writer_open,
    .close = common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_unix_socket_string_writer_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_string_writer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_STRING_WRITER = &sol_flow_node_type_unix_socket_string_writer;

static struct sol_flow_port_type_out sol_flow_node_type_unix_socket_string_reader__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_unix_socket_string_reader_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_string_reader__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_string_reader_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_string_reader__out__OUT.packet_type == NULL) {
        sol_flow_node_type_unix_socket_string_reader__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_string_reader_options sol_flow_node_type_unix_socket_string_reader_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_STRING_READER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_string_reader_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/string-reader",
    .category = "input/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_STRING_READER",
    .options_symbol = "sol_flow_node_type_unix_socket_string_reader_options",
    .description = "Unix socket string reader",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/string-reader.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Unix socket string reader, port out.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_string_reader_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_STRING_READER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_string_reader_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_string_reader_options, path),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_string_reader = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_string_reader_options),
    .default_options = &sol_flow_node_type_unix_socket_string_reader_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_string_reader_init_type_internal,
    .open = string_reader_open,
    .close = common_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_unix_socket_string_reader_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_string_reader_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_STRING_READER = &sol_flow_node_type_unix_socket_string_reader;

static struct sol_flow_port_type_in sol_flow_node_type_unix_socket_rgb_writer__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = rgb_writer_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_unix_socket_rgb_writer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_rgb_writer__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_rgb_writer_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_rgb_writer__in__IN.packet_type == NULL) {
        sol_flow_node_type_unix_socket_rgb_writer__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_rgb_writer_options sol_flow_node_type_unix_socket_rgb_writer_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_RGB_WRITER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_rgb_writer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/rgb-writer",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_RGB_WRITER",
    .options_symbol = "sol_flow_node_type_unix_socket_rgb_writer_options",
    .description = "Unix socket rgb writer",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/rgb-writer.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Unix socket rgb writer, port out.",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_rgb_writer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_RGB_WRITER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_rgb_writer_options, path),
            .size=sizeof(const char *),
        },
        {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_rgb_writer_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_rgb_writer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_rgb_writer_options),
    .default_options = &sol_flow_node_type_unix_socket_rgb_writer_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_rgb_writer_init_type_internal,
    .open = rgb_writer_open,
    .close = common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_unix_socket_rgb_writer_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_rgb_writer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_RGB_WRITER = &sol_flow_node_type_unix_socket_rgb_writer;

static struct sol_flow_port_type_out sol_flow_node_type_unix_socket_rgb_reader__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_unix_socket_rgb_reader_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_rgb_reader__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_rgb_reader_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_rgb_reader__out__OUT.packet_type == NULL) {
        sol_flow_node_type_unix_socket_rgb_reader__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_RGB;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_rgb_reader_options sol_flow_node_type_unix_socket_rgb_reader_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_RGB_READER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_rgb_reader_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/rgb-reader",
    .category = "input/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_RGB_READER",
    .options_symbol = "sol_flow_node_type_unix_socket_rgb_reader_options",
    .description = "Unix socket rgb reader",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/rgb-reader.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Unix socket rgb reader, port out.",
            .data_type="rgb",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_rgb_reader_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_RGB_READER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_rgb_reader_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_rgb_reader_options, path),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_rgb_reader = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_rgb_reader_options),
    .default_options = &sol_flow_node_type_unix_socket_rgb_reader_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_rgb_reader_init_type_internal,
    .open = rgb_reader_open,
    .close = common_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_unix_socket_rgb_reader_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_rgb_reader_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_RGB_READER = &sol_flow_node_type_unix_socket_rgb_reader;

static struct sol_flow_port_type_in sol_flow_node_type_unix_socket_direction_vector_writer__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = direction_vector_writer_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_unix_socket_direction_vector_writer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_direction_vector_writer__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_direction_vector_writer_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_direction_vector_writer__in__IN.packet_type == NULL) {
        sol_flow_node_type_unix_socket_direction_vector_writer__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_direction_vector_writer_options sol_flow_node_type_unix_socket_direction_vector_writer_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DIRECTION_VECTOR_WRITER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_direction_vector_writer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/direction-vector-writer",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DIRECTION_VECTOR_WRITER",
    .options_symbol = "sol_flow_node_type_unix_socket_direction_vector_writer_options",
    .description = "Unix socket direction vector writer",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/direction-vector-writer.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Unix socket direction vector writer, input port.",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_direction_vector_writer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DIRECTION_VECTOR_WRITER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_direction_vector_writer_options, path),
            .size=sizeof(const char *),
        },
        {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_direction_vector_writer_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_direction_vector_writer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_direction_vector_writer_options),
    .default_options = &sol_flow_node_type_unix_socket_direction_vector_writer_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_direction_vector_writer_init_type_internal,
    .open = direction_vector_writer_open,
    .close = common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_unix_socket_direction_vector_writer_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_direction_vector_writer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DIRECTION_VECTOR_WRITER = &sol_flow_node_type_unix_socket_direction_vector_writer;

static struct sol_flow_port_type_out sol_flow_node_type_unix_socket_direction_vector_reader__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_unix_socket_direction_vector_reader_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_direction_vector_reader__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_direction_vector_reader_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_direction_vector_reader__out__OUT.packet_type == NULL) {
        sol_flow_node_type_unix_socket_direction_vector_reader__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DIRECTION_VECTOR;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_direction_vector_reader_options sol_flow_node_type_unix_socket_direction_vector_reader_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DIRECTION_VECTOR_READER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_direction_vector_reader_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/direction-vector-reader",
    .category = "input/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DIRECTION_VECTOR_READER",
    .options_symbol = "sol_flow_node_type_unix_socket_direction_vector_reader_options",
    .description = "Unix socket direction_vector reader",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/direction-vector-reader.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Unix socket direction vector reader, oupput port.",
            .data_type="direction-vector",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_direction_vector_reader_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DIRECTION_VECTOR_READER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_direction_vector_reader_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_direction_vector_reader_options, path),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_direction_vector_reader = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_direction_vector_reader_options),
    .default_options = &sol_flow_node_type_unix_socket_direction_vector_reader_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_direction_vector_reader_init_type_internal,
    .open = direction_vector_reader_open,
    .close = common_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_unix_socket_direction_vector_reader_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_direction_vector_reader_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DIRECTION_VECTOR_READER = &sol_flow_node_type_unix_socket_direction_vector_reader;

static struct sol_flow_port_type_in sol_flow_node_type_unix_socket_byte_writer__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = byte_writer_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_unix_socket_byte_writer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_byte_writer__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_byte_writer_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_byte_writer__in__IN.packet_type == NULL) {
        sol_flow_node_type_unix_socket_byte_writer__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_byte_writer_options sol_flow_node_type_unix_socket_byte_writer_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BYTE_WRITER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_byte_writer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/byte-writer",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BYTE_WRITER",
    .options_symbol = "sol_flow_node_type_unix_socket_byte_writer_options",
    .description = "Unix socket byte writer",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/byte-writer.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Unix socket byte writer, port out.",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_byte_writer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BYTE_WRITER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_byte_writer_options, path),
            .size=sizeof(const char *),
        },
        {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_byte_writer_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_byte_writer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_byte_writer_options),
    .default_options = &sol_flow_node_type_unix_socket_byte_writer_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_byte_writer_init_type_internal,
    .open = byte_writer_open,
    .close = common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_unix_socket_byte_writer_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_byte_writer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BYTE_WRITER = &sol_flow_node_type_unix_socket_byte_writer;

static struct sol_flow_port_type_out sol_flow_node_type_unix_socket_byte_reader__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_unix_socket_byte_reader_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_byte_reader__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_byte_reader_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_byte_reader__out__OUT.packet_type == NULL) {
        sol_flow_node_type_unix_socket_byte_reader__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_BYTE;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_byte_reader_options sol_flow_node_type_unix_socket_byte_reader_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BYTE_READER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_byte_reader_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/byte-reader",
    .category = "input/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BYTE_READER",
    .options_symbol = "sol_flow_node_type_unix_socket_byte_reader_options",
    .description = "Unix socket byte reader",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/byte-reader.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Unix socket byte reader, port out.",
            .data_type="byte",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_byte_reader_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BYTE_READER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_byte_reader_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_byte_reader_options, path),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_byte_reader = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_byte_reader_options),
    .default_options = &sol_flow_node_type_unix_socket_byte_reader_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_byte_reader_init_type_internal,
    .open = byte_reader_open,
    .close = common_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_unix_socket_byte_reader_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_byte_reader_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BYTE_READER = &sol_flow_node_type_unix_socket_byte_reader;

static struct sol_flow_port_type_in sol_flow_node_type_unix_socket_int_writer__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = int_writer_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_unix_socket_int_writer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_int_writer__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_int_writer_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_int_writer__in__IN.packet_type == NULL) {
        sol_flow_node_type_unix_socket_int_writer__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_int_writer_options sol_flow_node_type_unix_socket_int_writer_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_INT_WRITER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_int_writer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/int-writer",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_INT_WRITER",
    .options_symbol = "sol_flow_node_type_unix_socket_int_writer_options",
    .description = "Unix socket int writer",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/int-writer.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Unix socket int writer, port out.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_int_writer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_INT_WRITER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_int_writer_options, path),
            .size=sizeof(const char *),
        },
        {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_int_writer_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_int_writer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_int_writer_options),
    .default_options = &sol_flow_node_type_unix_socket_int_writer_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_int_writer_init_type_internal,
    .open = int_writer_open,
    .close = common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_unix_socket_int_writer_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_int_writer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_INT_WRITER = &sol_flow_node_type_unix_socket_int_writer;

static struct sol_flow_port_type_out sol_flow_node_type_unix_socket_int_reader__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_unix_socket_int_reader_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_int_reader__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_int_reader_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_int_reader__out__OUT.packet_type == NULL) {
        sol_flow_node_type_unix_socket_int_reader__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_int_reader_options sol_flow_node_type_unix_socket_int_reader_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_INT_READER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_int_reader_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/int-reader",
    .category = "input/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_INT_READER",
    .options_symbol = "sol_flow_node_type_unix_socket_int_reader_options",
    .description = "Unix socket int reader",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/int-reader.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Unix socket int reader, port out.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_int_reader_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_INT_READER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_int_reader_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_int_reader_options, path),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_int_reader = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_int_reader_options),
    .default_options = &sol_flow_node_type_unix_socket_int_reader_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_int_reader_init_type_internal,
    .open = int_reader_open,
    .close = common_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_unix_socket_int_reader_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_int_reader_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_INT_READER = &sol_flow_node_type_unix_socket_int_reader;

static struct sol_flow_port_type_in sol_flow_node_type_unix_socket_float_writer__in__IN = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = float_writer_process,
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_unix_socket_float_writer_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_float_writer__in__IN;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_float_writer_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_float_writer__in__IN.packet_type == NULL) {
        sol_flow_node_type_unix_socket_float_writer__in__IN.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_float_writer_options sol_flow_node_type_unix_socket_float_writer_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_FLOAT_WRITER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_float_writer_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/float-writer",
    .category = "output/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_FLOAT_WRITER",
    .options_symbol = "sol_flow_node_type_unix_socket_float_writer_options",
    .description = "Unix socket float writer",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/float-writer.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "IN",
            .description="Unix socket float writer, port out.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_float_writer_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_FLOAT_WRITER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_float_writer_options, path),
            .size=sizeof(const char *),
        },
        {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_float_writer_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=true,
            },
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_float_writer = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_float_writer_options),
    .default_options = &sol_flow_node_type_unix_socket_float_writer_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_float_writer_init_type_internal,
    .open = float_writer_open,
    .close = common_close,
    .ports_in_count = 1,
    .get_port_in = sol_flow_node_type_unix_socket_float_writer_get_port_in_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_float_writer_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_FLOAT_WRITER = &sol_flow_node_type_unix_socket_float_writer;

static struct sol_flow_port_type_out sol_flow_node_type_unix_socket_float_reader__out__OUT = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_out *
sol_flow_node_type_unix_socket_float_reader_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_unix_socket_float_reader__out__OUT;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_unix_socket_float_reader_init_type_internal(void)
{
    if (sol_flow_node_type_unix_socket_float_reader__out__OUT.packet_type == NULL) {
        sol_flow_node_type_unix_socket_float_reader__out__OUT.packet_type = SOL_FLOW_PACKET_TYPE_DRANGE;
    }

    log_init();
}

static const struct sol_flow_node_type_unix_socket_float_reader_options sol_flow_node_type_unix_socket_float_reader_options_defaults = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_FLOAT_READER_OPTIONS_DEFAULTS();

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_unix_socket_float_reader_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "unix-socket/float-reader",
    .category = "input/network",
    .symbol = "SOL_FLOW_NODE_TYPE_UNIX_SOCKET_FLOAT_READER",
    .options_symbol = "sol_flow_node_type_unix_socket_float_reader_options",
    .description = "Unix socket float reader",
    .author = "Intel Corporation",
    .url = "http://solettaproject.org/doc/latest/node_types/unix-socket/float-reader.html",
    .license = "Apache-2.0",
    .version = "1",
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "OUT",
            .description="Unix socket float reader, port out.",
            .data_type="float",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        NULL
    },
    .options = &((const struct sol_flow_node_options_description){
        .data_size = sizeof(struct sol_flow_node_type_unix_socket_float_reader_options),
        SOL_SET_API_VERSION(.sub_api = SOL_FLOW_NODE_TYPE_UNIX_SOCKET_FLOAT_READER_OPTIONS_API_VERSION, )
        .required = true,
        .members = (const struct sol_flow_node_options_member_description[]){
                    {
            .name="server",
            .description="Act like a server",
            .data_type="boolean",
            .required=false,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_float_reader_options, server),
            .size=sizeof(bool),
            .defvalue = {
                .b=false,
            },
        },
        {
            .name="path",
            .description="Unix socket path",
            .data_type="string",
            .required=true,
            .offset=offsetof(struct sol_flow_node_type_unix_socket_float_reader_options, path),
            .size=sizeof(const char *),
        },
            {},

        },
    }),
};
#endif

static const struct sol_flow_node_type sol_flow_node_type_unix_socket_float_reader = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct unix_socket_data),
    .options_size = sizeof(struct sol_flow_node_type_unix_socket_float_reader_options),
    .default_options = &sol_flow_node_type_unix_socket_float_reader_options_defaults,
    .init_type = sol_flow_node_type_unix_socket_float_reader_init_type_internal,
    .open = float_reader_open,
    .close = common_close,
    .ports_out_count = 1,
    .get_port_out = sol_flow_node_type_unix_socket_float_reader_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_unix_socket_float_reader_description,
#endif

};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UNIX_SOCKET_FLOAT_READER = &sol_flow_node_type_unix_socket_float_reader;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_unix_socket(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_unix_socket(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BOOLEAN_WRITER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BOOLEAN_READER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_STRING_WRITER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_STRING_READER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_RGB_WRITER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_RGB_READER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DIRECTION_VECTOR_WRITER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_DIRECTION_VECTOR_READER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BYTE_WRITER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_BYTE_READER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_INT_WRITER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_INT_READER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_FLOAT_WRITER,
            &SOL_FLOW_NODE_TYPE_UNIX_SOCKET_FLOAT_READER,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
