/* this file was auto-generated from ./src/modules/flow/update/update.json.
 * include it from your implementation after your methods and
 * types are defined.
 */
#ifndef SOL_FLOW_NODE_TYPE_UPDATE_DEFINED
#include "sol-flow/update.h"
#endif
#include <sol-flow-packet.h>
#include <sol-macros.h>
#include <errno.h>


#ifdef SOL_LOG_ENABLED
#define SOL_LOG_INTERNAL_INIT_ONCE     do {         static bool _log_internal_init_once_first = true;         if (_log_internal_init_once_first) {             sol_log_domain_init_level(SOL_LOG_DOMAIN);             _log_internal_init_once_first = false;         }     } while (0)
#else
#define SOL_LOG_INTERNAL_INIT_ONCE
#endif // #ifdef SOL_LOG_ENABLED

static void
log_init(void)
{
    SOL_LOG_INTERNAL_INIT_ONCE;
}


static struct sol_flow_port_type_in sol_flow_node_type_update_check__in__CHECK = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = check_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_update_check__in__CANCEL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = cancel_check_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_update_check__in__GET_PROGRESS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_progress,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_update_check__out__VERSION = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_update_check__out__SIZE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_update_check__out__PROGRESS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_update_check__out__NEED_UPDATE = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_update_check_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_update_check__in__CHECK;
    if (port < 2)
        return &sol_flow_node_type_update_check__in__CANCEL;
    if (port < 3)
        return &sol_flow_node_type_update_check__in__GET_PROGRESS;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_update_check_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_update_check__out__VERSION;
    if (port < 2)
        return &sol_flow_node_type_update_check__out__SIZE;
    if (port < 3)
        return &sol_flow_node_type_update_check__out__PROGRESS;
    if (port < 4)
        return &sol_flow_node_type_update_check__out__NEED_UPDATE;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_update_check_init_type_internal(void)
{
    if (sol_flow_node_type_update_check__in__CHECK.packet_type == NULL) {
        sol_flow_node_type_update_check__in__CHECK.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_update_check__in__CANCEL.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_update_check__in__GET_PROGRESS.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_update_check__out__VERSION.packet_type = SOL_FLOW_PACKET_TYPE_STRING;
        sol_flow_node_type_update_check__out__SIZE.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_update_check__out__PROGRESS.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
        sol_flow_node_type_update_check__out__NEED_UPDATE.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_update_check_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "update/check",
    .category = "system/update",
    .symbol = "SOL_FLOW_NODE_TYPE_UPDATE_CHECK",
    .options_symbol = "sol_flow_node_type_update_check_options",
    .description = "Check if there's update available. How check is performed depends on current update module implementation. Outputs update file version and its size.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "CHECK",
            .description="Start a check on current URL to see if update is available.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "CANCEL",
            .description="Cancel an ongoing check operation. No output packets shall be sent, unless a new CHECK is issued",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET_PROGRESS",
            .description="Causes task current progress to be sent to PROGRESS port",
            .data_type="any",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "VERSION",
            .description="Update version.",
            .data_type="string",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "SIZE",
            .description="Update size, in bytes.",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "PROGRESS",
            .description="Current progress of task, a number between 0 and 100. An output of -1 indicates that current progress is not available",
            .data_type="int",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "NEED_UPDATE",
            .description="If update version is different from current version, outputs true, false otherwise. Note that this behaviour is backend defined: if an update module also downgrades, it may output true here also.",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=3,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct update_node_type sol_flow_node_type_update_check = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct update_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_update_check_init_type_internal,
    .open = NULL,
    .close = common_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_update_check_get_port_in_internal,
    .ports_out_count = 4,
    .get_port_out = sol_flow_node_type_update_check_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_update_check_description,
#endif
},
    .progress_port = SOL_FLOW_NODE_TYPE_UPDATE_CHECK__OUT__PROGRESS,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UPDATE_CHECK = &sol_flow_node_type_update_check.base;

static struct sol_flow_port_type_in sol_flow_node_type_update_fetch__in__FETCH = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = fetch_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_update_fetch__in__CANCEL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = cancel_fetch_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_update_fetch__in__GET_PROGRESS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_progress,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_update_fetch__out__SUCCESS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_update_fetch__out__PROGRESS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_update_fetch_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_update_fetch__in__FETCH;
    if (port < 2)
        return &sol_flow_node_type_update_fetch__in__CANCEL;
    if (port < 3)
        return &sol_flow_node_type_update_fetch__in__GET_PROGRESS;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_update_fetch_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_update_fetch__out__SUCCESS;
    if (port < 2)
        return &sol_flow_node_type_update_fetch__out__PROGRESS;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_update_fetch_init_type_internal(void)
{
    if (sol_flow_node_type_update_fetch__in__FETCH.packet_type == NULL) {
        sol_flow_node_type_update_fetch__in__FETCH.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_update_fetch__in__CANCEL.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_update_fetch__in__GET_PROGRESS.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_update_fetch__out__SUCCESS.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_update_fetch__out__PROGRESS.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_update_fetch_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "update/fetch",
    .category = "system/update",
    .symbol = "SOL_FLOW_NODE_TYPE_UPDATE_FETCH",
    .options_symbol = "sol_flow_node_type_update_fetch_options",
    .description = "Fetch an update. If eveything goes well, it should output true on port SUCCESS.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "FETCH",
            .description="Start fetching update.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "CANCEL",
            .description="Cancel an ongoing fetch operation. No output packets shall be sent, unless a new FETCH is issued",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET_PROGRESS",
            .description="Causes task current progress to be sent to PROGRESS port",
            .data_type="any",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "SUCCESS",
            .description="If FETCH was successfully completed",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "PROGRESS",
            .description="Current progress of task, a number between 0 and 100. An output of -1 indicates that current progress is not available",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct update_node_type sol_flow_node_type_update_fetch = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct update_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_update_fetch_init_type_internal,
    .open = NULL,
    .close = common_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_update_fetch_get_port_in_internal,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_update_fetch_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_update_fetch_description,
#endif
},
    .progress_port = SOL_FLOW_NODE_TYPE_UPDATE_FETCH__OUT__PROGRESS,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UPDATE_FETCH = &sol_flow_node_type_update_fetch.base;

static struct sol_flow_port_type_in sol_flow_node_type_update_install__in__CANCEL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = cancel_install_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_update_install__in__GET_PROGRESS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = common_get_progress,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_in sol_flow_node_type_update_install__in__INSTALL = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_IN_API_VERSION, )
    .process = install_process,
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_update_install__out__SUCCESS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};

static struct sol_flow_port_type_out sol_flow_node_type_update_install__out__PROGRESS = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_PORT_TYPE_OUT_API_VERSION, )
    .connect = NULL,
    .disconnect = NULL,
};
static const struct sol_flow_port_type_in *
sol_flow_node_type_update_install_get_port_in_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_update_install__in__CANCEL;
    if (port < 2)
        return &sol_flow_node_type_update_install__in__GET_PROGRESS;
    if (port < 3)
        return &sol_flow_node_type_update_install__in__INSTALL;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}
static const struct sol_flow_port_type_out *
sol_flow_node_type_update_install_get_port_out_internal(const struct sol_flow_node_type *type, uint16_t port)
{
    if (port < 1)
        return &sol_flow_node_type_update_install__out__SUCCESS;
    if (port < 2)
        return &sol_flow_node_type_update_install__out__PROGRESS;

    return NULL; /* shouldn't happen, but compiler complains otherwise */
}

static void
sol_flow_node_type_update_install_init_type_internal(void)
{
    if (sol_flow_node_type_update_install__in__CANCEL.packet_type == NULL) {
        sol_flow_node_type_update_install__in__CANCEL.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_update_install__in__GET_PROGRESS.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_update_install__in__INSTALL.packet_type = SOL_FLOW_PACKET_TYPE_ANY;
        sol_flow_node_type_update_install__out__SUCCESS.packet_type = SOL_FLOW_PACKET_TYPE_BOOL;
        sol_flow_node_type_update_install__out__PROGRESS.packet_type = SOL_FLOW_PACKET_TYPE_IRANGE;
    }

    log_init();
}

#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
static const struct sol_flow_node_type_description sol_flow_node_type_update_install_description = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_DESCRIPTION_API_VERSION, )
    .name = "update/install",
    .category = "system/update",
    .symbol = "SOL_FLOW_NODE_TYPE_UPDATE_INSTALL",
    .options_symbol = "sol_flow_node_type_update_install_options",
    .description = "Install update. Process of installing update depends on current underlying update module.",
    .author = "Intel Corporation",
    .url = NULL,
    .license = "Apache-2.0",
    .version = "1",
    .ports_in = (const struct sol_flow_port_description *const []){
            &((const struct sol_flow_port_description){
            .name = "CANCEL",
            .description="Cancel an ongoing install operation. Note that this is dependent on current underlying update module and may not be possible.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "GET_PROGRESS",
            .description="Causes task current progress to be sent to PROGRESS port",
            .data_type="any",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
            &((const struct sol_flow_port_description){
            .name = "INSTALL",
            .description="Install update file.",
            .data_type="any",
            .array_size=0,
            .base_port_idx=2,
            .required=false,
        }),
        NULL
    },
    .ports_out = (const struct sol_flow_port_description *const []){
        &((const struct sol_flow_port_description){
            .name = "SUCCESS",
            .description="If install completed successfully, sends true, false otherwise. Note that errors packet may be sent in case of failure",
            .data_type="boolean",
            .array_size=0,
            .base_port_idx=0,
            .required=false,
        }),
        &((const struct sol_flow_port_description){
            .name = "PROGRESS",
            .description="Current progress of task, a number between 0 and 100. An output of -1 indicates that current progress is not available",
            .data_type="int",
            .array_size=0,
            .base_port_idx=1,
            .required=false,
        }),
        NULL
    },
};
#endif

static const struct update_node_type sol_flow_node_type_update_install = {.base = {
    SOL_SET_API_VERSION(.api_version = SOL_FLOW_NODE_TYPE_API_VERSION, )
    .data_size = sizeof(struct update_data),
    .options_size = sizeof(struct sol_flow_node_options),
    .default_options = NULL,
    .init_type = sol_flow_node_type_update_install_init_type_internal,
    .open = NULL,
    .close = common_close,
    .ports_in_count = 3,
    .get_port_in = sol_flow_node_type_update_install_get_port_in_internal,
    .ports_out_count = 2,
    .get_port_out = sol_flow_node_type_update_install_get_port_out_internal,
#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
    .description=&sol_flow_node_type_update_install_description,
#endif
},
    .progress_port = SOL_FLOW_NODE_TYPE_UPDATE_INSTALL__OUT__PROGRESS,
};

SOL_API const struct sol_flow_node_type *SOL_FLOW_NODE_TYPE_UPDATE_INSTALL = &sol_flow_node_type_update_install.base;


#ifdef SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED

#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL

void sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API void
sol_flow_foreach_module_node_type(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#else

const struct sol_flow_node_type *sol_flow_foreach_builtin_node_type_update(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data);

SOL_API const struct sol_flow_node_type *
sol_flow_foreach_builtin_node_type_update(bool (*cb)(void *data, const struct sol_flow_node_type *type), const void *data)

#endif // SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
{
    static const struct sol_flow_node_type **types[] = {
            &SOL_FLOW_NODE_TYPE_UPDATE_CHECK,
            &SOL_FLOW_NODE_TYPE_UPDATE_FETCH,
            &SOL_FLOW_NODE_TYPE_UPDATE_INSTALL,
            NULL
    }, ***itr;

    if (!cb)
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
        return;
#else
        return NULL;
#endif

    for (itr = types; *itr != NULL; itr++) {
        const struct sol_flow_node_type **type = &**itr;
        if ((*type)->init_type)
            (*type)->init_type();
        if (!cb((void *)data, *type))
#ifdef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
            break;
#else
            return *type;
#endif
    }
#ifndef SOL_FLOW_NODE_TYPE_MODULE_EXTERNAL
    return NULL;
#endif
}
#else
#define sol_flow_foreach_module_node_type(cb, data)
#endif // SOL_FLOW_NODE_TYPE_DESCRIPTION_ENABLED
